
#define MCDE_VAL2REG(__reg, __fld, __val) \
	(((__val) << __reg##_##__fld##_SHIFT) & __reg##_##__fld##_MASK)
#define MCDE_REG2VAL(__reg, __fld, __val) \
	(((__val) & __reg##_##__fld##_MASK) >> __reg##_##__fld##_SHIFT)

#define MCDE_CR 0x00000000
#define MCDE_CR_DSICMD2_EN_V1_SHIFT 0
#define MCDE_CR_DSICMD2_EN_V1_MASK 0x00000001
#define MCDE_CR_DSICMD2_EN_V1(__x) \
	MCDE_VAL2REG(MCDE_CR, DSICMD2_EN_V1, __x)
#define MCDE_CR_DSICMD1_EN_V1_SHIFT 1
#define MCDE_CR_DSICMD1_EN_V1_MASK 0x00000002
#define MCDE_CR_DSICMD1_EN_V1(__x) \
	MCDE_VAL2REG(MCDE_CR, DSICMD1_EN_V1, __x)
#define MCDE_CR_DSI0_EN_V3_SHIFT 0
#define MCDE_CR_DSI0_EN_V3_MASK 0x00000001
#define MCDE_CR_DSI0_EN_V3(__x) \
	MCDE_VAL2REG(MCDE_CR, DSI0_EN_V3, __x)
#define MCDE_CR_DSI1_EN_V3_SHIFT 1
#define MCDE_CR_DSI1_EN_V3_MASK 0x00000002
#define MCDE_CR_DSI1_EN_V3(__x) \
	MCDE_VAL2REG(MCDE_CR, DSI1_EN_V3, __x)
#define MCDE_CR_DSICMD0_EN_V1_SHIFT 2
#define MCDE_CR_DSICMD0_EN_V1_MASK 0x00000004
#define MCDE_CR_DSICMD0_EN_V1(__x) \
	MCDE_VAL2REG(MCDE_CR, DSICMD0_EN_V1, __x)
#define MCDE_CR_DSIVID2_EN_V1_SHIFT 3
#define MCDE_CR_DSIVID2_EN_V1_MASK 0x00000008
#define MCDE_CR_DSIVID2_EN_V1(__x) \
	MCDE_VAL2REG(MCDE_CR, DSIVID2_EN_V1, __x)
#define MCDE_CR_DSIVID1_EN_V1_SHIFT 4
#define MCDE_CR_DSIVID1_EN_V1_MASK 0x00000010
#define MCDE_CR_DSIVID1_EN_V1(__x) \
	MCDE_VAL2REG(MCDE_CR, DSIVID1_EN_V1, __x)
#define MCDE_CR_DSIVID0_EN_V1_SHIFT 5
#define MCDE_CR_DSIVID0_EN_V1_MASK 0x00000020
#define MCDE_CR_DSIVID0_EN_V1(__x) \
	MCDE_VAL2REG(MCDE_CR, DSIVID0_EN_V1, __x)
#define MCDE_CR_DBIC1_EN_V1_SHIFT 6
#define MCDE_CR_DBIC1_EN_V1_MASK 0x00000040
#define MCDE_CR_DBIC1_EN_V1(__x) \
	MCDE_VAL2REG(MCDE_CR, DBIC1_EN_V1, __x)
#define MCDE_CR_DBIC0_EN_V1_SHIFT 7
#define MCDE_CR_DBIC0_EN_V1_MASK 0x00000080
#define MCDE_CR_DBIC0_EN_V1(__x) \
	MCDE_VAL2REG(MCDE_CR, DBIC0_EN_V1, __x)
#define MCDE_CR_DBI_EN_V3_SHIFT 7
#define MCDE_CR_DBI_EN_V3_MASK 0x00000080
#define MCDE_CR_DBI_EN_V3(__x) \
	MCDE_VAL2REG(MCDE_CR, DBI_EN_V3, __x)
#define MCDE_CR_DPIB_EN_V1_SHIFT 8
#define MCDE_CR_DPIB_EN_V1_MASK 0x00000100
#define MCDE_CR_DPIB_EN_V1(__x) \
	MCDE_VAL2REG(MCDE_CR, DPIB_EN_V1, __x)
#define MCDE_CR_DPIA_EN_V1_SHIFT 9
#define MCDE_CR_DPIA_EN_V1_MASK 0x00000200
#define MCDE_CR_DPIA_EN_V1(__x) \
	MCDE_VAL2REG(MCDE_CR, DPIA_EN_V1, __x)
#define MCDE_CR_DPI_EN_V3_SHIFT 9
#define MCDE_CR_DPI_EN_V3_MASK 0x00000200
#define MCDE_CR_DPI_EN_V3(__x) \
	MCDE_VAL2REG(MCDE_CR, DPI_EN_V3, __x)
#define MCDE_CR_IFIFOCTRLEN_SHIFT 15
#define MCDE_CR_IFIFOCTRLEN_MASK 0x00008000
#define MCDE_CR_IFIFOCTRLEN(__x) \
	MCDE_VAL2REG(MCDE_CR, IFIFOCTRLEN, __x)
#define MCDE_CR_F01MUX_V1_SHIFT 16
#define MCDE_CR_F01MUX_V1_MASK 0x00010000
#define MCDE_CR_F01MUX_V1(__x) \
	MCDE_VAL2REG(MCDE_CR, F01MUX_V1, __x)
#define MCDE_CR_FABMUX_V1_SHIFT 17
#define MCDE_CR_FABMUX_V1_MASK 0x00020000
#define MCDE_CR_FABMUX_V1(__x) \
	MCDE_VAL2REG(MCDE_CR, FABMUX_V1, __x)
#define MCDE_CR_AUTOCLKG_EN_SHIFT 30
#define MCDE_CR_AUTOCLKG_EN_MASK 0x40000000
#define MCDE_CR_AUTOCLKG_EN(__x) \
	MCDE_VAL2REG(MCDE_CR, AUTOCLKG_EN, __x)
#define MCDE_CR_MCDEEN_SHIFT 31
#define MCDE_CR_MCDEEN_MASK 0x80000000
#define MCDE_CR_MCDEEN(__x) \
	MCDE_VAL2REG(MCDE_CR, MCDEEN, __x)
#define MCDE_CONF0 0x00000004
#define MCDE_CONF0_SYNCMUX0_SHIFT 0
#define MCDE_CONF0_SYNCMUX0_MASK 0x00000001
#define MCDE_CONF0_SYNCMUX0(__x) \
	MCDE_VAL2REG(MCDE_CONF0, SYNCMUX0, __x)
#define MCDE_CONF0_SYNCMUX1_SHIFT 1
#define MCDE_CONF0_SYNCMUX1_MASK 0x00000002
#define MCDE_CONF0_SYNCMUX1(__x) \
	MCDE_VAL2REG(MCDE_CONF0, SYNCMUX1, __x)
#define MCDE_CONF0_SYNCMUX2_SHIFT 2
#define MCDE_CONF0_SYNCMUX2_MASK 0x00000004
#define MCDE_CONF0_SYNCMUX2(__x) \
	MCDE_VAL2REG(MCDE_CONF0, SYNCMUX2, __x)
#define MCDE_CONF0_SYNCMUX3_SHIFT 3
#define MCDE_CONF0_SYNCMUX3_MASK 0x00000008
#define MCDE_CONF0_SYNCMUX3(__x) \
	MCDE_VAL2REG(MCDE_CONF0, SYNCMUX3, __x)
#define MCDE_CONF0_SYNCMUX4_SHIFT 4
#define MCDE_CONF0_SYNCMUX4_MASK 0x00000010
#define MCDE_CONF0_SYNCMUX4(__x) \
	MCDE_VAL2REG(MCDE_CONF0, SYNCMUX4, __x)
#define MCDE_CONF0_SYNCMUX5_SHIFT 5
#define MCDE_CONF0_SYNCMUX5_MASK 0x00000020
#define MCDE_CONF0_SYNCMUX5(__x) \
	MCDE_VAL2REG(MCDE_CONF0, SYNCMUX5, __x)
#define MCDE_CONF0_SYNCMUX6_SHIFT 6
#define MCDE_CONF0_SYNCMUX6_MASK 0x00000040
#define MCDE_CONF0_SYNCMUX6(__x) \
	MCDE_VAL2REG(MCDE_CONF0, SYNCMUX6, __x)
#define MCDE_CONF0_SYNCMUX7_SHIFT 7
#define MCDE_CONF0_SYNCMUX7_MASK 0x00000080
#define MCDE_CONF0_SYNCMUX7(__x) \
	MCDE_VAL2REG(MCDE_CONF0, SYNCMUX7, __x)
#define MCDE_CONF0_SWAP_A_C0_V1_SHIFT 8
#define MCDE_CONF0_SWAP_A_C0_V1_MASK 0x00000100
#define MCDE_CONF0_SWAP_A_C0_V1(__x) \
	MCDE_VAL2REG(MCDE_CONF0, SWAP_A_C0_V1, __x)
#define MCDE_CONF0_SWAP_B_C1_V1_SHIFT 9
#define MCDE_CONF0_SWAP_B_C1_V1_MASK 0x00000200
#define MCDE_CONF0_SWAP_B_C1_V1(__x) \
	MCDE_VAL2REG(MCDE_CONF0, SWAP_B_C1_V1, __x)
#define MCDE_CONF0_FSYNCTRLA_V1_SHIFT 10
#define MCDE_CONF0_FSYNCTRLA_V1_MASK 0x00000400
#define MCDE_CONF0_FSYNCTRLA_V1(__x) \
	MCDE_VAL2REG(MCDE_CONF0, FSYNCTRLA_V1, __x)
#define MCDE_CONF0_FSYNCTRLB_V1_SHIFT 11
#define MCDE_CONF0_FSYNCTRLB_V1_MASK 0x00000800
#define MCDE_CONF0_FSYNCTRLB_V1(__x) \
	MCDE_VAL2REG(MCDE_CONF0, FSYNCTRLB_V1, __x)
#define MCDE_CONF0_IFIFOCTRLWTRMRKLVL_SHIFT 12
#define MCDE_CONF0_IFIFOCTRLWTRMRKLVL_MASK 0x00007000
#define MCDE_CONF0_IFIFOCTRLWTRMRKLVL(__x) \
	MCDE_VAL2REG(MCDE_CONF0, IFIFOCTRLWTRMRKLVL, __x)
#define MCDE_CONF0_OUTMUX0_SHIFT 16
#define MCDE_CONF0_OUTMUX0_MASK 0x00070000
#define MCDE_CONF0_OUTMUX0(__x) \
	MCDE_VAL2REG(MCDE_CONF0, OUTMUX0, __x)
#define MCDE_CONF0_OUTMUX1_SHIFT 19
#define MCDE_CONF0_OUTMUX1_MASK 0x00380000
#define MCDE_CONF0_OUTMUX1(__x) \
	MCDE_VAL2REG(MCDE_CONF0, OUTMUX1, __x)
#define MCDE_CONF0_OUTMUX2_SHIFT 22
#define MCDE_CONF0_OUTMUX2_MASK 0x01C00000
#define MCDE_CONF0_OUTMUX2(__x) \
	MCDE_VAL2REG(MCDE_CONF0, OUTMUX2, __x)
#define MCDE_CONF0_OUTMUX3_SHIFT 25
#define MCDE_CONF0_OUTMUX3_MASK 0x0E000000
#define MCDE_CONF0_OUTMUX3(__x) \
	MCDE_VAL2REG(MCDE_CONF0, OUTMUX3, __x)
#define MCDE_CONF0_OUTMUX4_SHIFT 28
#define MCDE_CONF0_OUTMUX4_MASK 0x70000000
#define MCDE_CONF0_OUTMUX4(__x) \
	MCDE_VAL2REG(MCDE_CONF0, OUTMUX4, __x)
#define MCDE_SSP 0x00000008
#define MCDE_SSP_SSPDATA_SHIFT 0
#define MCDE_SSP_SSPDATA_MASK 0x000000FF
#define MCDE_SSP_SSPDATA(__x) \
	MCDE_VAL2REG(MCDE_SSP, SSPDATA, __x)
#define MCDE_SSP_SSPCMD_SHIFT 8
#define MCDE_SSP_SSPCMD_MASK 0x00000100
#define MCDE_SSP_SSPCMD_DATA 0
#define MCDE_SSP_SSPCMD_COMMAND 1
#define MCDE_SSP_SSPCMD_ENUM(__x) \
	MCDE_VAL2REG(MCDE_SSP, SSPCMD, MCDE_SSP_SSPCMD_##__x)
#define MCDE_SSP_SSPCMD(__x) \
	MCDE_VAL2REG(MCDE_SSP, SSPCMD, __x)
#define MCDE_SSP_SSPEN_SHIFT 16
#define MCDE_SSP_SSPEN_MASK 0x00010000
#define MCDE_SSP_SSPEN(__x) \
	MCDE_VAL2REG(MCDE_SSP, SSPEN, __x)
#define MCDE_AIS 0x00000100
#define MCDE_AIS_MCDEPPI_SHIFT 0
#define MCDE_AIS_MCDEPPI_MASK 0x00000001
#define MCDE_AIS_MCDEPPI(__x) \
	MCDE_VAL2REG(MCDE_AIS, MCDEPPI, __x)
#define MCDE_AIS_MCDEOVLI_SHIFT 1
#define MCDE_AIS_MCDEOVLI_MASK 0x00000002
#define MCDE_AIS_MCDEOVLI(__x) \
	MCDE_VAL2REG(MCDE_AIS, MCDEOVLI, __x)
#define MCDE_AIS_MCDECHNLI_SHIFT 2
#define MCDE_AIS_MCDECHNLI_MASK 0x00000004
#define MCDE_AIS_MCDECHNLI(__x) \
	MCDE_VAL2REG(MCDE_AIS, MCDECHNLI, __x)
#define MCDE_AIS_MCDEERRI_SHIFT 3
#define MCDE_AIS_MCDEERRI_MASK 0x00000008
#define MCDE_AIS_MCDEERRI(__x) \
	MCDE_VAL2REG(MCDE_AIS, MCDEERRI, __x)
#define MCDE_AIS_DSI0AI_SHIFT 4
#define MCDE_AIS_DSI0AI_MASK 0x00000010
#define MCDE_AIS_DSI0AI(__x) \
	MCDE_VAL2REG(MCDE_AIS, DSI0AI, __x)
#define MCDE_AIS_DSI1AI_SHIFT 5
#define MCDE_AIS_DSI1AI_MASK 0x00000020
#define MCDE_AIS_DSI1AI(__x) \
	MCDE_VAL2REG(MCDE_AIS, DSI1AI, __x)
#define MCDE_AIS_DSI2AI_SHIFT 6
#define MCDE_AIS_DSI2AI_MASK 0x00000040
#define MCDE_AIS_DSI2AI(__x) \
	MCDE_VAL2REG(MCDE_AIS, DSI2AI, __x)
#define MCDE_IMSCPP 0x00000104
#define MCDE_IMSCPP_VCMPAIM_SHIFT 0
#define MCDE_IMSCPP_VCMPAIM_MASK 0x00000001
#define MCDE_IMSCPP_VCMPAIM(__x) \
	MCDE_VAL2REG(MCDE_IMSCPP, VCMPAIM, __x)
#define MCDE_IMSCPP_VCMPBIM_SHIFT 1
#define MCDE_IMSCPP_VCMPBIM_MASK 0x00000002
#define MCDE_IMSCPP_VCMPBIM(__x) \
	MCDE_VAL2REG(MCDE_IMSCPP, VCMPBIM, __x)
#define MCDE_IMSCPP_VSCC0IM_SHIFT 2
#define MCDE_IMSCPP_VSCC0IM_MASK 0x00000004
#define MCDE_IMSCPP_VSCC0IM(__x) \
	MCDE_VAL2REG(MCDE_IMSCPP, VSCC0IM, __x)
#define MCDE_IMSCPP_VSCC1IM_SHIFT 3
#define MCDE_IMSCPP_VSCC1IM_MASK 0x00000008
#define MCDE_IMSCPP_VSCC1IM(__x) \
	MCDE_VAL2REG(MCDE_IMSCPP, VSCC1IM, __x)
#define MCDE_IMSCPP_VCMPC0IM_SHIFT 4
#define MCDE_IMSCPP_VCMPC0IM_MASK 0x00000010
#define MCDE_IMSCPP_VCMPC0IM(__x) \
	MCDE_VAL2REG(MCDE_IMSCPP, VCMPC0IM, __x)
#define MCDE_IMSCPP_VCMPC1IM_SHIFT 5
#define MCDE_IMSCPP_VCMPC1IM_MASK 0x00000020
#define MCDE_IMSCPP_VCMPC1IM(__x) \
	MCDE_VAL2REG(MCDE_IMSCPP, VCMPC1IM, __x)
#define MCDE_IMSCPP_ROTFDIM_B_SHIFT 6
#define MCDE_IMSCPP_ROTFDIM_B_MASK 0x00000040
#define MCDE_IMSCPP_ROTFDIM_B(__x) \
	MCDE_VAL2REG(MCDE_IMSCPP, ROTFDIM_B, __x)
#define MCDE_IMSCPP_ROTFDIM_A_SHIFT 7
#define MCDE_IMSCPP_ROTFDIM_A_MASK 0x00000080
#define MCDE_IMSCPP_ROTFDIM_A(__x) \
	MCDE_VAL2REG(MCDE_IMSCPP, ROTFDIM_A, __x)
#define MCDE_IMSCOVL 0x00000108
#define MCDE_IMSCOVL_OVLRDIM_SHIFT 0
#define MCDE_IMSCOVL_OVLRDIM_MASK 0x0000FFFF
#define MCDE_IMSCOVL_OVLRDIM(__x) \
	MCDE_VAL2REG(MCDE_IMSCOVL, OVLRDIM, __x)
#define MCDE_IMSCOVL_OVLFDIM_SHIFT 16
#define MCDE_IMSCOVL_OVLFDIM_MASK 0xFFFF0000
#define MCDE_IMSCOVL_OVLFDIM(__x) \
	MCDE_VAL2REG(MCDE_IMSCOVL, OVLFDIM, __x)
#define MCDE_IMSCCHNL 0x0000010C
#define MCDE_IMSCCHNL_CHNLRDIM_SHIFT 0
#define MCDE_IMSCCHNL_CHNLRDIM_MASK 0x0000FFFF
#define MCDE_IMSCCHNL_CHNLRDIM(__x) \
	MCDE_VAL2REG(MCDE_IMSCCHNL, CHNLRDIM, __x)
#define MCDE_IMSCCHNL_CHNLAIM_SHIFT 16
#define MCDE_IMSCCHNL_CHNLAIM_MASK 0xFFFF0000
#define MCDE_IMSCCHNL_CHNLAIM(__x) \
	MCDE_VAL2REG(MCDE_IMSCCHNL, CHNLAIM, __x)
#define MCDE_IMSCERR 0x00000110
#define MCDE_IMSCERR_FUAIM_SHIFT 0
#define MCDE_IMSCERR_FUAIM_MASK 0x00000001
#define MCDE_IMSCERR_FUAIM(__x) \
	MCDE_VAL2REG(MCDE_IMSCERR, FUAIM, __x)
#define MCDE_IMSCERR_FUBIM_SHIFT 1
#define MCDE_IMSCERR_FUBIM_MASK 0x00000002
#define MCDE_IMSCERR_FUBIM(__x) \
	MCDE_VAL2REG(MCDE_IMSCERR, FUBIM, __x)
#define MCDE_IMSCERR_SCHBLCKDIM_SHIFT 2
#define MCDE_IMSCERR_SCHBLCKDIM_MASK 0x00000004
#define MCDE_IMSCERR_SCHBLCKDIM(__x) \
	MCDE_VAL2REG(MCDE_IMSCERR, SCHBLCKDIM, __x)
#define MCDE_IMSCERR_ROTAFEIM_WRITE_SHIFT 3
#define MCDE_IMSCERR_ROTAFEIM_WRITE_MASK 0x00000008
#define MCDE_IMSCERR_ROTAFEIM_WRITE(__x) \
	MCDE_VAL2REG(MCDE_IMSCERR, ROTAFEIM_WRITE, __x)
#define MCDE_IMSCERR_ROTAFEIM_READ_SHIFT 4
#define MCDE_IMSCERR_ROTAFEIM_READ_MASK 0x00000010
#define MCDE_IMSCERR_ROTAFEIM_READ(__x) \
	MCDE_VAL2REG(MCDE_IMSCERR, ROTAFEIM_READ, __x)
#define MCDE_IMSCERR_ROTBFEIM_WRITE_SHIFT 5
#define MCDE_IMSCERR_ROTBFEIM_WRITE_MASK 0x00000020
#define MCDE_IMSCERR_ROTBFEIM_WRITE(__x) \
	MCDE_VAL2REG(MCDE_IMSCERR, ROTBFEIM_WRITE, __x)
#define MCDE_IMSCERR_ROTBFEIM_READ_SHIFT 6
#define MCDE_IMSCERR_ROTBFEIM_READ_MASK 0x00000040
#define MCDE_IMSCERR_ROTBFEIM_READ(__x) \
	MCDE_VAL2REG(MCDE_IMSCERR, ROTBFEIM_READ, __x)
#define MCDE_IMSCERR_FUC0IM_SHIFT 7
#define MCDE_IMSCERR_FUC0IM_MASK 0x00000080
#define MCDE_IMSCERR_FUC0IM(__x) \
	MCDE_VAL2REG(MCDE_IMSCERR, FUC0IM, __x)
#define MCDE_IMSCERR_FUC1IM_SHIFT 8
#define MCDE_IMSCERR_FUC1IM_MASK 0x00000100
#define MCDE_IMSCERR_FUC1IM(__x) \
	MCDE_VAL2REG(MCDE_IMSCERR, FUC1IM, __x)
#define MCDE_IMSCERR_OVLFERRIM_SHIFT 16
#define MCDE_IMSCERR_OVLFERRIM_MASK 0xFFFF0000
#define MCDE_IMSCERR_OVLFERRIM(__x) \
	MCDE_VAL2REG(MCDE_IMSCERR, OVLFERRIM, __x)
#define MCDE_RISPP 0x00000114
#define MCDE_RISPP_VCMPARIS_SHIFT 0
#define MCDE_RISPP_VCMPARIS_MASK 0x00000001
#define MCDE_RISPP_VCMPARIS(__x) \
	MCDE_VAL2REG(MCDE_RISPP, VCMPARIS, __x)
#define MCDE_RISPP_VCMPBRIS_SHIFT 1
#define MCDE_RISPP_VCMPBRIS_MASK 0x00000002
#define MCDE_RISPP_VCMPBRIS(__x) \
	MCDE_VAL2REG(MCDE_RISPP, VCMPBRIS, __x)
#define MCDE_RISPP_VSCC0RIS_SHIFT 2
#define MCDE_RISPP_VSCC0RIS_MASK 0x00000004
#define MCDE_RISPP_VSCC0RIS(__x) \
	MCDE_VAL2REG(MCDE_RISPP, VSCC0RIS, __x)
#define MCDE_RISPP_VSCC1RIS_SHIFT 3
#define MCDE_RISPP_VSCC1RIS_MASK 0x00000008
#define MCDE_RISPP_VSCC1RIS(__x) \
	MCDE_VAL2REG(MCDE_RISPP, VSCC1RIS, __x)
#define MCDE_RISPP_VCMPC0RIS_SHIFT 4
#define MCDE_RISPP_VCMPC0RIS_MASK 0x00000010
#define MCDE_RISPP_VCMPC0RIS(__x) \
	MCDE_VAL2REG(MCDE_RISPP, VCMPC0RIS, __x)
#define MCDE_RISPP_VCMPC1RIS_SHIFT 5
#define MCDE_RISPP_VCMPC1RIS_MASK 0x00000020
#define MCDE_RISPP_VCMPC1RIS(__x) \
	MCDE_VAL2REG(MCDE_RISPP, VCMPC1RIS, __x)
#define MCDE_RISPP_ROTFDRIS_B_SHIFT 6
#define MCDE_RISPP_ROTFDRIS_B_MASK 0x00000040
#define MCDE_RISPP_ROTFDRIS_B(__x) \
	MCDE_VAL2REG(MCDE_RISPP, ROTFDRIS_B, __x)
#define MCDE_RISPP_ROTFDRIS_A_SHIFT 7
#define MCDE_RISPP_ROTFDRIS_A_MASK 0x00000080
#define MCDE_RISPP_ROTFDRIS_A(__x) \
	MCDE_VAL2REG(MCDE_RISPP, ROTFDRIS_A, __x)
#define MCDE_RISOVL 0x00000118
#define MCDE_RISOVL_OVLRDRIS_SHIFT 0
#define MCDE_RISOVL_OVLRDRIS_MASK 0x0000FFFF
#define MCDE_RISOVL_OVLRDRIS(__x) \
	MCDE_VAL2REG(MCDE_RISOVL, OVLRDRIS, __x)
#define MCDE_RISOVL_OVLFDRIS_SHIFT 16
#define MCDE_RISOVL_OVLFDRIS_MASK 0xFFFF0000
#define MCDE_RISOVL_OVLFDRIS(__x) \
	MCDE_VAL2REG(MCDE_RISOVL, OVLFDRIS, __x)
#define MCDE_RISCHNL 0x0000011C
#define MCDE_RISCHNL_CHNLRDRIS_SHIFT 0
#define MCDE_RISCHNL_CHNLRDRIS_MASK 0x0000FFFF
#define MCDE_RISCHNL_CHNLRDRIS(__x) \
	MCDE_VAL2REG(MCDE_RISCHNL, CHNLRDRIS, __x)
#define MCDE_RISCHNL_CHNLARIS_SHIFT 16
#define MCDE_RISCHNL_CHNLARIS_MASK 0xFFFF0000
#define MCDE_RISCHNL_CHNLARIS(__x) \
	MCDE_VAL2REG(MCDE_RISCHNL, CHNLARIS, __x)
#define MCDE_RISERR 0x00000120
#define MCDE_RISERR_FUARIS_SHIFT 0
#define MCDE_RISERR_FUARIS_MASK 0x00000001
#define MCDE_RISERR_FUARIS(__x) \
	MCDE_VAL2REG(MCDE_RISERR, FUARIS, __x)
#define MCDE_RISERR_FUBRIS_SHIFT 1
#define MCDE_RISERR_FUBRIS_MASK 0x00000002
#define MCDE_RISERR_FUBRIS(__x) \
	MCDE_VAL2REG(MCDE_RISERR, FUBRIS, __x)
#define MCDE_RISERR_SCHBLCKDRIS_SHIFT 2
#define MCDE_RISERR_SCHBLCKDRIS_MASK 0x00000004
#define MCDE_RISERR_SCHBLCKDRIS(__x) \
	MCDE_VAL2REG(MCDE_RISERR, SCHBLCKDRIS, __x)
#define MCDE_RISERR_ROTAFERIS_WRITE_SHIFT 3
#define MCDE_RISERR_ROTAFERIS_WRITE_MASK 0x00000008
#define MCDE_RISERR_ROTAFERIS_WRITE(__x) \
	MCDE_VAL2REG(MCDE_RISERR, ROTAFERIS_WRITE, __x)
#define MCDE_RISERR_ROTAFERIS_READ_SHIFT 4
#define MCDE_RISERR_ROTAFERIS_READ_MASK 0x00000010
#define MCDE_RISERR_ROTAFERIS_READ(__x) \
	MCDE_VAL2REG(MCDE_RISERR, ROTAFERIS_READ, __x)
#define MCDE_RISERR_ROTBFERIS_WRITE_SHIFT 5
#define MCDE_RISERR_ROTBFERIS_WRITE_MASK 0x00000020
#define MCDE_RISERR_ROTBFERIS_WRITE(__x) \
	MCDE_VAL2REG(MCDE_RISERR, ROTBFERIS_WRITE, __x)
#define MCDE_RISERR_ROTBFERIS_READ_SHIFT 6
#define MCDE_RISERR_ROTBFERIS_READ_MASK 0x00000040
#define MCDE_RISERR_ROTBFERIS_READ(__x) \
	MCDE_VAL2REG(MCDE_RISERR, ROTBFERIS_READ, __x)
#define MCDE_RISERR_FUC0RIS_SHIFT 7
#define MCDE_RISERR_FUC0RIS_MASK 0x00000080
#define MCDE_RISERR_FUC0RIS(__x) \
	MCDE_VAL2REG(MCDE_RISERR, FUC0RIS, __x)
#define MCDE_RISERR_FUC1RIS_SHIFT 8
#define MCDE_RISERR_FUC1RIS_MASK 0x00000100
#define MCDE_RISERR_FUC1RIS(__x) \
	MCDE_VAL2REG(MCDE_RISERR, FUC1RIS, __x)
#define MCDE_RISERR_OVLFERRRIS_SHIFT 16
#define MCDE_RISERR_OVLFERRRIS_MASK 0xFFFF0000
#define MCDE_RISERR_OVLFERRRIS(__x) \
	MCDE_VAL2REG(MCDE_RISERR, OVLFERRRIS, __x)
#define MCDE_MISPP 0x00000124
#define MCDE_MISPP_VCMPAMIS_SHIFT 0
#define MCDE_MISPP_VCMPAMIS_MASK 0x00000001
#define MCDE_MISPP_VCMPAMIS(__x) \
	MCDE_VAL2REG(MCDE_MISPP, VCMPAMIS, __x)
#define MCDE_MISPP_VCMPBMIS_SHIFT 1
#define MCDE_MISPP_VCMPBMIS_MASK 0x00000002
#define MCDE_MISPP_VCMPBMIS(__x) \
	MCDE_VAL2REG(MCDE_MISPP, VCMPBMIS, __x)
#define MCDE_MISPP_VSCC0MIS_SHIFT 2
#define MCDE_MISPP_VSCC0MIS_MASK 0x00000004
#define MCDE_MISPP_VSCC0MIS(__x) \
	MCDE_VAL2REG(MCDE_MISPP, VSCC0MIS, __x)
#define MCDE_MISPP_VSCC1MIS_SHIFT 3
#define MCDE_MISPP_VSCC1MIS_MASK 0x00000008
#define MCDE_MISPP_VSCC1MIS(__x) \
	MCDE_VAL2REG(MCDE_MISPP, VSCC1MIS, __x)
#define MCDE_MISPP_VCMPC0MIS_SHIFT 4
#define MCDE_MISPP_VCMPC0MIS_MASK 0x00000010
#define MCDE_MISPP_VCMPC0MIS(__x) \
	MCDE_VAL2REG(MCDE_MISPP, VCMPC0MIS, __x)
#define MCDE_MISPP_VCMPC1MIS_SHIFT 5
#define MCDE_MISPP_VCMPC1MIS_MASK 0x00000020
#define MCDE_MISPP_VCMPC1MIS(__x) \
	MCDE_VAL2REG(MCDE_MISPP, VCMPC1MIS, __x)
#define MCDE_MISPP_ROTFDMIS_A_SHIFT 6
#define MCDE_MISPP_ROTFDMIS_A_MASK 0x00000040
#define MCDE_MISPP_ROTFDMIS_A(__x) \
	MCDE_VAL2REG(MCDE_MISPP, ROTFDMIS_A, __x)
#define MCDE_MISPP_ROTFDMIS_B_SHIFT 7
#define MCDE_MISPP_ROTFDMIS_B_MASK 0x00000080
#define MCDE_MISPP_ROTFDMIS_B(__x) \
	MCDE_VAL2REG(MCDE_MISPP, ROTFDMIS_B, __x)
#define MCDE_MISOVL 0x00000128
#define MCDE_MISOVL_OVLRDMIS_SHIFT 0
#define MCDE_MISOVL_OVLRDMIS_MASK 0x0000FFFF
#define MCDE_MISOVL_OVLRDMIS(__x) \
	MCDE_VAL2REG(MCDE_MISOVL, OVLRDMIS, __x)
#define MCDE_MISOVL_OVLFDMIS_SHIFT 16
#define MCDE_MISOVL_OVLFDMIS_MASK 0xFFFF0000
#define MCDE_MISOVL_OVLFDMIS(__x) \
	MCDE_VAL2REG(MCDE_MISOVL, OVLFDMIS, __x)
#define MCDE_MISCHNL 0x0000012C
#define MCDE_MISCHNL_CHNLRDMIS_SHIFT 0
#define MCDE_MISCHNL_CHNLRDMIS_MASK 0x0000FFFF
#define MCDE_MISCHNL_CHNLRDMIS(__x) \
	MCDE_VAL2REG(MCDE_MISCHNL, CHNLRDMIS, __x)
#define MCDE_MISCHNL_CHNLAMIS_SHIFT 16
#define MCDE_MISCHNL_CHNLAMIS_MASK 0xFFFF0000
#define MCDE_MISCHNL_CHNLAMIS(__x) \
	MCDE_VAL2REG(MCDE_MISCHNL, CHNLAMIS, __x)
#define MCDE_MISERR 0x00000130
#define MCDE_MISERR_FUAMIS_SHIFT 0
#define MCDE_MISERR_FUAMIS_MASK 0x00000001
#define MCDE_MISERR_FUAMIS(__x) \
	MCDE_VAL2REG(MCDE_MISERR, FUAMIS, __x)
#define MCDE_MISERR_FUBMIS_SHIFT 1
#define MCDE_MISERR_FUBMIS_MASK 0x00000002
#define MCDE_MISERR_FUBMIS(__x) \
	MCDE_VAL2REG(MCDE_MISERR, FUBMIS, __x)
#define MCDE_MISERR_SCHBLCKDMIS_SHIFT 2
#define MCDE_MISERR_SCHBLCKDMIS_MASK 0x00000004
#define MCDE_MISERR_SCHBLCKDMIS(__x) \
	MCDE_VAL2REG(MCDE_MISERR, SCHBLCKDMIS, __x)
#define MCDE_MISERR_ROTAFEMIS_WRITE_SHIFT 3
#define MCDE_MISERR_ROTAFEMIS_WRITE_MASK 0x00000008
#define MCDE_MISERR_ROTAFEMIS_WRITE(__x) \
	MCDE_VAL2REG(MCDE_MISERR, ROTAFEMIS_WRITE, __x)
#define MCDE_MISERR_ROTAFEMIS_READ_SHIFT 4
#define MCDE_MISERR_ROTAFEMIS_READ_MASK 0x00000010
#define MCDE_MISERR_ROTAFEMIS_READ(__x) \
	MCDE_VAL2REG(MCDE_MISERR, ROTAFEMIS_READ, __x)
#define MCDE_MISERR_ROTBFEMIS_WRITE_SHIFT 5
#define MCDE_MISERR_ROTBFEMIS_WRITE_MASK 0x00000020
#define MCDE_MISERR_ROTBFEMIS_WRITE(__x) \
	MCDE_VAL2REG(MCDE_MISERR, ROTBFEMIS_WRITE, __x)
#define MCDE_MISERR_ROTBFEMIS_READ_SHIFT 6
#define MCDE_MISERR_ROTBFEMIS_READ_MASK 0x00000040
#define MCDE_MISERR_ROTBFEMIS_READ(__x) \
	MCDE_VAL2REG(MCDE_MISERR, ROTBFEMIS_READ, __x)
#define MCDE_MISERR_FUC0MIS_SHIFT 7
#define MCDE_MISERR_FUC0MIS_MASK 0x00000080
#define MCDE_MISERR_FUC0MIS(__x) \
	MCDE_VAL2REG(MCDE_MISERR, FUC0MIS, __x)
#define MCDE_MISERR_FUC1MIS_SHIFT 8
#define MCDE_MISERR_FUC1MIS_MASK 0x00000100
#define MCDE_MISERR_FUC1MIS(__x) \
	MCDE_VAL2REG(MCDE_MISERR, FUC1MIS, __x)
#define MCDE_MISERR_OVLFERMIS_SHIFT 16
#define MCDE_MISERR_OVLFERMIS_MASK 0xFFFF0000
#define MCDE_MISERR_OVLFERMIS(__x) \
	MCDE_VAL2REG(MCDE_MISERR, OVLFERMIS, __x)
#define MCDE_SISPP 0x00000134
#define MCDE_SISPP_VCMPASIS_SHIFT 0
#define MCDE_SISPP_VCMPASIS_MASK 0x00000001
#define MCDE_SISPP_VCMPASIS(__x) \
	MCDE_VAL2REG(MCDE_SISPP, VCMPASIS, __x)
#define MCDE_SISPP_VCMPBSIS_SHIFT 1
#define MCDE_SISPP_VCMPBSIS_MASK 0x00000002
#define MCDE_SISPP_VCMPBSIS(__x) \
	MCDE_VAL2REG(MCDE_SISPP, VCMPBSIS, __x)
#define MCDE_SISPP_VSCC0SIS_SHIFT 2
#define MCDE_SISPP_VSCC0SIS_MASK 0x00000004
#define MCDE_SISPP_VSCC0SIS(__x) \
	MCDE_VAL2REG(MCDE_SISPP, VSCC0SIS, __x)
#define MCDE_SISPP_VSCC1SIS_SHIFT 3
#define MCDE_SISPP_VSCC1SIS_MASK 0x00000008
#define MCDE_SISPP_VSCC1SIS(__x) \
	MCDE_VAL2REG(MCDE_SISPP, VSCC1SIS, __x)
#define MCDE_SISPP_VCMPC0SIS_SHIFT 4
#define MCDE_SISPP_VCMPC0SIS_MASK 0x00000010
#define MCDE_SISPP_VCMPC0SIS(__x) \
	MCDE_VAL2REG(MCDE_SISPP, VCMPC0SIS, __x)
#define MCDE_SISPP_VCMPC1SIS_SHIFT 5
#define MCDE_SISPP_VCMPC1SIS_MASK 0x00000020
#define MCDE_SISPP_VCMPC1SIS(__x) \
	MCDE_VAL2REG(MCDE_SISPP, VCMPC1SIS, __x)
#define MCDE_SISPP_ROTFDSIS_A_SHIFT 6
#define MCDE_SISPP_ROTFDSIS_A_MASK 0x00000040
#define MCDE_SISPP_ROTFDSIS_A(__x) \
	MCDE_VAL2REG(MCDE_SISPP, ROTFDSIS_A, __x)
#define MCDE_SISPP_ROTFDSIS_B_SHIFT 7
#define MCDE_SISPP_ROTFDSIS_B_MASK 0x00000080
#define MCDE_SISPP_ROTFDSIS_B(__x) \
	MCDE_VAL2REG(MCDE_SISPP, ROTFDSIS_B, __x)
#define MCDE_SISOVL 0x00000138
#define MCDE_SISOVL_OVLRDSIS_SHIFT 0
#define MCDE_SISOVL_OVLRDSIS_MASK 0x0000FFFF
#define MCDE_SISOVL_OVLRDSIS(__x) \
	MCDE_VAL2REG(MCDE_SISOVL, OVLRDSIS, __x)
#define MCDE_SISOVL_OVLFDSIS_SHIFT 16
#define MCDE_SISOVL_OVLFDSIS_MASK 0xFFFF0000
#define MCDE_SISOVL_OVLFDSIS(__x) \
	MCDE_VAL2REG(MCDE_SISOVL, OVLFDSIS, __x)
#define MCDE_SISCHNL 0x0000013C
#define MCDE_SISCHNL_CHNLRDSIS_SHIFT 0
#define MCDE_SISCHNL_CHNLRDSIS_MASK 0x0000FFFF
#define MCDE_SISCHNL_CHNLRDSIS(__x) \
	MCDE_VAL2REG(MCDE_SISCHNL, CHNLRDSIS, __x)
#define MCDE_SISCHNL_CHNLASIS_SHIFT 16
#define MCDE_SISCHNL_CHNLASIS_MASK 0xFFFF0000
#define MCDE_SISCHNL_CHNLASIS(__x) \
	MCDE_VAL2REG(MCDE_SISCHNL, CHNLASIS, __x)
#define MCDE_SISERR 0x00000140
#define MCDE_SISERR_FUASIS_SHIFT 0
#define MCDE_SISERR_FUASIS_MASK 0x00000001
#define MCDE_SISERR_FUASIS(__x) \
	MCDE_VAL2REG(MCDE_SISERR, FUASIS, __x)
#define MCDE_SISERR_FUBSIS_SHIFT 1
#define MCDE_SISERR_FUBSIS_MASK 0x00000002
#define MCDE_SISERR_FUBSIS(__x) \
	MCDE_VAL2REG(MCDE_SISERR, FUBSIS, __x)
#define MCDE_SISERR_SCHBLCKDSIS_SHIFT 2
#define MCDE_SISERR_SCHBLCKDSIS_MASK 0x00000004
#define MCDE_SISERR_SCHBLCKDSIS(__x) \
	MCDE_VAL2REG(MCDE_SISERR, SCHBLCKDSIS, __x)
#define MCDE_SISERR_ROTAFESIS_WRITE_SHIFT 3
#define MCDE_SISERR_ROTAFESIS_WRITE_MASK 0x00000008
#define MCDE_SISERR_ROTAFESIS_WRITE(__x) \
	MCDE_VAL2REG(MCDE_SISERR, ROTAFESIS_WRITE, __x)
#define MCDE_SISERR_ROTAFESIS_READ_SHIFT 4
#define MCDE_SISERR_ROTAFESIS_READ_MASK 0x00000010
#define MCDE_SISERR_ROTAFESIS_READ(__x) \
	MCDE_VAL2REG(MCDE_SISERR, ROTAFESIS_READ, __x)
#define MCDE_SISERR_ROTBFESIS_WRITE_SHIFT 5
#define MCDE_SISERR_ROTBFESIS_WRITE_MASK 0x00000020
#define MCDE_SISERR_ROTBFESIS_WRITE(__x) \
	MCDE_VAL2REG(MCDE_SISERR, ROTBFESIS_WRITE, __x)
#define MCDE_SISERR_ROTBFESIS_READ_SHIFT 6
#define MCDE_SISERR_ROTBFESIS_READ_MASK 0x00000040
#define MCDE_SISERR_ROTBFESIS_READ(__x) \
	MCDE_VAL2REG(MCDE_SISERR, ROTBFESIS_READ, __x)
#define MCDE_SISERR_FUC0SIS_SHIFT 7
#define MCDE_SISERR_FUC0SIS_MASK 0x00000080
#define MCDE_SISERR_FUC0SIS(__x) \
	MCDE_VAL2REG(MCDE_SISERR, FUC0SIS, __x)
#define MCDE_SISERR_FUC1SIS_SHIFT 8
#define MCDE_SISERR_FUC1SIS_MASK 0x00000100
#define MCDE_SISERR_FUC1SIS(__x) \
	MCDE_VAL2REG(MCDE_SISERR, FUC1SIS, __x)
#define MCDE_SISERR_OVLFERSIS_SHIFT 16
#define MCDE_SISERR_OVLFERSIS_MASK 0xFFFF0000
#define MCDE_SISERR_OVLFERSIS(__x) \
	MCDE_VAL2REG(MCDE_SISERR, OVLFERSIS, __x)
#define MCDE_PID 0x000001FC
#define MCDE_PID_METALFIX_VERSION_SHIFT 0
#define MCDE_PID_METALFIX_VERSION_MASK 0x000000FF
#define MCDE_PID_METALFIX_VERSION(__x) \
	MCDE_VAL2REG(MCDE_PID, METALFIX_VERSION, __x)
#define MCDE_PID_DEVELOPMENT_VERSION_SHIFT 8
#define MCDE_PID_DEVELOPMENT_VERSION_MASK 0x0000FF00
#define MCDE_PID_DEVELOPMENT_VERSION(__x) \
	MCDE_VAL2REG(MCDE_PID, DEVELOPMENT_VERSION, __x)
#define MCDE_PID_MINOR_VERSION_SHIFT 16
#define MCDE_PID_MINOR_VERSION_MASK 0x00FF0000
#define MCDE_PID_MINOR_VERSION(__x) \
	MCDE_VAL2REG(MCDE_PID, MINOR_VERSION, __x)
#define MCDE_PID_MAJOR_VERSION_SHIFT 24
#define MCDE_PID_MAJOR_VERSION_MASK 0xFF000000
#define MCDE_PID_MAJOR_VERSION(__x) \
	MCDE_VAL2REG(MCDE_PID, MAJOR_VERSION, __x)
#define MCDE_EXTSRC0A0 0x00000200
#define MCDE_EXTSRC0A0_GROUPOFFSET 0x20
#define MCDE_EXTSRC0A0_BASEADDRESS0_SHIFT 3
#define MCDE_EXTSRC0A0_BASEADDRESS0_MASK 0xFFFFFFF8
#define MCDE_EXTSRC0A0_BASEADDRESS0(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0A0, BASEADDRESS0, __x)
#define MCDE_EXTSRC1A0 0x00000220
#define MCDE_EXTSRC1A0_BASEADDRESS0_SHIFT 3
#define MCDE_EXTSRC1A0_BASEADDRESS0_MASK 0xFFFFFFF8
#define MCDE_EXTSRC1A0_BASEADDRESS0(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1A0, BASEADDRESS0, __x)
#define MCDE_EXTSRC2A0 0x00000240
#define MCDE_EXTSRC2A0_BASEADDRESS0_SHIFT 3
#define MCDE_EXTSRC2A0_BASEADDRESS0_MASK 0xFFFFFFF8
#define MCDE_EXTSRC2A0_BASEADDRESS0(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2A0, BASEADDRESS0, __x)
#define MCDE_EXTSRC3A0 0x00000260
#define MCDE_EXTSRC3A0_BASEADDRESS0_SHIFT 3
#define MCDE_EXTSRC3A0_BASEADDRESS0_MASK 0xFFFFFFF8
#define MCDE_EXTSRC3A0_BASEADDRESS0(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3A0, BASEADDRESS0, __x)
#define MCDE_EXTSRC4A0 0x00000280
#define MCDE_EXTSRC4A0_BASEADDRESS0_SHIFT 3
#define MCDE_EXTSRC4A0_BASEADDRESS0_MASK 0xFFFFFFF8
#define MCDE_EXTSRC4A0_BASEADDRESS0(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4A0, BASEADDRESS0, __x)
#define MCDE_EXTSRC5A0 0x000002A0
#define MCDE_EXTSRC5A0_BASEADDRESS0_SHIFT 3
#define MCDE_EXTSRC5A0_BASEADDRESS0_MASK 0xFFFFFFF8
#define MCDE_EXTSRC5A0_BASEADDRESS0(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5A0, BASEADDRESS0, __x)
#define MCDE_EXTSRC6A0 0x000002C0
#define MCDE_EXTSRC6A0_BASEADDRESS0_SHIFT 3
#define MCDE_EXTSRC6A0_BASEADDRESS0_MASK 0xFFFFFFF8
#define MCDE_EXTSRC6A0_BASEADDRESS0(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6A0, BASEADDRESS0, __x)
#define MCDE_EXTSRC7A0 0x000002E0
#define MCDE_EXTSRC7A0_BASEADDRESS0_SHIFT 3
#define MCDE_EXTSRC7A0_BASEADDRESS0_MASK 0xFFFFFFF8
#define MCDE_EXTSRC7A0_BASEADDRESS0(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7A0, BASEADDRESS0, __x)
#define MCDE_EXTSRC8A0 0x00000300
#define MCDE_EXTSRC8A0_BASEADDRESS0_SHIFT 3
#define MCDE_EXTSRC8A0_BASEADDRESS0_MASK 0xFFFFFFF8
#define MCDE_EXTSRC8A0_BASEADDRESS0(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8A0, BASEADDRESS0, __x)
#define MCDE_EXTSRC9A0 0x00000320
#define MCDE_EXTSRC9A0_BASEADDRESS0_SHIFT 3
#define MCDE_EXTSRC9A0_BASEADDRESS0_MASK 0xFFFFFFF8
#define MCDE_EXTSRC9A0_BASEADDRESS0(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9A0, BASEADDRESS0, __x)
#define MCDE_EXTSRC0A1 0x00000204
#define MCDE_EXTSRC0A1_GROUPOFFSET 0x20
#define MCDE_EXTSRC0A1_BASEADDRESS1_SHIFT 3
#define MCDE_EXTSRC0A1_BASEADDRESS1_MASK 0xFFFFFFF8
#define MCDE_EXTSRC0A1_BASEADDRESS1(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0A1, BASEADDRESS1, __x)
#define MCDE_EXTSRC1A1 0x00000224
#define MCDE_EXTSRC1A1_BASEADDRESS1_SHIFT 3
#define MCDE_EXTSRC1A1_BASEADDRESS1_MASK 0xFFFFFFF8
#define MCDE_EXTSRC1A1_BASEADDRESS1(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1A1, BASEADDRESS1, __x)
#define MCDE_EXTSRC2A1 0x00000244
#define MCDE_EXTSRC2A1_BASEADDRESS1_SHIFT 3
#define MCDE_EXTSRC2A1_BASEADDRESS1_MASK 0xFFFFFFF8
#define MCDE_EXTSRC2A1_BASEADDRESS1(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2A1, BASEADDRESS1, __x)
#define MCDE_EXTSRC3A1 0x00000264
#define MCDE_EXTSRC3A1_BASEADDRESS1_SHIFT 3
#define MCDE_EXTSRC3A1_BASEADDRESS1_MASK 0xFFFFFFF8
#define MCDE_EXTSRC3A1_BASEADDRESS1(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3A1, BASEADDRESS1, __x)
#define MCDE_EXTSRC4A1 0x00000284
#define MCDE_EXTSRC4A1_BASEADDRESS1_SHIFT 3
#define MCDE_EXTSRC4A1_BASEADDRESS1_MASK 0xFFFFFFF8
#define MCDE_EXTSRC4A1_BASEADDRESS1(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4A1, BASEADDRESS1, __x)
#define MCDE_EXTSRC5A1 0x000002A4
#define MCDE_EXTSRC5A1_BASEADDRESS1_SHIFT 3
#define MCDE_EXTSRC5A1_BASEADDRESS1_MASK 0xFFFFFFF8
#define MCDE_EXTSRC5A1_BASEADDRESS1(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5A1, BASEADDRESS1, __x)
#define MCDE_EXTSRC6A1 0x000002C4
#define MCDE_EXTSRC6A1_BASEADDRESS1_SHIFT 3
#define MCDE_EXTSRC6A1_BASEADDRESS1_MASK 0xFFFFFFF8
#define MCDE_EXTSRC6A1_BASEADDRESS1(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6A1, BASEADDRESS1, __x)
#define MCDE_EXTSRC7A1 0x000002E4
#define MCDE_EXTSRC7A1_BASEADDRESS1_SHIFT 3
#define MCDE_EXTSRC7A1_BASEADDRESS1_MASK 0xFFFFFFF8
#define MCDE_EXTSRC7A1_BASEADDRESS1(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7A1, BASEADDRESS1, __x)
#define MCDE_EXTSRC8A1 0x00000304
#define MCDE_EXTSRC8A1_BASEADDRESS1_SHIFT 3
#define MCDE_EXTSRC8A1_BASEADDRESS1_MASK 0xFFFFFFF8
#define MCDE_EXTSRC8A1_BASEADDRESS1(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8A1, BASEADDRESS1, __x)
#define MCDE_EXTSRC9A1 0x00000324
#define MCDE_EXTSRC9A1_BASEADDRESS1_SHIFT 3
#define MCDE_EXTSRC9A1_BASEADDRESS1_MASK 0xFFFFFFF8
#define MCDE_EXTSRC9A1_BASEADDRESS1(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9A1, BASEADDRESS1, __x)
#define MCDE_EXTSRC6A2 0x000002C8
#define MCDE_EXTSRC6A2_BASEADDRESS2_SHIFT 3
#define MCDE_EXTSRC6A2_BASEADDRESS2_MASK 0xFFFFFFF8
#define MCDE_EXTSRC6A2_BASEADDRESS2(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6A2, BASEADDRESS2, __x)
#define MCDE_EXTSRC0CONF 0x0000020C
#define MCDE_EXTSRC0CONF_GROUPOFFSET 0x20
#define MCDE_EXTSRC0CONF_BUF_ID_SHIFT 0
#define MCDE_EXTSRC0CONF_BUF_ID_MASK 0x00000003
#define MCDE_EXTSRC0CONF_BUF_ID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0CONF, BUF_ID, __x)
#define MCDE_EXTSRC0CONF_BUF_NB_SHIFT 2
#define MCDE_EXTSRC0CONF_BUF_NB_MASK 0x0000000C
#define MCDE_EXTSRC0CONF_BUF_NB(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0CONF, BUF_NB, __x)
#define MCDE_EXTSRC0CONF_PRI_OVLID_SHIFT 4
#define MCDE_EXTSRC0CONF_PRI_OVLID_MASK 0x000000F0
#define MCDE_EXTSRC0CONF_PRI_OVLID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0CONF, PRI_OVLID, __x)
#define MCDE_EXTSRC0CONF_BPP_SHIFT 8
#define MCDE_EXTSRC0CONF_BPP_MASK 0x00000F00
#define MCDE_EXTSRC0CONF_BPP_1BPP_PAL 0
#define MCDE_EXTSRC0CONF_BPP_2BPP_PAL 1
#define MCDE_EXTSRC0CONF_BPP_4BPP_PAL 2
#define MCDE_EXTSRC0CONF_BPP_8BPP_PAL 3
#define MCDE_EXTSRC0CONF_BPP_RGB444 4
#define MCDE_EXTSRC0CONF_BPP_ARGB4444 5
#define MCDE_EXTSRC0CONF_BPP_IRGB1555 6
#define MCDE_EXTSRC0CONF_BPP_RGB565 7
#define MCDE_EXTSRC0CONF_BPP_RGB888 8
#define MCDE_EXTSRC0CONF_BPP_XRGB8888 9
#define MCDE_EXTSRC0CONF_BPP_ARGB8888 10
#define MCDE_EXTSRC0CONF_BPP_YCBCR422 11
#define MCDE_EXTSRC0CONF_BPP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0CONF, BPP, MCDE_EXTSRC0CONF_BPP_##__x)
#define MCDE_EXTSRC0CONF_BPP(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0CONF, BPP, __x)
#define MCDE_EXTSRC0CONF_BGR_SHIFT 12
#define MCDE_EXTSRC0CONF_BGR_MASK 0x00001000
#define MCDE_EXTSRC0CONF_BGR_RGB 0
#define MCDE_EXTSRC0CONF_BGR_BGR 1
#define MCDE_EXTSRC0CONF_BGR_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0CONF, BGR, MCDE_EXTSRC0CONF_BGR_##__x)
#define MCDE_EXTSRC0CONF_BGR(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0CONF, BGR, __x)
#define MCDE_EXTSRC0CONF_BEBO_SHIFT 13
#define MCDE_EXTSRC0CONF_BEBO_MASK 0x00002000
#define MCDE_EXTSRC0CONF_BEBO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC0CONF_BEBO_BIG_ENDIAN 1
#define MCDE_EXTSRC0CONF_BEBO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0CONF, BEBO, MCDE_EXTSRC0CONF_BEBO_##__x)
#define MCDE_EXTSRC0CONF_BEBO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0CONF, BEBO, __x)
#define MCDE_EXTSRC0CONF_BEPO_SHIFT 14
#define MCDE_EXTSRC0CONF_BEPO_MASK 0x00004000
#define MCDE_EXTSRC0CONF_BEPO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC0CONF_BEPO_BIG_ENDIAN 1
#define MCDE_EXTSRC0CONF_BEPO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0CONF, BEPO, MCDE_EXTSRC0CONF_BEPO_##__x)
#define MCDE_EXTSRC0CONF_BEPO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0CONF, BEPO, __x)
#define MCDE_EXTSRC1CONF 0x0000022C
#define MCDE_EXTSRC1CONF_BUF_ID_SHIFT 0
#define MCDE_EXTSRC1CONF_BUF_ID_MASK 0x00000003
#define MCDE_EXTSRC1CONF_BUF_ID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1CONF, BUF_ID, __x)
#define MCDE_EXTSRC1CONF_BUF_NB_SHIFT 2
#define MCDE_EXTSRC1CONF_BUF_NB_MASK 0x0000000C
#define MCDE_EXTSRC1CONF_BUF_NB(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1CONF, BUF_NB, __x)
#define MCDE_EXTSRC1CONF_PRI_OVLID_SHIFT 4
#define MCDE_EXTSRC1CONF_PRI_OVLID_MASK 0x000000F0
#define MCDE_EXTSRC1CONF_PRI_OVLID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1CONF, PRI_OVLID, __x)
#define MCDE_EXTSRC1CONF_BPP_SHIFT 8
#define MCDE_EXTSRC1CONF_BPP_MASK 0x00000F00
#define MCDE_EXTSRC1CONF_BPP_1BPP_PAL 0
#define MCDE_EXTSRC1CONF_BPP_2BPP_PAL 1
#define MCDE_EXTSRC1CONF_BPP_4BPP_PAL 2
#define MCDE_EXTSRC1CONF_BPP_8BPP_PAL 3
#define MCDE_EXTSRC1CONF_BPP_RGB444 4
#define MCDE_EXTSRC1CONF_BPP_ARGB4444 5
#define MCDE_EXTSRC1CONF_BPP_IRGB1555 6
#define MCDE_EXTSRC1CONF_BPP_RGB565 7
#define MCDE_EXTSRC1CONF_BPP_RGB888 8
#define MCDE_EXTSRC1CONF_BPP_XRGB8888 9
#define MCDE_EXTSRC1CONF_BPP_ARGB8888 10
#define MCDE_EXTSRC1CONF_BPP_YCBCR422 11
#define MCDE_EXTSRC1CONF_BPP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1CONF, BPP, MCDE_EXTSRC1CONF_BPP_##__x)
#define MCDE_EXTSRC1CONF_BPP(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1CONF, BPP, __x)
#define MCDE_EXTSRC1CONF_BGR_SHIFT 12
#define MCDE_EXTSRC1CONF_BGR_MASK 0x00001000
#define MCDE_EXTSRC1CONF_BGR_RGB 0
#define MCDE_EXTSRC1CONF_BGR_BGR 1
#define MCDE_EXTSRC1CONF_BGR_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1CONF, BGR, MCDE_EXTSRC1CONF_BGR_##__x)
#define MCDE_EXTSRC1CONF_BGR(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1CONF, BGR, __x)
#define MCDE_EXTSRC1CONF_BEBO_SHIFT 13
#define MCDE_EXTSRC1CONF_BEBO_MASK 0x00002000
#define MCDE_EXTSRC1CONF_BEBO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC1CONF_BEBO_BIG_ENDIAN 1
#define MCDE_EXTSRC1CONF_BEBO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1CONF, BEBO, MCDE_EXTSRC1CONF_BEBO_##__x)
#define MCDE_EXTSRC1CONF_BEBO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1CONF, BEBO, __x)
#define MCDE_EXTSRC1CONF_BEPO_SHIFT 14
#define MCDE_EXTSRC1CONF_BEPO_MASK 0x00004000
#define MCDE_EXTSRC1CONF_BEPO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC1CONF_BEPO_BIG_ENDIAN 1
#define MCDE_EXTSRC1CONF_BEPO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1CONF, BEPO, MCDE_EXTSRC1CONF_BEPO_##__x)
#define MCDE_EXTSRC1CONF_BEPO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1CONF, BEPO, __x)
#define MCDE_EXTSRC2CONF 0x0000024C
#define MCDE_EXTSRC2CONF_BUF_ID_SHIFT 0
#define MCDE_EXTSRC2CONF_BUF_ID_MASK 0x00000003
#define MCDE_EXTSRC2CONF_BUF_ID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2CONF, BUF_ID, __x)
#define MCDE_EXTSRC2CONF_BUF_NB_SHIFT 2
#define MCDE_EXTSRC2CONF_BUF_NB_MASK 0x0000000C
#define MCDE_EXTSRC2CONF_BUF_NB(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2CONF, BUF_NB, __x)
#define MCDE_EXTSRC2CONF_PRI_OVLID_SHIFT 4
#define MCDE_EXTSRC2CONF_PRI_OVLID_MASK 0x000000F0
#define MCDE_EXTSRC2CONF_PRI_OVLID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2CONF, PRI_OVLID, __x)
#define MCDE_EXTSRC2CONF_BPP_SHIFT 8
#define MCDE_EXTSRC2CONF_BPP_MASK 0x00000F00
#define MCDE_EXTSRC2CONF_BPP_1BPP_PAL 0
#define MCDE_EXTSRC2CONF_BPP_2BPP_PAL 1
#define MCDE_EXTSRC2CONF_BPP_4BPP_PAL 2
#define MCDE_EXTSRC2CONF_BPP_8BPP_PAL 3
#define MCDE_EXTSRC2CONF_BPP_RGB444 4
#define MCDE_EXTSRC2CONF_BPP_ARGB4444 5
#define MCDE_EXTSRC2CONF_BPP_IRGB1555 6
#define MCDE_EXTSRC2CONF_BPP_RGB565 7
#define MCDE_EXTSRC2CONF_BPP_RGB888 8
#define MCDE_EXTSRC2CONF_BPP_XRGB8888 9
#define MCDE_EXTSRC2CONF_BPP_ARGB8888 10
#define MCDE_EXTSRC2CONF_BPP_YCBCR422 11
#define MCDE_EXTSRC2CONF_BPP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2CONF, BPP, MCDE_EXTSRC2CONF_BPP_##__x)
#define MCDE_EXTSRC2CONF_BPP(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2CONF, BPP, __x)
#define MCDE_EXTSRC2CONF_BGR_SHIFT 12
#define MCDE_EXTSRC2CONF_BGR_MASK 0x00001000
#define MCDE_EXTSRC2CONF_BGR_RGB 0
#define MCDE_EXTSRC2CONF_BGR_BGR 1
#define MCDE_EXTSRC2CONF_BGR_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2CONF, BGR, MCDE_EXTSRC2CONF_BGR_##__x)
#define MCDE_EXTSRC2CONF_BGR(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2CONF, BGR, __x)
#define MCDE_EXTSRC2CONF_BEBO_SHIFT 13
#define MCDE_EXTSRC2CONF_BEBO_MASK 0x00002000
#define MCDE_EXTSRC2CONF_BEBO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC2CONF_BEBO_BIG_ENDIAN 1
#define MCDE_EXTSRC2CONF_BEBO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2CONF, BEBO, MCDE_EXTSRC2CONF_BEBO_##__x)
#define MCDE_EXTSRC2CONF_BEBO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2CONF, BEBO, __x)
#define MCDE_EXTSRC2CONF_BEPO_SHIFT 14
#define MCDE_EXTSRC2CONF_BEPO_MASK 0x00004000
#define MCDE_EXTSRC2CONF_BEPO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC2CONF_BEPO_BIG_ENDIAN 1
#define MCDE_EXTSRC2CONF_BEPO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2CONF, BEPO, MCDE_EXTSRC2CONF_BEPO_##__x)
#define MCDE_EXTSRC2CONF_BEPO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2CONF, BEPO, __x)
#define MCDE_EXTSRC3CONF 0x0000026C
#define MCDE_EXTSRC3CONF_BUF_ID_SHIFT 0
#define MCDE_EXTSRC3CONF_BUF_ID_MASK 0x00000003
#define MCDE_EXTSRC3CONF_BUF_ID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3CONF, BUF_ID, __x)
#define MCDE_EXTSRC3CONF_BUF_NB_SHIFT 2
#define MCDE_EXTSRC3CONF_BUF_NB_MASK 0x0000000C
#define MCDE_EXTSRC3CONF_BUF_NB(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3CONF, BUF_NB, __x)
#define MCDE_EXTSRC3CONF_PRI_OVLID_SHIFT 4
#define MCDE_EXTSRC3CONF_PRI_OVLID_MASK 0x000000F0
#define MCDE_EXTSRC3CONF_PRI_OVLID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3CONF, PRI_OVLID, __x)
#define MCDE_EXTSRC3CONF_BPP_SHIFT 8
#define MCDE_EXTSRC3CONF_BPP_MASK 0x00000F00
#define MCDE_EXTSRC3CONF_BPP_1BPP_PAL 0
#define MCDE_EXTSRC3CONF_BPP_2BPP_PAL 1
#define MCDE_EXTSRC3CONF_BPP_4BPP_PAL 2
#define MCDE_EXTSRC3CONF_BPP_8BPP_PAL 3
#define MCDE_EXTSRC3CONF_BPP_RGB444 4
#define MCDE_EXTSRC3CONF_BPP_ARGB4444 5
#define MCDE_EXTSRC3CONF_BPP_IRGB1555 6
#define MCDE_EXTSRC3CONF_BPP_RGB565 7
#define MCDE_EXTSRC3CONF_BPP_RGB888 8
#define MCDE_EXTSRC3CONF_BPP_XRGB8888 9
#define MCDE_EXTSRC3CONF_BPP_ARGB8888 10
#define MCDE_EXTSRC3CONF_BPP_YCBCR422 11
#define MCDE_EXTSRC3CONF_BPP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3CONF, BPP, MCDE_EXTSRC3CONF_BPP_##__x)
#define MCDE_EXTSRC3CONF_BPP(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3CONF, BPP, __x)
#define MCDE_EXTSRC3CONF_BGR_SHIFT 12
#define MCDE_EXTSRC3CONF_BGR_MASK 0x00001000
#define MCDE_EXTSRC3CONF_BGR_RGB 0
#define MCDE_EXTSRC3CONF_BGR_BGR 1
#define MCDE_EXTSRC3CONF_BGR_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3CONF, BGR, MCDE_EXTSRC3CONF_BGR_##__x)
#define MCDE_EXTSRC3CONF_BGR(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3CONF, BGR, __x)
#define MCDE_EXTSRC3CONF_BEBO_SHIFT 13
#define MCDE_EXTSRC3CONF_BEBO_MASK 0x00002000
#define MCDE_EXTSRC3CONF_BEBO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC3CONF_BEBO_BIG_ENDIAN 1
#define MCDE_EXTSRC3CONF_BEBO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3CONF, BEBO, MCDE_EXTSRC3CONF_BEBO_##__x)
#define MCDE_EXTSRC3CONF_BEBO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3CONF, BEBO, __x)
#define MCDE_EXTSRC3CONF_BEPO_SHIFT 14
#define MCDE_EXTSRC3CONF_BEPO_MASK 0x00004000
#define MCDE_EXTSRC3CONF_BEPO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC3CONF_BEPO_BIG_ENDIAN 1
#define MCDE_EXTSRC3CONF_BEPO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3CONF, BEPO, MCDE_EXTSRC3CONF_BEPO_##__x)
#define MCDE_EXTSRC3CONF_BEPO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3CONF, BEPO, __x)
#define MCDE_EXTSRC4CONF 0x0000028C
#define MCDE_EXTSRC4CONF_BUF_ID_SHIFT 0
#define MCDE_EXTSRC4CONF_BUF_ID_MASK 0x00000003
#define MCDE_EXTSRC4CONF_BUF_ID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4CONF, BUF_ID, __x)
#define MCDE_EXTSRC4CONF_BUF_NB_SHIFT 2
#define MCDE_EXTSRC4CONF_BUF_NB_MASK 0x0000000C
#define MCDE_EXTSRC4CONF_BUF_NB(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4CONF, BUF_NB, __x)
#define MCDE_EXTSRC4CONF_PRI_OVLID_SHIFT 4
#define MCDE_EXTSRC4CONF_PRI_OVLID_MASK 0x000000F0
#define MCDE_EXTSRC4CONF_PRI_OVLID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4CONF, PRI_OVLID, __x)
#define MCDE_EXTSRC4CONF_BPP_SHIFT 8
#define MCDE_EXTSRC4CONF_BPP_MASK 0x00000F00
#define MCDE_EXTSRC4CONF_BPP_1BPP_PAL 0
#define MCDE_EXTSRC4CONF_BPP_2BPP_PAL 1
#define MCDE_EXTSRC4CONF_BPP_4BPP_PAL 2
#define MCDE_EXTSRC4CONF_BPP_8BPP_PAL 3
#define MCDE_EXTSRC4CONF_BPP_RGB444 4
#define MCDE_EXTSRC4CONF_BPP_ARGB4444 5
#define MCDE_EXTSRC4CONF_BPP_IRGB1555 6
#define MCDE_EXTSRC4CONF_BPP_RGB565 7
#define MCDE_EXTSRC4CONF_BPP_RGB888 8
#define MCDE_EXTSRC4CONF_BPP_XRGB8888 9
#define MCDE_EXTSRC4CONF_BPP_ARGB8888 10
#define MCDE_EXTSRC4CONF_BPP_YCBCR422 11
#define MCDE_EXTSRC4CONF_BPP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4CONF, BPP, MCDE_EXTSRC4CONF_BPP_##__x)
#define MCDE_EXTSRC4CONF_BPP(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4CONF, BPP, __x)
#define MCDE_EXTSRC4CONF_BGR_SHIFT 12
#define MCDE_EXTSRC4CONF_BGR_MASK 0x00001000
#define MCDE_EXTSRC4CONF_BGR_RGB 0
#define MCDE_EXTSRC4CONF_BGR_BGR 1
#define MCDE_EXTSRC4CONF_BGR_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4CONF, BGR, MCDE_EXTSRC4CONF_BGR_##__x)
#define MCDE_EXTSRC4CONF_BGR(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4CONF, BGR, __x)
#define MCDE_EXTSRC4CONF_BEBO_SHIFT 13
#define MCDE_EXTSRC4CONF_BEBO_MASK 0x00002000
#define MCDE_EXTSRC4CONF_BEBO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC4CONF_BEBO_BIG_ENDIAN 1
#define MCDE_EXTSRC4CONF_BEBO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4CONF, BEBO, MCDE_EXTSRC4CONF_BEBO_##__x)
#define MCDE_EXTSRC4CONF_BEBO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4CONF, BEBO, __x)
#define MCDE_EXTSRC4CONF_BEPO_SHIFT 14
#define MCDE_EXTSRC4CONF_BEPO_MASK 0x00004000
#define MCDE_EXTSRC4CONF_BEPO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC4CONF_BEPO_BIG_ENDIAN 1
#define MCDE_EXTSRC4CONF_BEPO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4CONF, BEPO, MCDE_EXTSRC4CONF_BEPO_##__x)
#define MCDE_EXTSRC4CONF_BEPO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4CONF, BEPO, __x)
#define MCDE_EXTSRC5CONF 0x000002AC
#define MCDE_EXTSRC5CONF_BUF_ID_SHIFT 0
#define MCDE_EXTSRC5CONF_BUF_ID_MASK 0x00000003
#define MCDE_EXTSRC5CONF_BUF_ID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5CONF, BUF_ID, __x)
#define MCDE_EXTSRC5CONF_BUF_NB_SHIFT 2
#define MCDE_EXTSRC5CONF_BUF_NB_MASK 0x0000000C
#define MCDE_EXTSRC5CONF_BUF_NB(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5CONF, BUF_NB, __x)
#define MCDE_EXTSRC5CONF_PRI_OVLID_SHIFT 4
#define MCDE_EXTSRC5CONF_PRI_OVLID_MASK 0x000000F0
#define MCDE_EXTSRC5CONF_PRI_OVLID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5CONF, PRI_OVLID, __x)
#define MCDE_EXTSRC5CONF_BPP_SHIFT 8
#define MCDE_EXTSRC5CONF_BPP_MASK 0x00000F00
#define MCDE_EXTSRC5CONF_BPP_1BPP_PAL 0
#define MCDE_EXTSRC5CONF_BPP_2BPP_PAL 1
#define MCDE_EXTSRC5CONF_BPP_4BPP_PAL 2
#define MCDE_EXTSRC5CONF_BPP_8BPP_PAL 3
#define MCDE_EXTSRC5CONF_BPP_RGB444 4
#define MCDE_EXTSRC5CONF_BPP_ARGB4444 5
#define MCDE_EXTSRC5CONF_BPP_IRGB1555 6
#define MCDE_EXTSRC5CONF_BPP_RGB565 7
#define MCDE_EXTSRC5CONF_BPP_RGB888 8
#define MCDE_EXTSRC5CONF_BPP_XRGB8888 9
#define MCDE_EXTSRC5CONF_BPP_ARGB8888 10
#define MCDE_EXTSRC5CONF_BPP_YCBCR422 11
#define MCDE_EXTSRC5CONF_BPP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5CONF, BPP, MCDE_EXTSRC5CONF_BPP_##__x)
#define MCDE_EXTSRC5CONF_BPP(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5CONF, BPP, __x)
#define MCDE_EXTSRC5CONF_BGR_SHIFT 12
#define MCDE_EXTSRC5CONF_BGR_MASK 0x00001000
#define MCDE_EXTSRC5CONF_BGR_RGB 0
#define MCDE_EXTSRC5CONF_BGR_BGR 1
#define MCDE_EXTSRC5CONF_BGR_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5CONF, BGR, MCDE_EXTSRC5CONF_BGR_##__x)
#define MCDE_EXTSRC5CONF_BGR(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5CONF, BGR, __x)
#define MCDE_EXTSRC5CONF_BEBO_SHIFT 13
#define MCDE_EXTSRC5CONF_BEBO_MASK 0x00002000
#define MCDE_EXTSRC5CONF_BEBO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC5CONF_BEBO_BIG_ENDIAN 1
#define MCDE_EXTSRC5CONF_BEBO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5CONF, BEBO, MCDE_EXTSRC5CONF_BEBO_##__x)
#define MCDE_EXTSRC5CONF_BEBO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5CONF, BEBO, __x)
#define MCDE_EXTSRC5CONF_BEPO_SHIFT 14
#define MCDE_EXTSRC5CONF_BEPO_MASK 0x00004000
#define MCDE_EXTSRC5CONF_BEPO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC5CONF_BEPO_BIG_ENDIAN 1
#define MCDE_EXTSRC5CONF_BEPO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5CONF, BEPO, MCDE_EXTSRC5CONF_BEPO_##__x)
#define MCDE_EXTSRC5CONF_BEPO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5CONF, BEPO, __x)
#define MCDE_EXTSRC6CONF 0x000002CC
#define MCDE_EXTSRC6CONF_BUF_ID_SHIFT 0
#define MCDE_EXTSRC6CONF_BUF_ID_MASK 0x00000003
#define MCDE_EXTSRC6CONF_BUF_ID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6CONF, BUF_ID, __x)
#define MCDE_EXTSRC6CONF_BUF_NB_SHIFT 2
#define MCDE_EXTSRC6CONF_BUF_NB_MASK 0x0000000C
#define MCDE_EXTSRC6CONF_BUF_NB(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6CONF, BUF_NB, __x)
#define MCDE_EXTSRC6CONF_PRI_OVLID_SHIFT 4
#define MCDE_EXTSRC6CONF_PRI_OVLID_MASK 0x000000F0
#define MCDE_EXTSRC6CONF_PRI_OVLID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6CONF, PRI_OVLID, __x)
#define MCDE_EXTSRC6CONF_BPP_SHIFT 8
#define MCDE_EXTSRC6CONF_BPP_MASK 0x00000F00
#define MCDE_EXTSRC6CONF_BPP_1BPP_PAL 0
#define MCDE_EXTSRC6CONF_BPP_2BPP_PAL 1
#define MCDE_EXTSRC6CONF_BPP_4BPP_PAL 2
#define MCDE_EXTSRC6CONF_BPP_8BPP_PAL 3
#define MCDE_EXTSRC6CONF_BPP_RGB444 4
#define MCDE_EXTSRC6CONF_BPP_ARGB4444 5
#define MCDE_EXTSRC6CONF_BPP_IRGB1555 6
#define MCDE_EXTSRC6CONF_BPP_RGB565 7
#define MCDE_EXTSRC6CONF_BPP_RGB888 8
#define MCDE_EXTSRC6CONF_BPP_XRGB8888 9
#define MCDE_EXTSRC6CONF_BPP_ARGB8888 10
#define MCDE_EXTSRC6CONF_BPP_YCBCR422 11
#define MCDE_EXTSRC6CONF_BPP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6CONF, BPP, MCDE_EXTSRC6CONF_BPP_##__x)
#define MCDE_EXTSRC6CONF_BPP(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6CONF, BPP, __x)
#define MCDE_EXTSRC6CONF_BGR_SHIFT 12
#define MCDE_EXTSRC6CONF_BGR_MASK 0x00001000
#define MCDE_EXTSRC6CONF_BGR_RGB 0
#define MCDE_EXTSRC6CONF_BGR_BGR 1
#define MCDE_EXTSRC6CONF_BGR_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6CONF, BGR, MCDE_EXTSRC6CONF_BGR_##__x)
#define MCDE_EXTSRC6CONF_BGR(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6CONF, BGR, __x)
#define MCDE_EXTSRC6CONF_BEBO_SHIFT 13
#define MCDE_EXTSRC6CONF_BEBO_MASK 0x00002000
#define MCDE_EXTSRC6CONF_BEBO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC6CONF_BEBO_BIG_ENDIAN 1
#define MCDE_EXTSRC6CONF_BEBO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6CONF, BEBO, MCDE_EXTSRC6CONF_BEBO_##__x)
#define MCDE_EXTSRC6CONF_BEBO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6CONF, BEBO, __x)
#define MCDE_EXTSRC6CONF_BEPO_SHIFT 14
#define MCDE_EXTSRC6CONF_BEPO_MASK 0x00004000
#define MCDE_EXTSRC6CONF_BEPO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC6CONF_BEPO_BIG_ENDIAN 1
#define MCDE_EXTSRC6CONF_BEPO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6CONF, BEPO, MCDE_EXTSRC6CONF_BEPO_##__x)
#define MCDE_EXTSRC6CONF_BEPO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6CONF, BEPO, __x)
#define MCDE_EXTSRC7CONF 0x000002EC
#define MCDE_EXTSRC7CONF_BUF_ID_SHIFT 0
#define MCDE_EXTSRC7CONF_BUF_ID_MASK 0x00000003
#define MCDE_EXTSRC7CONF_BUF_ID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7CONF, BUF_ID, __x)
#define MCDE_EXTSRC7CONF_BUF_NB_SHIFT 2
#define MCDE_EXTSRC7CONF_BUF_NB_MASK 0x0000000C
#define MCDE_EXTSRC7CONF_BUF_NB(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7CONF, BUF_NB, __x)
#define MCDE_EXTSRC7CONF_PRI_OVLID_SHIFT 4
#define MCDE_EXTSRC7CONF_PRI_OVLID_MASK 0x000000F0
#define MCDE_EXTSRC7CONF_PRI_OVLID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7CONF, PRI_OVLID, __x)
#define MCDE_EXTSRC7CONF_BPP_SHIFT 8
#define MCDE_EXTSRC7CONF_BPP_MASK 0x00000F00
#define MCDE_EXTSRC7CONF_BPP_1BPP_PAL 0
#define MCDE_EXTSRC7CONF_BPP_2BPP_PAL 1
#define MCDE_EXTSRC7CONF_BPP_4BPP_PAL 2
#define MCDE_EXTSRC7CONF_BPP_8BPP_PAL 3
#define MCDE_EXTSRC7CONF_BPP_RGB444 4
#define MCDE_EXTSRC7CONF_BPP_ARGB4444 5
#define MCDE_EXTSRC7CONF_BPP_IRGB1555 6
#define MCDE_EXTSRC7CONF_BPP_RGB565 7
#define MCDE_EXTSRC7CONF_BPP_RGB888 8
#define MCDE_EXTSRC7CONF_BPP_XRGB8888 9
#define MCDE_EXTSRC7CONF_BPP_ARGB8888 10
#define MCDE_EXTSRC7CONF_BPP_YCBCR422 11
#define MCDE_EXTSRC7CONF_BPP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7CONF, BPP, MCDE_EXTSRC7CONF_BPP_##__x)
#define MCDE_EXTSRC7CONF_BPP(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7CONF, BPP, __x)
#define MCDE_EXTSRC7CONF_BGR_SHIFT 12
#define MCDE_EXTSRC7CONF_BGR_MASK 0x00001000
#define MCDE_EXTSRC7CONF_BGR_RGB 0
#define MCDE_EXTSRC7CONF_BGR_BGR 1
#define MCDE_EXTSRC7CONF_BGR_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7CONF, BGR, MCDE_EXTSRC7CONF_BGR_##__x)
#define MCDE_EXTSRC7CONF_BGR(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7CONF, BGR, __x)
#define MCDE_EXTSRC7CONF_BEBO_SHIFT 13
#define MCDE_EXTSRC7CONF_BEBO_MASK 0x00002000
#define MCDE_EXTSRC7CONF_BEBO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC7CONF_BEBO_BIG_ENDIAN 1
#define MCDE_EXTSRC7CONF_BEBO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7CONF, BEBO, MCDE_EXTSRC7CONF_BEBO_##__x)
#define MCDE_EXTSRC7CONF_BEBO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7CONF, BEBO, __x)
#define MCDE_EXTSRC7CONF_BEPO_SHIFT 14
#define MCDE_EXTSRC7CONF_BEPO_MASK 0x00004000
#define MCDE_EXTSRC7CONF_BEPO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC7CONF_BEPO_BIG_ENDIAN 1
#define MCDE_EXTSRC7CONF_BEPO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7CONF, BEPO, MCDE_EXTSRC7CONF_BEPO_##__x)
#define MCDE_EXTSRC7CONF_BEPO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7CONF, BEPO, __x)
#define MCDE_EXTSRC8CONF 0x0000030C
#define MCDE_EXTSRC8CONF_BUF_ID_SHIFT 0
#define MCDE_EXTSRC8CONF_BUF_ID_MASK 0x00000003
#define MCDE_EXTSRC8CONF_BUF_ID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8CONF, BUF_ID, __x)
#define MCDE_EXTSRC8CONF_BUF_NB_SHIFT 2
#define MCDE_EXTSRC8CONF_BUF_NB_MASK 0x0000000C
#define MCDE_EXTSRC8CONF_BUF_NB(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8CONF, BUF_NB, __x)
#define MCDE_EXTSRC8CONF_PRI_OVLID_SHIFT 4
#define MCDE_EXTSRC8CONF_PRI_OVLID_MASK 0x000000F0
#define MCDE_EXTSRC8CONF_PRI_OVLID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8CONF, PRI_OVLID, __x)
#define MCDE_EXTSRC8CONF_BPP_SHIFT 8
#define MCDE_EXTSRC8CONF_BPP_MASK 0x00000F00
#define MCDE_EXTSRC8CONF_BPP_1BPP_PAL 0
#define MCDE_EXTSRC8CONF_BPP_2BPP_PAL 1
#define MCDE_EXTSRC8CONF_BPP_4BPP_PAL 2
#define MCDE_EXTSRC8CONF_BPP_8BPP_PAL 3
#define MCDE_EXTSRC8CONF_BPP_RGB444 4
#define MCDE_EXTSRC8CONF_BPP_ARGB4444 5
#define MCDE_EXTSRC8CONF_BPP_IRGB1555 6
#define MCDE_EXTSRC8CONF_BPP_RGB565 7
#define MCDE_EXTSRC8CONF_BPP_RGB888 8
#define MCDE_EXTSRC8CONF_BPP_XRGB8888 9
#define MCDE_EXTSRC8CONF_BPP_ARGB8888 10
#define MCDE_EXTSRC8CONF_BPP_YCBCR422 11
#define MCDE_EXTSRC8CONF_BPP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8CONF, BPP, MCDE_EXTSRC8CONF_BPP_##__x)
#define MCDE_EXTSRC8CONF_BPP(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8CONF, BPP, __x)
#define MCDE_EXTSRC8CONF_BGR_SHIFT 12
#define MCDE_EXTSRC8CONF_BGR_MASK 0x00001000
#define MCDE_EXTSRC8CONF_BGR_RGB 0
#define MCDE_EXTSRC8CONF_BGR_BGR 1
#define MCDE_EXTSRC8CONF_BGR_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8CONF, BGR, MCDE_EXTSRC8CONF_BGR_##__x)
#define MCDE_EXTSRC8CONF_BGR(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8CONF, BGR, __x)
#define MCDE_EXTSRC8CONF_BEBO_SHIFT 13
#define MCDE_EXTSRC8CONF_BEBO_MASK 0x00002000
#define MCDE_EXTSRC8CONF_BEBO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC8CONF_BEBO_BIG_ENDIAN 1
#define MCDE_EXTSRC8CONF_BEBO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8CONF, BEBO, MCDE_EXTSRC8CONF_BEBO_##__x)
#define MCDE_EXTSRC8CONF_BEBO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8CONF, BEBO, __x)
#define MCDE_EXTSRC8CONF_BEPO_SHIFT 14
#define MCDE_EXTSRC8CONF_BEPO_MASK 0x00004000
#define MCDE_EXTSRC8CONF_BEPO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC8CONF_BEPO_BIG_ENDIAN 1
#define MCDE_EXTSRC8CONF_BEPO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8CONF, BEPO, MCDE_EXTSRC8CONF_BEPO_##__x)
#define MCDE_EXTSRC8CONF_BEPO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8CONF, BEPO, __x)
#define MCDE_EXTSRC9CONF 0x0000032C
#define MCDE_EXTSRC9CONF_BUF_ID_SHIFT 0
#define MCDE_EXTSRC9CONF_BUF_ID_MASK 0x00000003
#define MCDE_EXTSRC9CONF_BUF_ID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9CONF, BUF_ID, __x)
#define MCDE_EXTSRC9CONF_BUF_NB_SHIFT 2
#define MCDE_EXTSRC9CONF_BUF_NB_MASK 0x0000000C
#define MCDE_EXTSRC9CONF_BUF_NB(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9CONF, BUF_NB, __x)
#define MCDE_EXTSRC9CONF_PRI_OVLID_SHIFT 4
#define MCDE_EXTSRC9CONF_PRI_OVLID_MASK 0x000000F0
#define MCDE_EXTSRC9CONF_PRI_OVLID(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9CONF, PRI_OVLID, __x)
#define MCDE_EXTSRC9CONF_BPP_SHIFT 8
#define MCDE_EXTSRC9CONF_BPP_MASK 0x00000F00
#define MCDE_EXTSRC9CONF_BPP_1BPP_PAL 0
#define MCDE_EXTSRC9CONF_BPP_2BPP_PAL 1
#define MCDE_EXTSRC9CONF_BPP_4BPP_PAL 2
#define MCDE_EXTSRC9CONF_BPP_8BPP_PAL 3
#define MCDE_EXTSRC9CONF_BPP_RGB444 4
#define MCDE_EXTSRC9CONF_BPP_ARGB4444 5
#define MCDE_EXTSRC9CONF_BPP_IRGB1555 6
#define MCDE_EXTSRC9CONF_BPP_RGB565 7
#define MCDE_EXTSRC9CONF_BPP_RGB888 8
#define MCDE_EXTSRC9CONF_BPP_XRGB8888 9
#define MCDE_EXTSRC9CONF_BPP_ARGB8888 10
#define MCDE_EXTSRC9CONF_BPP_YCBCR422 11
#define MCDE_EXTSRC9CONF_BPP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9CONF, BPP, MCDE_EXTSRC9CONF_BPP_##__x)
#define MCDE_EXTSRC9CONF_BPP(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9CONF, BPP, __x)
#define MCDE_EXTSRC9CONF_BGR_SHIFT 12
#define MCDE_EXTSRC9CONF_BGR_MASK 0x00001000
#define MCDE_EXTSRC9CONF_BGR_RGB 0
#define MCDE_EXTSRC9CONF_BGR_BGR 1
#define MCDE_EXTSRC9CONF_BGR_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9CONF, BGR, MCDE_EXTSRC9CONF_BGR_##__x)
#define MCDE_EXTSRC9CONF_BGR(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9CONF, BGR, __x)
#define MCDE_EXTSRC9CONF_BEBO_SHIFT 13
#define MCDE_EXTSRC9CONF_BEBO_MASK 0x00002000
#define MCDE_EXTSRC9CONF_BEBO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC9CONF_BEBO_BIG_ENDIAN 1
#define MCDE_EXTSRC9CONF_BEBO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9CONF, BEBO, MCDE_EXTSRC9CONF_BEBO_##__x)
#define MCDE_EXTSRC9CONF_BEBO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9CONF, BEBO, __x)
#define MCDE_EXTSRC9CONF_BEPO_SHIFT 14
#define MCDE_EXTSRC9CONF_BEPO_MASK 0x00004000
#define MCDE_EXTSRC9CONF_BEPO_LITTLE_ENDIAN 0
#define MCDE_EXTSRC9CONF_BEPO_BIG_ENDIAN 1
#define MCDE_EXTSRC9CONF_BEPO_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9CONF, BEPO, MCDE_EXTSRC9CONF_BEPO_##__x)
#define MCDE_EXTSRC9CONF_BEPO(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9CONF, BEPO, __x)
#define MCDE_EXTSRC0CR 0x00000210
#define MCDE_EXTSRC0CR_GROUPOFFSET 0x20
#define MCDE_EXTSRC0CR_SEL_MOD_SHIFT 0
#define MCDE_EXTSRC0CR_SEL_MOD_MASK 0x00000003
#define MCDE_EXTSRC0CR_SEL_MOD_EXTERNAL_SEL 0
#define MCDE_EXTSRC0CR_SEL_MOD_AUTO_TOGGLE 1
#define MCDE_EXTSRC0CR_SEL_MOD_SOFTWARE_SEL 2
#define MCDE_EXTSRC0CR_SEL_MOD_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0CR, SEL_MOD, MCDE_EXTSRC0CR_SEL_MOD_##__x)
#define MCDE_EXTSRC0CR_SEL_MOD(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0CR, SEL_MOD, __x)
#define MCDE_EXTSRC0CR_MULTIOVL_CTRL_SHIFT 2
#define MCDE_EXTSRC0CR_MULTIOVL_CTRL_MASK 0x00000004
#define MCDE_EXTSRC0CR_MULTIOVL_CTRL_ALL 0
#define MCDE_EXTSRC0CR_MULTIOVL_CTRL_PRIMARY 1
#define MCDE_EXTSRC0CR_MULTIOVL_CTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0CR, MULTIOVL_CTRL, \
	MCDE_EXTSRC0CR_MULTIOVL_CTRL_##__x)
#define MCDE_EXTSRC0CR_MULTIOVL_CTRL(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0CR, MULTIOVL_CTRL, __x)
#define MCDE_EXTSRC0CR_FS_DIV_DISABLE_SHIFT 3
#define MCDE_EXTSRC0CR_FS_DIV_DISABLE_MASK 0x00000008
#define MCDE_EXTSRC0CR_FS_DIV_DISABLE(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0CR, FS_DIV_DISABLE, __x)
#define MCDE_EXTSRC0CR_FORCE_FS_DIV_SHIFT 4
#define MCDE_EXTSRC0CR_FORCE_FS_DIV_MASK 0x00000010
#define MCDE_EXTSRC0CR_FORCE_FS_DIV(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC0CR, FORCE_FS_DIV, __x)
#define MCDE_EXTSRC1CR 0x00000230
#define MCDE_EXTSRC1CR_SEL_MOD_SHIFT 0
#define MCDE_EXTSRC1CR_SEL_MOD_MASK 0x00000003
#define MCDE_EXTSRC1CR_SEL_MOD_EXTERNAL_SEL 0
#define MCDE_EXTSRC1CR_SEL_MOD_AUTO_TOGGLE 1
#define MCDE_EXTSRC1CR_SEL_MOD_SOFTWARE_SEL 2
#define MCDE_EXTSRC1CR_SEL_MOD_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1CR, SEL_MOD, MCDE_EXTSRC1CR_SEL_MOD_##__x)
#define MCDE_EXTSRC1CR_SEL_MOD(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1CR, SEL_MOD, __x)
#define MCDE_EXTSRC1CR_MULTIOVL_CTRL_SHIFT 2
#define MCDE_EXTSRC1CR_MULTIOVL_CTRL_MASK 0x00000004
#define MCDE_EXTSRC1CR_MULTIOVL_CTRL_ALL 0
#define MCDE_EXTSRC1CR_MULTIOVL_CTRL_PRIMARY 1
#define MCDE_EXTSRC1CR_MULTIOVL_CTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1CR, MULTIOVL_CTRL, \
	MCDE_EXTSRC1CR_MULTIOVL_CTRL_##__x)
#define MCDE_EXTSRC1CR_MULTIOVL_CTRL(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1CR, MULTIOVL_CTRL, __x)
#define MCDE_EXTSRC1CR_FS_DIV_DISABLE_SHIFT 3
#define MCDE_EXTSRC1CR_FS_DIV_DISABLE_MASK 0x00000008
#define MCDE_EXTSRC1CR_FS_DIV_DISABLE(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1CR, FS_DIV_DISABLE, __x)
#define MCDE_EXTSRC1CR_FORCE_FS_DIV_SHIFT 4
#define MCDE_EXTSRC1CR_FORCE_FS_DIV_MASK 0x00000010
#define MCDE_EXTSRC1CR_FORCE_FS_DIV(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC1CR, FORCE_FS_DIV, __x)
#define MCDE_EXTSRC2CR 0x00000250
#define MCDE_EXTSRC2CR_SEL_MOD_SHIFT 0
#define MCDE_EXTSRC2CR_SEL_MOD_MASK 0x00000003
#define MCDE_EXTSRC2CR_SEL_MOD_EXTERNAL_SEL 0
#define MCDE_EXTSRC2CR_SEL_MOD_AUTO_TOGGLE 1
#define MCDE_EXTSRC2CR_SEL_MOD_SOFTWARE_SEL 2
#define MCDE_EXTSRC2CR_SEL_MOD_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2CR, SEL_MOD, MCDE_EXTSRC2CR_SEL_MOD_##__x)
#define MCDE_EXTSRC2CR_SEL_MOD(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2CR, SEL_MOD, __x)
#define MCDE_EXTSRC2CR_MULTIOVL_CTRL_SHIFT 2
#define MCDE_EXTSRC2CR_MULTIOVL_CTRL_MASK 0x00000004
#define MCDE_EXTSRC2CR_MULTIOVL_CTRL_ALL 0
#define MCDE_EXTSRC2CR_MULTIOVL_CTRL_PRIMARY 1
#define MCDE_EXTSRC2CR_MULTIOVL_CTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2CR, MULTIOVL_CTRL, \
	MCDE_EXTSRC2CR_MULTIOVL_CTRL_##__x)
#define MCDE_EXTSRC2CR_MULTIOVL_CTRL(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2CR, MULTIOVL_CTRL, __x)
#define MCDE_EXTSRC2CR_FS_DIV_DISABLE_SHIFT 3
#define MCDE_EXTSRC2CR_FS_DIV_DISABLE_MASK 0x00000008
#define MCDE_EXTSRC2CR_FS_DIV_DISABLE(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2CR, FS_DIV_DISABLE, __x)
#define MCDE_EXTSRC2CR_FORCE_FS_DIV_SHIFT 4
#define MCDE_EXTSRC2CR_FORCE_FS_DIV_MASK 0x00000010
#define MCDE_EXTSRC2CR_FORCE_FS_DIV(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC2CR, FORCE_FS_DIV, __x)
#define MCDE_EXTSRC3CR 0x00000270
#define MCDE_EXTSRC3CR_SEL_MOD_SHIFT 0
#define MCDE_EXTSRC3CR_SEL_MOD_MASK 0x00000003
#define MCDE_EXTSRC3CR_SEL_MOD_EXTERNAL_SEL 0
#define MCDE_EXTSRC3CR_SEL_MOD_AUTO_TOGGLE 1
#define MCDE_EXTSRC3CR_SEL_MOD_SOFTWARE_SEL 2
#define MCDE_EXTSRC3CR_SEL_MOD_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3CR, SEL_MOD, MCDE_EXTSRC3CR_SEL_MOD_##__x)
#define MCDE_EXTSRC3CR_SEL_MOD(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3CR, SEL_MOD, __x)
#define MCDE_EXTSRC3CR_MULTIOVL_CTRL_SHIFT 2
#define MCDE_EXTSRC3CR_MULTIOVL_CTRL_MASK 0x00000004
#define MCDE_EXTSRC3CR_MULTIOVL_CTRL_ALL 0
#define MCDE_EXTSRC3CR_MULTIOVL_CTRL_PRIMARY 1
#define MCDE_EXTSRC3CR_MULTIOVL_CTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3CR, MULTIOVL_CTRL, \
	MCDE_EXTSRC3CR_MULTIOVL_CTRL_##__x)
#define MCDE_EXTSRC3CR_MULTIOVL_CTRL(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3CR, MULTIOVL_CTRL, __x)
#define MCDE_EXTSRC3CR_FS_DIV_DISABLE_SHIFT 3
#define MCDE_EXTSRC3CR_FS_DIV_DISABLE_MASK 0x00000008
#define MCDE_EXTSRC3CR_FS_DIV_DISABLE(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3CR, FS_DIV_DISABLE, __x)
#define MCDE_EXTSRC3CR_FORCE_FS_DIV_SHIFT 4
#define MCDE_EXTSRC3CR_FORCE_FS_DIV_MASK 0x00000010
#define MCDE_EXTSRC3CR_FORCE_FS_DIV(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC3CR, FORCE_FS_DIV, __x)
#define MCDE_EXTSRC4CR 0x00000290
#define MCDE_EXTSRC4CR_SEL_MOD_SHIFT 0
#define MCDE_EXTSRC4CR_SEL_MOD_MASK 0x00000003
#define MCDE_EXTSRC4CR_SEL_MOD_EXTERNAL_SEL 0
#define MCDE_EXTSRC4CR_SEL_MOD_AUTO_TOGGLE 1
#define MCDE_EXTSRC4CR_SEL_MOD_SOFTWARE_SEL 2
#define MCDE_EXTSRC4CR_SEL_MOD_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4CR, SEL_MOD, MCDE_EXTSRC4CR_SEL_MOD_##__x)
#define MCDE_EXTSRC4CR_SEL_MOD(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4CR, SEL_MOD, __x)
#define MCDE_EXTSRC4CR_MULTIOVL_CTRL_SHIFT 2
#define MCDE_EXTSRC4CR_MULTIOVL_CTRL_MASK 0x00000004
#define MCDE_EXTSRC4CR_MULTIOVL_CTRL_ALL 0
#define MCDE_EXTSRC4CR_MULTIOVL_CTRL_PRIMARY 1
#define MCDE_EXTSRC4CR_MULTIOVL_CTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4CR, MULTIOVL_CTRL, \
	MCDE_EXTSRC4CR_MULTIOVL_CTRL_##__x)
#define MCDE_EXTSRC4CR_MULTIOVL_CTRL(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4CR, MULTIOVL_CTRL, __x)
#define MCDE_EXTSRC4CR_FS_DIV_DISABLE_SHIFT 3
#define MCDE_EXTSRC4CR_FS_DIV_DISABLE_MASK 0x00000008
#define MCDE_EXTSRC4CR_FS_DIV_DISABLE(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4CR, FS_DIV_DISABLE, __x)
#define MCDE_EXTSRC4CR_FORCE_FS_DIV_SHIFT 4
#define MCDE_EXTSRC4CR_FORCE_FS_DIV_MASK 0x00000010
#define MCDE_EXTSRC4CR_FORCE_FS_DIV(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC4CR, FORCE_FS_DIV, __x)
#define MCDE_EXTSRC5CR 0x000002B0
#define MCDE_EXTSRC5CR_SEL_MOD_SHIFT 0
#define MCDE_EXTSRC5CR_SEL_MOD_MASK 0x00000003
#define MCDE_EXTSRC5CR_SEL_MOD_EXTERNAL_SEL 0
#define MCDE_EXTSRC5CR_SEL_MOD_AUTO_TOGGLE 1
#define MCDE_EXTSRC5CR_SEL_MOD_SOFTWARE_SEL 2
#define MCDE_EXTSRC5CR_SEL_MOD_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5CR, SEL_MOD, MCDE_EXTSRC5CR_SEL_MOD_##__x)
#define MCDE_EXTSRC5CR_SEL_MOD(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5CR, SEL_MOD, __x)
#define MCDE_EXTSRC5CR_MULTIOVL_CTRL_SHIFT 2
#define MCDE_EXTSRC5CR_MULTIOVL_CTRL_MASK 0x00000004
#define MCDE_EXTSRC5CR_MULTIOVL_CTRL_ALL 0
#define MCDE_EXTSRC5CR_MULTIOVL_CTRL_PRIMARY 1
#define MCDE_EXTSRC5CR_MULTIOVL_CTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5CR, MULTIOVL_CTRL, \
	MCDE_EXTSRC5CR_MULTIOVL_CTRL_##__x)
#define MCDE_EXTSRC5CR_MULTIOVL_CTRL(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5CR, MULTIOVL_CTRL, __x)
#define MCDE_EXTSRC5CR_FS_DIV_DISABLE_SHIFT 3
#define MCDE_EXTSRC5CR_FS_DIV_DISABLE_MASK 0x00000008
#define MCDE_EXTSRC5CR_FS_DIV_DISABLE(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5CR, FS_DIV_DISABLE, __x)
#define MCDE_EXTSRC5CR_FORCE_FS_DIV_SHIFT 4
#define MCDE_EXTSRC5CR_FORCE_FS_DIV_MASK 0x00000010
#define MCDE_EXTSRC5CR_FORCE_FS_DIV(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC5CR, FORCE_FS_DIV, __x)
#define MCDE_EXTSRC6CR 0x000002D0
#define MCDE_EXTSRC6CR_SEL_MOD_SHIFT 0
#define MCDE_EXTSRC6CR_SEL_MOD_MASK 0x00000003
#define MCDE_EXTSRC6CR_SEL_MOD_EXTERNAL_SEL 0
#define MCDE_EXTSRC6CR_SEL_MOD_AUTO_TOGGLE 1
#define MCDE_EXTSRC6CR_SEL_MOD_SOFTWARE_SEL 2
#define MCDE_EXTSRC6CR_SEL_MOD_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6CR, SEL_MOD, MCDE_EXTSRC6CR_SEL_MOD_##__x)
#define MCDE_EXTSRC6CR_SEL_MOD(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6CR, SEL_MOD, __x)
#define MCDE_EXTSRC6CR_MULTIOVL_CTRL_SHIFT 2
#define MCDE_EXTSRC6CR_MULTIOVL_CTRL_MASK 0x00000004
#define MCDE_EXTSRC6CR_MULTIOVL_CTRL_ALL 0
#define MCDE_EXTSRC6CR_MULTIOVL_CTRL_PRIMARY 1
#define MCDE_EXTSRC6CR_MULTIOVL_CTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6CR, MULTIOVL_CTRL, \
	MCDE_EXTSRC6CR_MULTIOVL_CTRL_##__x)
#define MCDE_EXTSRC6CR_MULTIOVL_CTRL(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6CR, MULTIOVL_CTRL, __x)
#define MCDE_EXTSRC6CR_FS_DIV_DISABLE_SHIFT 3
#define MCDE_EXTSRC6CR_FS_DIV_DISABLE_MASK 0x00000008
#define MCDE_EXTSRC6CR_FS_DIV_DISABLE(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6CR, FS_DIV_DISABLE, __x)
#define MCDE_EXTSRC6CR_FORCE_FS_DIV_SHIFT 4
#define MCDE_EXTSRC6CR_FORCE_FS_DIV_MASK 0x00000010
#define MCDE_EXTSRC6CR_FORCE_FS_DIV(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC6CR, FORCE_FS_DIV, __x)
#define MCDE_EXTSRC7CR 0x000002F0
#define MCDE_EXTSRC7CR_SEL_MOD_SHIFT 0
#define MCDE_EXTSRC7CR_SEL_MOD_MASK 0x00000003
#define MCDE_EXTSRC7CR_SEL_MOD_EXTERNAL_SEL 0
#define MCDE_EXTSRC7CR_SEL_MOD_AUTO_TOGGLE 1
#define MCDE_EXTSRC7CR_SEL_MOD_SOFTWARE_SEL 2
#define MCDE_EXTSRC7CR_SEL_MOD_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7CR, SEL_MOD, MCDE_EXTSRC7CR_SEL_MOD_##__x)
#define MCDE_EXTSRC7CR_SEL_MOD(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7CR, SEL_MOD, __x)
#define MCDE_EXTSRC7CR_MULTIOVL_CTRL_SHIFT 2
#define MCDE_EXTSRC7CR_MULTIOVL_CTRL_MASK 0x00000004
#define MCDE_EXTSRC7CR_MULTIOVL_CTRL_ALL 0
#define MCDE_EXTSRC7CR_MULTIOVL_CTRL_PRIMARY 1
#define MCDE_EXTSRC7CR_MULTIOVL_CTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7CR, MULTIOVL_CTRL, \
	MCDE_EXTSRC7CR_MULTIOVL_CTRL_##__x)
#define MCDE_EXTSRC7CR_MULTIOVL_CTRL(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7CR, MULTIOVL_CTRL, __x)
#define MCDE_EXTSRC7CR_FS_DIV_DISABLE_SHIFT 3
#define MCDE_EXTSRC7CR_FS_DIV_DISABLE_MASK 0x00000008
#define MCDE_EXTSRC7CR_FS_DIV_DISABLE(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7CR, FS_DIV_DISABLE, __x)
#define MCDE_EXTSRC7CR_FORCE_FS_DIV_SHIFT 4
#define MCDE_EXTSRC7CR_FORCE_FS_DIV_MASK 0x00000010
#define MCDE_EXTSRC7CR_FORCE_FS_DIV(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC7CR, FORCE_FS_DIV, __x)
#define MCDE_EXTSRC8CR 0x00000310
#define MCDE_EXTSRC8CR_SEL_MOD_SHIFT 0
#define MCDE_EXTSRC8CR_SEL_MOD_MASK 0x00000003
#define MCDE_EXTSRC8CR_SEL_MOD_EXTERNAL_SEL 0
#define MCDE_EXTSRC8CR_SEL_MOD_AUTO_TOGGLE 1
#define MCDE_EXTSRC8CR_SEL_MOD_SOFTWARE_SEL 2
#define MCDE_EXTSRC8CR_SEL_MOD_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8CR, SEL_MOD, MCDE_EXTSRC8CR_SEL_MOD_##__x)
#define MCDE_EXTSRC8CR_SEL_MOD(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8CR, SEL_MOD, __x)
#define MCDE_EXTSRC8CR_MULTIOVL_CTRL_SHIFT 2
#define MCDE_EXTSRC8CR_MULTIOVL_CTRL_MASK 0x00000004
#define MCDE_EXTSRC8CR_MULTIOVL_CTRL_ALL 0
#define MCDE_EXTSRC8CR_MULTIOVL_CTRL_PRIMARY 1
#define MCDE_EXTSRC8CR_MULTIOVL_CTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8CR, MULTIOVL_CTRL, \
	MCDE_EXTSRC8CR_MULTIOVL_CTRL_##__x)
#define MCDE_EXTSRC8CR_MULTIOVL_CTRL(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8CR, MULTIOVL_CTRL, __x)
#define MCDE_EXTSRC8CR_FS_DIV_DISABLE_SHIFT 3
#define MCDE_EXTSRC8CR_FS_DIV_DISABLE_MASK 0x00000008
#define MCDE_EXTSRC8CR_FS_DIV_DISABLE(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8CR, FS_DIV_DISABLE, __x)
#define MCDE_EXTSRC8CR_FORCE_FS_DIV_SHIFT 4
#define MCDE_EXTSRC8CR_FORCE_FS_DIV_MASK 0x00000010
#define MCDE_EXTSRC8CR_FORCE_FS_DIV(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC8CR, FORCE_FS_DIV, __x)
#define MCDE_EXTSRC9CR 0x00000330
#define MCDE_EXTSRC9CR_SEL_MOD_SHIFT 0
#define MCDE_EXTSRC9CR_SEL_MOD_MASK 0x00000003
#define MCDE_EXTSRC9CR_SEL_MOD_EXTERNAL_SEL 0
#define MCDE_EXTSRC9CR_SEL_MOD_AUTO_TOGGLE 1
#define MCDE_EXTSRC9CR_SEL_MOD_SOFTWARE_SEL 2
#define MCDE_EXTSRC9CR_SEL_MOD_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9CR, SEL_MOD, MCDE_EXTSRC9CR_SEL_MOD_##__x)
#define MCDE_EXTSRC9CR_SEL_MOD(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9CR, SEL_MOD, __x)
#define MCDE_EXTSRC9CR_MULTIOVL_CTRL_SHIFT 2
#define MCDE_EXTSRC9CR_MULTIOVL_CTRL_MASK 0x00000004
#define MCDE_EXTSRC9CR_MULTIOVL_CTRL_ALL 0
#define MCDE_EXTSRC9CR_MULTIOVL_CTRL_PRIMARY 1
#define MCDE_EXTSRC9CR_MULTIOVL_CTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9CR, MULTIOVL_CTRL, \
	MCDE_EXTSRC9CR_MULTIOVL_CTRL_##__x)
#define MCDE_EXTSRC9CR_MULTIOVL_CTRL(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9CR, MULTIOVL_CTRL, __x)
#define MCDE_EXTSRC9CR_FS_DIV_DISABLE_SHIFT 3
#define MCDE_EXTSRC9CR_FS_DIV_DISABLE_MASK 0x00000008
#define MCDE_EXTSRC9CR_FS_DIV_DISABLE(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9CR, FS_DIV_DISABLE, __x)
#define MCDE_EXTSRC9CR_FORCE_FS_DIV_SHIFT 4
#define MCDE_EXTSRC9CR_FORCE_FS_DIV_MASK 0x00000010
#define MCDE_EXTSRC9CR_FORCE_FS_DIV(__x) \
	MCDE_VAL2REG(MCDE_EXTSRC9CR, FORCE_FS_DIV, __x)
#define MCDE_OVL0CR 0x00000400
#define MCDE_OVL0CR_GROUPOFFSET 0x20
#define MCDE_OVL0CR_OVLEN_SHIFT 0
#define MCDE_OVL0CR_OVLEN_MASK 0x00000001
#define MCDE_OVL0CR_OVLEN(__x) \
	MCDE_VAL2REG(MCDE_OVL0CR, OVLEN, __x)
#define MCDE_OVL0CR_COLCCTRL_SHIFT 1
#define MCDE_OVL0CR_COLCCTRL_MASK 0x00000006
#define MCDE_OVL0CR_COLCCTRL_DISABLED 0
#define MCDE_OVL0CR_COLCCTRL_ENABLED_NO_SAT 1
#define MCDE_OVL0CR_COLCCTRL_ENABLED_SAT 2
#define MCDE_OVL0CR_COLCCTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL0CR, COLCCTRL, MCDE_OVL0CR_COLCCTRL_##__x)
#define MCDE_OVL0CR_COLCCTRL(__x) \
	MCDE_VAL2REG(MCDE_OVL0CR, COLCCTRL, __x)
#define MCDE_OVL0CR_CKEYGEN_SHIFT 3
#define MCDE_OVL0CR_CKEYGEN_MASK 0x00000008
#define MCDE_OVL0CR_CKEYGEN(__x) \
	MCDE_VAL2REG(MCDE_OVL0CR, CKEYGEN, __x)
#define MCDE_OVL0CR_ALPHAPMEN_SHIFT 4
#define MCDE_OVL0CR_ALPHAPMEN_MASK 0x00000010
#define MCDE_OVL0CR_ALPHAPMEN(__x) \
	MCDE_VAL2REG(MCDE_OVL0CR, ALPHAPMEN, __x)
#define MCDE_OVL0CR_OVLF_SHIFT 5
#define MCDE_OVL0CR_OVLF_MASK 0x00000020
#define MCDE_OVL0CR_OVLF(__x) \
	MCDE_VAL2REG(MCDE_OVL0CR, OVLF, __x)
#define MCDE_OVL0CR_OVLR_SHIFT 6
#define MCDE_OVL0CR_OVLR_MASK 0x00000040
#define MCDE_OVL0CR_OVLR(__x) \
	MCDE_VAL2REG(MCDE_OVL0CR, OVLR, __x)
#define MCDE_OVL0CR_OVLB_SHIFT 7
#define MCDE_OVL0CR_OVLB_MASK 0x00000080
#define MCDE_OVL0CR_OVLB(__x) \
	MCDE_VAL2REG(MCDE_OVL0CR, OVLB, __x)
#define MCDE_OVL0CR_FETCH_ROPC_SHIFT 8
#define MCDE_OVL0CR_FETCH_ROPC_MASK 0x0000FF00
#define MCDE_OVL0CR_FETCH_ROPC(__x) \
	MCDE_VAL2REG(MCDE_OVL0CR, FETCH_ROPC, __x)
#define MCDE_OVL0CR_STBPRIO_SHIFT 16
#define MCDE_OVL0CR_STBPRIO_MASK 0x000F0000
#define MCDE_OVL0CR_STBPRIO(__x) \
	MCDE_VAL2REG(MCDE_OVL0CR, STBPRIO, __x)
#define MCDE_OVL0CR_BURSTSIZE_SHIFT 20
#define MCDE_OVL0CR_BURSTSIZE_MASK 0x00F00000
#define MCDE_OVL0CR_BURSTSIZE_1W 0
#define MCDE_OVL0CR_BURSTSIZE_2W 1
#define MCDE_OVL0CR_BURSTSIZE_4W 2
#define MCDE_OVL0CR_BURSTSIZE_8W 3
#define MCDE_OVL0CR_BURSTSIZE_16W 4
#define MCDE_OVL0CR_BURSTSIZE_HW_1W 8
#define MCDE_OVL0CR_BURSTSIZE_HW_2W 9
#define MCDE_OVL0CR_BURSTSIZE_HW_4W 10
#define MCDE_OVL0CR_BURSTSIZE_HW_8W 11
#define MCDE_OVL0CR_BURSTSIZE_HW_16W 12
#define MCDE_OVL0CR_BURSTSIZE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL0CR, BURSTSIZE, MCDE_OVL0CR_BURSTSIZE_##__x)
#define MCDE_OVL0CR_BURSTSIZE(__x) \
	MCDE_VAL2REG(MCDE_OVL0CR, BURSTSIZE, __x)
#define MCDE_OVL0CR_MAXOUTSTANDING_SHIFT 24
#define MCDE_OVL0CR_MAXOUTSTANDING_MASK 0x0F000000
#define MCDE_OVL0CR_MAXOUTSTANDING_1_REQ 0
#define MCDE_OVL0CR_MAXOUTSTANDING_2_REQ 1
#define MCDE_OVL0CR_MAXOUTSTANDING_4_REQ 2
#define MCDE_OVL0CR_MAXOUTSTANDING_8_REQ 3
#define MCDE_OVL0CR_MAXOUTSTANDING_16_REQ 4
#define MCDE_OVL0CR_MAXOUTSTANDING_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL0CR, MAXOUTSTANDING, \
	MCDE_OVL0CR_MAXOUTSTANDING_##__x)
#define MCDE_OVL0CR_MAXOUTSTANDING(__x) \
	MCDE_VAL2REG(MCDE_OVL0CR, MAXOUTSTANDING, __x)
#define MCDE_OVL0CR_ROTBURSTSIZE_SHIFT 28
#define MCDE_OVL0CR_ROTBURSTSIZE_MASK 0xF0000000
#define MCDE_OVL0CR_ROTBURSTSIZE_1W 0
#define MCDE_OVL0CR_ROTBURSTSIZE_2W 1
#define MCDE_OVL0CR_ROTBURSTSIZE_4W 2
#define MCDE_OVL0CR_ROTBURSTSIZE_8W 3
#define MCDE_OVL0CR_ROTBURSTSIZE_16W 4
#define MCDE_OVL0CR_ROTBURSTSIZE_HW_1W 8
#define MCDE_OVL0CR_ROTBURSTSIZE_HW_2W 9
#define MCDE_OVL0CR_ROTBURSTSIZE_HW_4W 10
#define MCDE_OVL0CR_ROTBURSTSIZE_HW_8W 11
#define MCDE_OVL0CR_ROTBURSTSIZE_HW_16W 12
#define MCDE_OVL0CR_ROTBURSTSIZE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL0CR, ROTBURSTSIZE, MCDE_OVL0CR_ROTBURSTSIZE_##__x)
#define MCDE_OVL0CR_ROTBURSTSIZE(__x) \
	MCDE_VAL2REG(MCDE_OVL0CR, ROTBURSTSIZE, __x)
#define MCDE_OVL1CR 0x00000420
#define MCDE_OVL1CR_OVLEN_SHIFT 0
#define MCDE_OVL1CR_OVLEN_MASK 0x00000001
#define MCDE_OVL1CR_OVLEN(__x) \
	MCDE_VAL2REG(MCDE_OVL1CR, OVLEN, __x)
#define MCDE_OVL1CR_COLCCTRL_SHIFT 1
#define MCDE_OVL1CR_COLCCTRL_MASK 0x00000006
#define MCDE_OVL1CR_COLCCTRL_DISABLED 0
#define MCDE_OVL1CR_COLCCTRL_ENABLED_NO_SAT 1
#define MCDE_OVL1CR_COLCCTRL_ENABLED_SAT 2
#define MCDE_OVL1CR_COLCCTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL1CR, COLCCTRL, MCDE_OVL1CR_COLCCTRL_##__x)
#define MCDE_OVL1CR_COLCCTRL(__x) \
	MCDE_VAL2REG(MCDE_OVL1CR, COLCCTRL, __x)
#define MCDE_OVL1CR_CKEYGEN_SHIFT 3
#define MCDE_OVL1CR_CKEYGEN_MASK 0x00000008
#define MCDE_OVL1CR_CKEYGEN(__x) \
	MCDE_VAL2REG(MCDE_OVL1CR, CKEYGEN, __x)
#define MCDE_OVL1CR_ALPHAPMEN_SHIFT 4
#define MCDE_OVL1CR_ALPHAPMEN_MASK 0x00000010
#define MCDE_OVL1CR_ALPHAPMEN(__x) \
	MCDE_VAL2REG(MCDE_OVL1CR, ALPHAPMEN, __x)
#define MCDE_OVL1CR_OVLF_SHIFT 5
#define MCDE_OVL1CR_OVLF_MASK 0x00000020
#define MCDE_OVL1CR_OVLF(__x) \
	MCDE_VAL2REG(MCDE_OVL1CR, OVLF, __x)
#define MCDE_OVL1CR_OVLR_SHIFT 6
#define MCDE_OVL1CR_OVLR_MASK 0x00000040
#define MCDE_OVL1CR_OVLR(__x) \
	MCDE_VAL2REG(MCDE_OVL1CR, OVLR, __x)
#define MCDE_OVL1CR_OVLB_SHIFT 7
#define MCDE_OVL1CR_OVLB_MASK 0x00000080
#define MCDE_OVL1CR_OVLB(__x) \
	MCDE_VAL2REG(MCDE_OVL1CR, OVLB, __x)
#define MCDE_OVL1CR_FETCH_ROPC_SHIFT 8
#define MCDE_OVL1CR_FETCH_ROPC_MASK 0x0000FF00
#define MCDE_OVL1CR_FETCH_ROPC(__x) \
	MCDE_VAL2REG(MCDE_OVL1CR, FETCH_ROPC, __x)
#define MCDE_OVL1CR_STBPRIO_SHIFT 16
#define MCDE_OVL1CR_STBPRIO_MASK 0x000F0000
#define MCDE_OVL1CR_STBPRIO(__x) \
	MCDE_VAL2REG(MCDE_OVL1CR, STBPRIO, __x)
#define MCDE_OVL1CR_BURSTSIZE_SHIFT 20
#define MCDE_OVL1CR_BURSTSIZE_MASK 0x00F00000
#define MCDE_OVL1CR_BURSTSIZE_1W 0
#define MCDE_OVL1CR_BURSTSIZE_2W 1
#define MCDE_OVL1CR_BURSTSIZE_4W 2
#define MCDE_OVL1CR_BURSTSIZE_8W 3
#define MCDE_OVL1CR_BURSTSIZE_16W 4
#define MCDE_OVL1CR_BURSTSIZE_HW_1W 8
#define MCDE_OVL1CR_BURSTSIZE_HW_2W 9
#define MCDE_OVL1CR_BURSTSIZE_HW_4W 10
#define MCDE_OVL1CR_BURSTSIZE_HW_8W 11
#define MCDE_OVL1CR_BURSTSIZE_HW_16W 12
#define MCDE_OVL1CR_BURSTSIZE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL1CR, BURSTSIZE, MCDE_OVL1CR_BURSTSIZE_##__x)
#define MCDE_OVL1CR_BURSTSIZE(__x) \
	MCDE_VAL2REG(MCDE_OVL1CR, BURSTSIZE, __x)
#define MCDE_OVL1CR_MAXOUTSTANDING_SHIFT 24
#define MCDE_OVL1CR_MAXOUTSTANDING_MASK 0x0F000000
#define MCDE_OVL1CR_MAXOUTSTANDING_1_REQ 0
#define MCDE_OVL1CR_MAXOUTSTANDING_2_REQ 1
#define MCDE_OVL1CR_MAXOUTSTANDING_4_REQ 2
#define MCDE_OVL1CR_MAXOUTSTANDING_8_REQ 3
#define MCDE_OVL1CR_MAXOUTSTANDING_16_REQ 4
#define MCDE_OVL1CR_MAXOUTSTANDING_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL1CR, MAXOUTSTANDING, \
	MCDE_OVL1CR_MAXOUTSTANDING_##__x)
#define MCDE_OVL1CR_MAXOUTSTANDING(__x) \
	MCDE_VAL2REG(MCDE_OVL1CR, MAXOUTSTANDING, __x)
#define MCDE_OVL1CR_ROTBURSTSIZE_SHIFT 28
#define MCDE_OVL1CR_ROTBURSTSIZE_MASK 0xF0000000
#define MCDE_OVL1CR_ROTBURSTSIZE_1W 0
#define MCDE_OVL1CR_ROTBURSTSIZE_2W 1
#define MCDE_OVL1CR_ROTBURSTSIZE_4W 2
#define MCDE_OVL1CR_ROTBURSTSIZE_8W 3
#define MCDE_OVL1CR_ROTBURSTSIZE_16W 4
#define MCDE_OVL1CR_ROTBURSTSIZE_HW_1W 8
#define MCDE_OVL1CR_ROTBURSTSIZE_HW_2W 9
#define MCDE_OVL1CR_ROTBURSTSIZE_HW_4W 10
#define MCDE_OVL1CR_ROTBURSTSIZE_HW_8W 11
#define MCDE_OVL1CR_ROTBURSTSIZE_HW_16W 12
#define MCDE_OVL1CR_ROTBURSTSIZE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL1CR, ROTBURSTSIZE, MCDE_OVL1CR_ROTBURSTSIZE_##__x)
#define MCDE_OVL1CR_ROTBURSTSIZE(__x) \
	MCDE_VAL2REG(MCDE_OVL1CR, ROTBURSTSIZE, __x)
#define MCDE_OVL2CR 0x00000440
#define MCDE_OVL2CR_OVLEN_SHIFT 0
#define MCDE_OVL2CR_OVLEN_MASK 0x00000001
#define MCDE_OVL2CR_OVLEN(__x) \
	MCDE_VAL2REG(MCDE_OVL2CR, OVLEN, __x)
#define MCDE_OVL2CR_COLCCTRL_SHIFT 1
#define MCDE_OVL2CR_COLCCTRL_MASK 0x00000006
#define MCDE_OVL2CR_COLCCTRL_DISABLED 0
#define MCDE_OVL2CR_COLCCTRL_ENABLED_NO_SAT 1
#define MCDE_OVL2CR_COLCCTRL_ENABLED_SAT 2
#define MCDE_OVL2CR_COLCCTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL2CR, COLCCTRL, MCDE_OVL2CR_COLCCTRL_##__x)
#define MCDE_OVL2CR_COLCCTRL(__x) \
	MCDE_VAL2REG(MCDE_OVL2CR, COLCCTRL, __x)
#define MCDE_OVL2CR_CKEYGEN_SHIFT 3
#define MCDE_OVL2CR_CKEYGEN_MASK 0x00000008
#define MCDE_OVL2CR_CKEYGEN(__x) \
	MCDE_VAL2REG(MCDE_OVL2CR, CKEYGEN, __x)
#define MCDE_OVL2CR_ALPHAPMEN_SHIFT 4
#define MCDE_OVL2CR_ALPHAPMEN_MASK 0x00000010
#define MCDE_OVL2CR_ALPHAPMEN(__x) \
	MCDE_VAL2REG(MCDE_OVL2CR, ALPHAPMEN, __x)
#define MCDE_OVL2CR_OVLF_SHIFT 5
#define MCDE_OVL2CR_OVLF_MASK 0x00000020
#define MCDE_OVL2CR_OVLF(__x) \
	MCDE_VAL2REG(MCDE_OVL2CR, OVLF, __x)
#define MCDE_OVL2CR_OVLR_SHIFT 6
#define MCDE_OVL2CR_OVLR_MASK 0x00000040
#define MCDE_OVL2CR_OVLR(__x) \
	MCDE_VAL2REG(MCDE_OVL2CR, OVLR, __x)
#define MCDE_OVL2CR_OVLB_SHIFT 7
#define MCDE_OVL2CR_OVLB_MASK 0x00000080
#define MCDE_OVL2CR_OVLB(__x) \
	MCDE_VAL2REG(MCDE_OVL2CR, OVLB, __x)
#define MCDE_OVL2CR_FETCH_ROPC_SHIFT 8
#define MCDE_OVL2CR_FETCH_ROPC_MASK 0x0000FF00
#define MCDE_OVL2CR_FETCH_ROPC(__x) \
	MCDE_VAL2REG(MCDE_OVL2CR, FETCH_ROPC, __x)
#define MCDE_OVL2CR_STBPRIO_SHIFT 16
#define MCDE_OVL2CR_STBPRIO_MASK 0x000F0000
#define MCDE_OVL2CR_STBPRIO(__x) \
	MCDE_VAL2REG(MCDE_OVL2CR, STBPRIO, __x)
#define MCDE_OVL2CR_BURSTSIZE_SHIFT 20
#define MCDE_OVL2CR_BURSTSIZE_MASK 0x00F00000
#define MCDE_OVL2CR_BURSTSIZE_1W 0
#define MCDE_OVL2CR_BURSTSIZE_2W 1
#define MCDE_OVL2CR_BURSTSIZE_4W 2
#define MCDE_OVL2CR_BURSTSIZE_8W 3
#define MCDE_OVL2CR_BURSTSIZE_16W 4
#define MCDE_OVL2CR_BURSTSIZE_HW_1W 8
#define MCDE_OVL2CR_BURSTSIZE_HW_2W 9
#define MCDE_OVL2CR_BURSTSIZE_HW_4W 10
#define MCDE_OVL2CR_BURSTSIZE_HW_8W 11
#define MCDE_OVL2CR_BURSTSIZE_HW_16W 12
#define MCDE_OVL2CR_BURSTSIZE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL2CR, BURSTSIZE, MCDE_OVL2CR_BURSTSIZE_##__x)
#define MCDE_OVL2CR_BURSTSIZE(__x) \
	MCDE_VAL2REG(MCDE_OVL2CR, BURSTSIZE, __x)
#define MCDE_OVL2CR_MAXOUTSTANDING_SHIFT 24
#define MCDE_OVL2CR_MAXOUTSTANDING_MASK 0x0F000000
#define MCDE_OVL2CR_MAXOUTSTANDING_1_REQ 0
#define MCDE_OVL2CR_MAXOUTSTANDING_2_REQ 1
#define MCDE_OVL2CR_MAXOUTSTANDING_4_REQ 2
#define MCDE_OVL2CR_MAXOUTSTANDING_8_REQ 3
#define MCDE_OVL2CR_MAXOUTSTANDING_16_REQ 4
#define MCDE_OVL2CR_MAXOUTSTANDING_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL2CR, MAXOUTSTANDING, \
	MCDE_OVL2CR_MAXOUTSTANDING_##__x)
#define MCDE_OVL2CR_MAXOUTSTANDING(__x) \
	MCDE_VAL2REG(MCDE_OVL2CR, MAXOUTSTANDING, __x)
#define MCDE_OVL2CR_ROTBURSTSIZE_SHIFT 28
#define MCDE_OVL2CR_ROTBURSTSIZE_MASK 0xF0000000
#define MCDE_OVL2CR_ROTBURSTSIZE_1W 0
#define MCDE_OVL2CR_ROTBURSTSIZE_2W 1
#define MCDE_OVL2CR_ROTBURSTSIZE_4W 2
#define MCDE_OVL2CR_ROTBURSTSIZE_8W 3
#define MCDE_OVL2CR_ROTBURSTSIZE_16W 4
#define MCDE_OVL2CR_ROTBURSTSIZE_HW_1W 8
#define MCDE_OVL2CR_ROTBURSTSIZE_HW_2W 9
#define MCDE_OVL2CR_ROTBURSTSIZE_HW_4W 10
#define MCDE_OVL2CR_ROTBURSTSIZE_HW_8W 11
#define MCDE_OVL2CR_ROTBURSTSIZE_HW_16W 12
#define MCDE_OVL2CR_ROTBURSTSIZE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL2CR, ROTBURSTSIZE, MCDE_OVL2CR_ROTBURSTSIZE_##__x)
#define MCDE_OVL2CR_ROTBURSTSIZE(__x) \
	MCDE_VAL2REG(MCDE_OVL2CR, ROTBURSTSIZE, __x)
#define MCDE_OVL3CR 0x00000460
#define MCDE_OVL3CR_OVLEN_SHIFT 0
#define MCDE_OVL3CR_OVLEN_MASK 0x00000001
#define MCDE_OVL3CR_OVLEN(__x) \
	MCDE_VAL2REG(MCDE_OVL3CR, OVLEN, __x)
#define MCDE_OVL3CR_COLCCTRL_SHIFT 1
#define MCDE_OVL3CR_COLCCTRL_MASK 0x00000006
#define MCDE_OVL3CR_COLCCTRL_DISABLED 0
#define MCDE_OVL3CR_COLCCTRL_ENABLED_NO_SAT 1
#define MCDE_OVL3CR_COLCCTRL_ENABLED_SAT 2
#define MCDE_OVL3CR_COLCCTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL3CR, COLCCTRL, MCDE_OVL3CR_COLCCTRL_##__x)
#define MCDE_OVL3CR_COLCCTRL(__x) \
	MCDE_VAL2REG(MCDE_OVL3CR, COLCCTRL, __x)
#define MCDE_OVL3CR_CKEYGEN_SHIFT 3
#define MCDE_OVL3CR_CKEYGEN_MASK 0x00000008
#define MCDE_OVL3CR_CKEYGEN(__x) \
	MCDE_VAL2REG(MCDE_OVL3CR, CKEYGEN, __x)
#define MCDE_OVL3CR_ALPHAPMEN_SHIFT 4
#define MCDE_OVL3CR_ALPHAPMEN_MASK 0x00000010
#define MCDE_OVL3CR_ALPHAPMEN(__x) \
	MCDE_VAL2REG(MCDE_OVL3CR, ALPHAPMEN, __x)
#define MCDE_OVL3CR_OVLF_SHIFT 5
#define MCDE_OVL3CR_OVLF_MASK 0x00000020
#define MCDE_OVL3CR_OVLF(__x) \
	MCDE_VAL2REG(MCDE_OVL3CR, OVLF, __x)
#define MCDE_OVL3CR_OVLR_SHIFT 6
#define MCDE_OVL3CR_OVLR_MASK 0x00000040
#define MCDE_OVL3CR_OVLR(__x) \
	MCDE_VAL2REG(MCDE_OVL3CR, OVLR, __x)
#define MCDE_OVL3CR_OVLB_SHIFT 7
#define MCDE_OVL3CR_OVLB_MASK 0x00000080
#define MCDE_OVL3CR_OVLB(__x) \
	MCDE_VAL2REG(MCDE_OVL3CR, OVLB, __x)
#define MCDE_OVL3CR_FETCH_ROPC_SHIFT 8
#define MCDE_OVL3CR_FETCH_ROPC_MASK 0x0000FF00
#define MCDE_OVL3CR_FETCH_ROPC(__x) \
	MCDE_VAL2REG(MCDE_OVL3CR, FETCH_ROPC, __x)
#define MCDE_OVL3CR_STBPRIO_SHIFT 16
#define MCDE_OVL3CR_STBPRIO_MASK 0x000F0000
#define MCDE_OVL3CR_STBPRIO(__x) \
	MCDE_VAL2REG(MCDE_OVL3CR, STBPRIO, __x)
#define MCDE_OVL3CR_BURSTSIZE_SHIFT 20
#define MCDE_OVL3CR_BURSTSIZE_MASK 0x00F00000
#define MCDE_OVL3CR_BURSTSIZE_1W 0
#define MCDE_OVL3CR_BURSTSIZE_2W 1
#define MCDE_OVL3CR_BURSTSIZE_4W 2
#define MCDE_OVL3CR_BURSTSIZE_8W 3
#define MCDE_OVL3CR_BURSTSIZE_16W 4
#define MCDE_OVL3CR_BURSTSIZE_HW_1W 8
#define MCDE_OVL3CR_BURSTSIZE_HW_2W 9
#define MCDE_OVL3CR_BURSTSIZE_HW_4W 10
#define MCDE_OVL3CR_BURSTSIZE_HW_8W 11
#define MCDE_OVL3CR_BURSTSIZE_HW_16W 12
#define MCDE_OVL3CR_BURSTSIZE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL3CR, BURSTSIZE, MCDE_OVL3CR_BURSTSIZE_##__x)
#define MCDE_OVL3CR_BURSTSIZE(__x) \
	MCDE_VAL2REG(MCDE_OVL3CR, BURSTSIZE, __x)
#define MCDE_OVL3CR_MAXOUTSTANDING_SHIFT 24
#define MCDE_OVL3CR_MAXOUTSTANDING_MASK 0x0F000000
#define MCDE_OVL3CR_MAXOUTSTANDING_1_REQ 0
#define MCDE_OVL3CR_MAXOUTSTANDING_2_REQ 1
#define MCDE_OVL3CR_MAXOUTSTANDING_4_REQ 2
#define MCDE_OVL3CR_MAXOUTSTANDING_8_REQ 3
#define MCDE_OVL3CR_MAXOUTSTANDING_16_REQ 4
#define MCDE_OVL3CR_MAXOUTSTANDING_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL3CR, MAXOUTSTANDING, \
	MCDE_OVL3CR_MAXOUTSTANDING_##__x)
#define MCDE_OVL3CR_MAXOUTSTANDING(__x) \
	MCDE_VAL2REG(MCDE_OVL3CR, MAXOUTSTANDING, __x)
#define MCDE_OVL3CR_ROTBURSTSIZE_SHIFT 28
#define MCDE_OVL3CR_ROTBURSTSIZE_MASK 0xF0000000
#define MCDE_OVL3CR_ROTBURSTSIZE_1W 0
#define MCDE_OVL3CR_ROTBURSTSIZE_2W 1
#define MCDE_OVL3CR_ROTBURSTSIZE_4W 2
#define MCDE_OVL3CR_ROTBURSTSIZE_8W 3
#define MCDE_OVL3CR_ROTBURSTSIZE_16W 4
#define MCDE_OVL3CR_ROTBURSTSIZE_HW_1W 8
#define MCDE_OVL3CR_ROTBURSTSIZE_HW_2W 9
#define MCDE_OVL3CR_ROTBURSTSIZE_HW_4W 10
#define MCDE_OVL3CR_ROTBURSTSIZE_HW_8W 11
#define MCDE_OVL3CR_ROTBURSTSIZE_HW_16W 12
#define MCDE_OVL3CR_ROTBURSTSIZE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL3CR, ROTBURSTSIZE, MCDE_OVL3CR_ROTBURSTSIZE_##__x)
#define MCDE_OVL3CR_ROTBURSTSIZE(__x) \
	MCDE_VAL2REG(MCDE_OVL3CR, ROTBURSTSIZE, __x)
#define MCDE_OVL4CR 0x00000480
#define MCDE_OVL4CR_OVLEN_SHIFT 0
#define MCDE_OVL4CR_OVLEN_MASK 0x00000001
#define MCDE_OVL4CR_OVLEN(__x) \
	MCDE_VAL2REG(MCDE_OVL4CR, OVLEN, __x)
#define MCDE_OVL4CR_COLCCTRL_SHIFT 1
#define MCDE_OVL4CR_COLCCTRL_MASK 0x00000006
#define MCDE_OVL4CR_COLCCTRL_DISABLED 0
#define MCDE_OVL4CR_COLCCTRL_ENABLED_NO_SAT 1
#define MCDE_OVL4CR_COLCCTRL_ENABLED_SAT 2
#define MCDE_OVL4CR_COLCCTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL4CR, COLCCTRL, MCDE_OVL4CR_COLCCTRL_##__x)
#define MCDE_OVL4CR_COLCCTRL(__x) \
	MCDE_VAL2REG(MCDE_OVL4CR, COLCCTRL, __x)
#define MCDE_OVL4CR_CKEYGEN_SHIFT 3
#define MCDE_OVL4CR_CKEYGEN_MASK 0x00000008
#define MCDE_OVL4CR_CKEYGEN(__x) \
	MCDE_VAL2REG(MCDE_OVL4CR, CKEYGEN, __x)
#define MCDE_OVL4CR_ALPHAPMEN_SHIFT 4
#define MCDE_OVL4CR_ALPHAPMEN_MASK 0x00000010
#define MCDE_OVL4CR_ALPHAPMEN(__x) \
	MCDE_VAL2REG(MCDE_OVL4CR, ALPHAPMEN, __x)
#define MCDE_OVL4CR_OVLF_SHIFT 5
#define MCDE_OVL4CR_OVLF_MASK 0x00000020
#define MCDE_OVL4CR_OVLF(__x) \
	MCDE_VAL2REG(MCDE_OVL4CR, OVLF, __x)
#define MCDE_OVL4CR_OVLR_SHIFT 6
#define MCDE_OVL4CR_OVLR_MASK 0x00000040
#define MCDE_OVL4CR_OVLR(__x) \
	MCDE_VAL2REG(MCDE_OVL4CR, OVLR, __x)
#define MCDE_OVL4CR_OVLB_SHIFT 7
#define MCDE_OVL4CR_OVLB_MASK 0x00000080
#define MCDE_OVL4CR_OVLB(__x) \
	MCDE_VAL2REG(MCDE_OVL4CR, OVLB, __x)
#define MCDE_OVL4CR_FETCH_ROPC_SHIFT 8
#define MCDE_OVL4CR_FETCH_ROPC_MASK 0x0000FF00
#define MCDE_OVL4CR_FETCH_ROPC(__x) \
	MCDE_VAL2REG(MCDE_OVL4CR, FETCH_ROPC, __x)
#define MCDE_OVL4CR_STBPRIO_SHIFT 16
#define MCDE_OVL4CR_STBPRIO_MASK 0x000F0000
#define MCDE_OVL4CR_STBPRIO(__x) \
	MCDE_VAL2REG(MCDE_OVL4CR, STBPRIO, __x)
#define MCDE_OVL4CR_BURSTSIZE_SHIFT 20
#define MCDE_OVL4CR_BURSTSIZE_MASK 0x00F00000
#define MCDE_OVL4CR_BURSTSIZE_1W 0
#define MCDE_OVL4CR_BURSTSIZE_2W 1
#define MCDE_OVL4CR_BURSTSIZE_4W 2
#define MCDE_OVL4CR_BURSTSIZE_8W 3
#define MCDE_OVL4CR_BURSTSIZE_16W 4
#define MCDE_OVL4CR_BURSTSIZE_HW_1W 8
#define MCDE_OVL4CR_BURSTSIZE_HW_2W 9
#define MCDE_OVL4CR_BURSTSIZE_HW_4W 10
#define MCDE_OVL4CR_BURSTSIZE_HW_8W 11
#define MCDE_OVL4CR_BURSTSIZE_HW_16W 12
#define MCDE_OVL4CR_BURSTSIZE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL4CR, BURSTSIZE, MCDE_OVL4CR_BURSTSIZE_##__x)
#define MCDE_OVL4CR_BURSTSIZE(__x) \
	MCDE_VAL2REG(MCDE_OVL4CR, BURSTSIZE, __x)
#define MCDE_OVL4CR_MAXOUTSTANDING_SHIFT 24
#define MCDE_OVL4CR_MAXOUTSTANDING_MASK 0x0F000000
#define MCDE_OVL4CR_MAXOUTSTANDING_1_REQ 0
#define MCDE_OVL4CR_MAXOUTSTANDING_2_REQ 1
#define MCDE_OVL4CR_MAXOUTSTANDING_4_REQ 2
#define MCDE_OVL4CR_MAXOUTSTANDING_8_REQ 3
#define MCDE_OVL4CR_MAXOUTSTANDING_16_REQ 4
#define MCDE_OVL4CR_MAXOUTSTANDING_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL4CR, MAXOUTSTANDING, \
	MCDE_OVL4CR_MAXOUTSTANDING_##__x)
#define MCDE_OVL4CR_MAXOUTSTANDING(__x) \
	MCDE_VAL2REG(MCDE_OVL4CR, MAXOUTSTANDING, __x)
#define MCDE_OVL4CR_ROTBURSTSIZE_SHIFT 28
#define MCDE_OVL4CR_ROTBURSTSIZE_MASK 0xF0000000
#define MCDE_OVL4CR_ROTBURSTSIZE_1W 0
#define MCDE_OVL4CR_ROTBURSTSIZE_2W 1
#define MCDE_OVL4CR_ROTBURSTSIZE_4W 2
#define MCDE_OVL4CR_ROTBURSTSIZE_8W 3
#define MCDE_OVL4CR_ROTBURSTSIZE_16W 4
#define MCDE_OVL4CR_ROTBURSTSIZE_HW_1W 8
#define MCDE_OVL4CR_ROTBURSTSIZE_HW_2W 9
#define MCDE_OVL4CR_ROTBURSTSIZE_HW_4W 10
#define MCDE_OVL4CR_ROTBURSTSIZE_HW_8W 11
#define MCDE_OVL4CR_ROTBURSTSIZE_HW_16W 12
#define MCDE_OVL4CR_ROTBURSTSIZE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL4CR, ROTBURSTSIZE, MCDE_OVL4CR_ROTBURSTSIZE_##__x)
#define MCDE_OVL4CR_ROTBURSTSIZE(__x) \
	MCDE_VAL2REG(MCDE_OVL4CR, ROTBURSTSIZE, __x)
#define MCDE_OVL5CR 0x000004A0
#define MCDE_OVL5CR_OVLEN_SHIFT 0
#define MCDE_OVL5CR_OVLEN_MASK 0x00000001
#define MCDE_OVL5CR_OVLEN(__x) \
	MCDE_VAL2REG(MCDE_OVL5CR, OVLEN, __x)
#define MCDE_OVL5CR_COLCCTRL_SHIFT 1
#define MCDE_OVL5CR_COLCCTRL_MASK 0x00000006
#define MCDE_OVL5CR_COLCCTRL_DISABLED 0
#define MCDE_OVL5CR_COLCCTRL_ENABLED_NO_SAT 1
#define MCDE_OVL5CR_COLCCTRL_ENABLED_SAT 2
#define MCDE_OVL5CR_COLCCTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL5CR, COLCCTRL, MCDE_OVL5CR_COLCCTRL_##__x)
#define MCDE_OVL5CR_COLCCTRL(__x) \
	MCDE_VAL2REG(MCDE_OVL5CR, COLCCTRL, __x)
#define MCDE_OVL5CR_CKEYGEN_SHIFT 3
#define MCDE_OVL5CR_CKEYGEN_MASK 0x00000008
#define MCDE_OVL5CR_CKEYGEN(__x) \
	MCDE_VAL2REG(MCDE_OVL5CR, CKEYGEN, __x)
#define MCDE_OVL5CR_ALPHAPMEN_SHIFT 4
#define MCDE_OVL5CR_ALPHAPMEN_MASK 0x00000010
#define MCDE_OVL5CR_ALPHAPMEN(__x) \
	MCDE_VAL2REG(MCDE_OVL5CR, ALPHAPMEN, __x)
#define MCDE_OVL5CR_OVLF_SHIFT 5
#define MCDE_OVL5CR_OVLF_MASK 0x00000020
#define MCDE_OVL5CR_OVLF(__x) \
	MCDE_VAL2REG(MCDE_OVL5CR, OVLF, __x)
#define MCDE_OVL5CR_OVLR_SHIFT 6
#define MCDE_OVL5CR_OVLR_MASK 0x00000040
#define MCDE_OVL5CR_OVLR(__x) \
	MCDE_VAL2REG(MCDE_OVL5CR, OVLR, __x)
#define MCDE_OVL5CR_OVLB_SHIFT 7
#define MCDE_OVL5CR_OVLB_MASK 0x00000080
#define MCDE_OVL5CR_OVLB(__x) \
	MCDE_VAL2REG(MCDE_OVL5CR, OVLB, __x)
#define MCDE_OVL5CR_FETCH_ROPC_SHIFT 8
#define MCDE_OVL5CR_FETCH_ROPC_MASK 0x0000FF00
#define MCDE_OVL5CR_FETCH_ROPC(__x) \
	MCDE_VAL2REG(MCDE_OVL5CR, FETCH_ROPC, __x)
#define MCDE_OVL5CR_STBPRIO_SHIFT 16
#define MCDE_OVL5CR_STBPRIO_MASK 0x000F0000
#define MCDE_OVL5CR_STBPRIO(__x) \
	MCDE_VAL2REG(MCDE_OVL5CR, STBPRIO, __x)
#define MCDE_OVL5CR_BURSTSIZE_SHIFT 20
#define MCDE_OVL5CR_BURSTSIZE_MASK 0x00F00000
#define MCDE_OVL5CR_BURSTSIZE_1W 0
#define MCDE_OVL5CR_BURSTSIZE_2W 1
#define MCDE_OVL5CR_BURSTSIZE_4W 2
#define MCDE_OVL5CR_BURSTSIZE_8W 3
#define MCDE_OVL5CR_BURSTSIZE_16W 4
#define MCDE_OVL5CR_BURSTSIZE_HW_1W 8
#define MCDE_OVL5CR_BURSTSIZE_HW_2W 9
#define MCDE_OVL5CR_BURSTSIZE_HW_4W 10
#define MCDE_OVL5CR_BURSTSIZE_HW_8W 11
#define MCDE_OVL5CR_BURSTSIZE_HW_16W 12
#define MCDE_OVL5CR_BURSTSIZE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL5CR, BURSTSIZE, MCDE_OVL5CR_BURSTSIZE_##__x)
#define MCDE_OVL5CR_BURSTSIZE(__x) \
	MCDE_VAL2REG(MCDE_OVL5CR, BURSTSIZE, __x)
#define MCDE_OVL5CR_MAXOUTSTANDING_SHIFT 24
#define MCDE_OVL5CR_MAXOUTSTANDING_MASK 0x0F000000
#define MCDE_OVL5CR_MAXOUTSTANDING_1_REQ 0
#define MCDE_OVL5CR_MAXOUTSTANDING_2_REQ 1
#define MCDE_OVL5CR_MAXOUTSTANDING_4_REQ 2
#define MCDE_OVL5CR_MAXOUTSTANDING_8_REQ 3
#define MCDE_OVL5CR_MAXOUTSTANDING_16_REQ 4
#define MCDE_OVL5CR_MAXOUTSTANDING_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL5CR, MAXOUTSTANDING, \
	MCDE_OVL5CR_MAXOUTSTANDING_##__x)
#define MCDE_OVL5CR_MAXOUTSTANDING(__x) \
	MCDE_VAL2REG(MCDE_OVL5CR, MAXOUTSTANDING, __x)
#define MCDE_OVL5CR_ROTBURSTSIZE_SHIFT 28
#define MCDE_OVL5CR_ROTBURSTSIZE_MASK 0xF0000000
#define MCDE_OVL5CR_ROTBURSTSIZE_1W 0
#define MCDE_OVL5CR_ROTBURSTSIZE_2W 1
#define MCDE_OVL5CR_ROTBURSTSIZE_4W 2
#define MCDE_OVL5CR_ROTBURSTSIZE_8W 3
#define MCDE_OVL5CR_ROTBURSTSIZE_16W 4
#define MCDE_OVL5CR_ROTBURSTSIZE_HW_1W 8
#define MCDE_OVL5CR_ROTBURSTSIZE_HW_2W 9
#define MCDE_OVL5CR_ROTBURSTSIZE_HW_4W 10
#define MCDE_OVL5CR_ROTBURSTSIZE_HW_8W 11
#define MCDE_OVL5CR_ROTBURSTSIZE_HW_16W 12
#define MCDE_OVL5CR_ROTBURSTSIZE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL5CR, ROTBURSTSIZE, MCDE_OVL5CR_ROTBURSTSIZE_##__x)
#define MCDE_OVL5CR_ROTBURSTSIZE(__x) \
	MCDE_VAL2REG(MCDE_OVL5CR, ROTBURSTSIZE, __x)
#define MCDE_OVL0CONF 0x00000404
#define MCDE_OVL0CONF_GROUPOFFSET 0x20
#define MCDE_OVL0CONF_PPL_SHIFT 0
#define MCDE_OVL0CONF_PPL_MASK 0x000007FF
#define MCDE_OVL0CONF_PPL(__x) \
	MCDE_VAL2REG(MCDE_OVL0CONF, PPL, __x)
#define MCDE_OVL0CONF_EXTSRC_ID_SHIFT 11
#define MCDE_OVL0CONF_EXTSRC_ID_MASK 0x00007800
#define MCDE_OVL0CONF_EXTSRC_ID(__x) \
	MCDE_VAL2REG(MCDE_OVL0CONF, EXTSRC_ID, __x)
#define MCDE_OVL0CONF_LPF_SHIFT 16
#define MCDE_OVL0CONF_LPF_MASK 0x07FF0000
#define MCDE_OVL0CONF_LPF(__x) \
	MCDE_VAL2REG(MCDE_OVL0CONF, LPF, __x)
#define MCDE_OVL1CONF 0x00000424
#define MCDE_OVL1CONF_PPL_SHIFT 0
#define MCDE_OVL1CONF_PPL_MASK 0x000007FF
#define MCDE_OVL1CONF_PPL(__x) \
	MCDE_VAL2REG(MCDE_OVL1CONF, PPL, __x)
#define MCDE_OVL1CONF_EXTSRC_ID_SHIFT 11
#define MCDE_OVL1CONF_EXTSRC_ID_MASK 0x00007800
#define MCDE_OVL1CONF_EXTSRC_ID(__x) \
	MCDE_VAL2REG(MCDE_OVL1CONF, EXTSRC_ID, __x)
#define MCDE_OVL1CONF_LPF_SHIFT 16
#define MCDE_OVL1CONF_LPF_MASK 0x07FF0000
#define MCDE_OVL1CONF_LPF(__x) \
	MCDE_VAL2REG(MCDE_OVL1CONF, LPF, __x)
#define MCDE_OVL2CONF 0x00000444
#define MCDE_OVL2CONF_PPL_SHIFT 0
#define MCDE_OVL2CONF_PPL_MASK 0x000007FF
#define MCDE_OVL2CONF_PPL(__x) \
	MCDE_VAL2REG(MCDE_OVL2CONF, PPL, __x)
#define MCDE_OVL2CONF_EXTSRC_ID_SHIFT 11
#define MCDE_OVL2CONF_EXTSRC_ID_MASK 0x00007800
#define MCDE_OVL2CONF_EXTSRC_ID(__x) \
	MCDE_VAL2REG(MCDE_OVL2CONF, EXTSRC_ID, __x)
#define MCDE_OVL2CONF_LPF_SHIFT 16
#define MCDE_OVL2CONF_LPF_MASK 0x07FF0000
#define MCDE_OVL2CONF_LPF(__x) \
	MCDE_VAL2REG(MCDE_OVL2CONF, LPF, __x)
#define MCDE_OVL3CONF 0x00000464
#define MCDE_OVL3CONF_PPL_SHIFT 0
#define MCDE_OVL3CONF_PPL_MASK 0x000007FF
#define MCDE_OVL3CONF_PPL(__x) \
	MCDE_VAL2REG(MCDE_OVL3CONF, PPL, __x)
#define MCDE_OVL3CONF_EXTSRC_ID_SHIFT 11
#define MCDE_OVL3CONF_EXTSRC_ID_MASK 0x00007800
#define MCDE_OVL3CONF_EXTSRC_ID(__x) \
	MCDE_VAL2REG(MCDE_OVL3CONF, EXTSRC_ID, __x)
#define MCDE_OVL3CONF_LPF_SHIFT 16
#define MCDE_OVL3CONF_LPF_MASK 0x07FF0000
#define MCDE_OVL3CONF_LPF(__x) \
	MCDE_VAL2REG(MCDE_OVL3CONF, LPF, __x)
#define MCDE_OVL4CONF 0x00000484
#define MCDE_OVL4CONF_PPL_SHIFT 0
#define MCDE_OVL4CONF_PPL_MASK 0x000007FF
#define MCDE_OVL4CONF_PPL(__x) \
	MCDE_VAL2REG(MCDE_OVL4CONF, PPL, __x)
#define MCDE_OVL4CONF_EXTSRC_ID_SHIFT 11
#define MCDE_OVL4CONF_EXTSRC_ID_MASK 0x00007800
#define MCDE_OVL4CONF_EXTSRC_ID(__x) \
	MCDE_VAL2REG(MCDE_OVL4CONF, EXTSRC_ID, __x)
#define MCDE_OVL4CONF_LPF_SHIFT 16
#define MCDE_OVL4CONF_LPF_MASK 0x07FF0000
#define MCDE_OVL4CONF_LPF(__x) \
	MCDE_VAL2REG(MCDE_OVL4CONF, LPF, __x)
#define MCDE_OVL5CONF 0x000004A4
#define MCDE_OVL5CONF_PPL_SHIFT 0
#define MCDE_OVL5CONF_PPL_MASK 0x000007FF
#define MCDE_OVL5CONF_PPL(__x) \
	MCDE_VAL2REG(MCDE_OVL5CONF, PPL, __x)
#define MCDE_OVL5CONF_EXTSRC_ID_SHIFT 11
#define MCDE_OVL5CONF_EXTSRC_ID_MASK 0x00007800
#define MCDE_OVL5CONF_EXTSRC_ID(__x) \
	MCDE_VAL2REG(MCDE_OVL5CONF, EXTSRC_ID, __x)
#define MCDE_OVL5CONF_LPF_SHIFT 16
#define MCDE_OVL5CONF_LPF_MASK 0x07FF0000
#define MCDE_OVL5CONF_LPF(__x) \
	MCDE_VAL2REG(MCDE_OVL5CONF, LPF, __x)
#define MCDE_OVL0CONF2 0x00000408
#define MCDE_OVL0CONF2_GROUPOFFSET 0x20
#define MCDE_OVL0CONF2_BP_SHIFT 0
#define MCDE_OVL0CONF2_BP_MASK 0x00000001
#define MCDE_OVL0CONF2_BP_PER_PIXEL_ALPHA 0
#define MCDE_OVL0CONF2_BP_CONSTANT_ALPHA 1
#define MCDE_OVL0CONF2_BP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL0CONF2, BP, MCDE_OVL0CONF2_BP_##__x)
#define MCDE_OVL0CONF2_BP(__x) \
	MCDE_VAL2REG(MCDE_OVL0CONF2, BP, __x)
#define MCDE_OVL0CONF2_ALPHAVALUE_SHIFT 1
#define MCDE_OVL0CONF2_ALPHAVALUE_MASK 0x000001FE
#define MCDE_OVL0CONF2_ALPHAVALUE(__x) \
	MCDE_VAL2REG(MCDE_OVL0CONF2, ALPHAVALUE, __x)
#define MCDE_OVL0CONF2_OPQ_SHIFT 9
#define MCDE_OVL0CONF2_OPQ_MASK 0x00000200
#define MCDE_OVL0CONF2_OPQ(__x) \
	MCDE_VAL2REG(MCDE_OVL0CONF2, OPQ, __x)
#define MCDE_OVL0CONF2_PIXOFF_SHIFT 10
#define MCDE_OVL0CONF2_PIXOFF_MASK 0x0000FC00
#define MCDE_OVL0CONF2_PIXOFF(__x) \
	MCDE_VAL2REG(MCDE_OVL0CONF2, PIXOFF, __x)
#define MCDE_OVL0CONF2_PIXELFETCHERWATERMARKLEVEL_SHIFT 16
#define MCDE_OVL0CONF2_PIXELFETCHERWATERMARKLEVEL_MASK 0x1FFF0000
#define MCDE_OVL0CONF2_PIXELFETCHERWATERMARKLEVEL(__x) \
	MCDE_VAL2REG(MCDE_OVL0CONF2, PIXELFETCHERWATERMARKLEVEL, __x)
#define MCDE_OVL1CONF2 0x00000428
#define MCDE_OVL1CONF2_BP_SHIFT 0
#define MCDE_OVL1CONF2_BP_MASK 0x00000001
#define MCDE_OVL1CONF2_BP_PER_PIXEL_ALPHA 0
#define MCDE_OVL1CONF2_BP_CONSTANT_ALPHA 1
#define MCDE_OVL1CONF2_BP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL1CONF2, BP, MCDE_OVL1CONF2_BP_##__x)
#define MCDE_OVL1CONF2_BP(__x) \
	MCDE_VAL2REG(MCDE_OVL1CONF2, BP, __x)
#define MCDE_OVL1CONF2_ALPHAVALUE_SHIFT 1
#define MCDE_OVL1CONF2_ALPHAVALUE_MASK 0x000001FE
#define MCDE_OVL1CONF2_ALPHAVALUE(__x) \
	MCDE_VAL2REG(MCDE_OVL1CONF2, ALPHAVALUE, __x)
#define MCDE_OVL1CONF2_OPQ_SHIFT 9
#define MCDE_OVL1CONF2_OPQ_MASK 0x00000200
#define MCDE_OVL1CONF2_OPQ(__x) \
	MCDE_VAL2REG(MCDE_OVL1CONF2, OPQ, __x)
#define MCDE_OVL1CONF2_PIXOFF_SHIFT 10
#define MCDE_OVL1CONF2_PIXOFF_MASK 0x0000FC00
#define MCDE_OVL1CONF2_PIXOFF(__x) \
	MCDE_VAL2REG(MCDE_OVL1CONF2, PIXOFF, __x)
#define MCDE_OVL1CONF2_PIXELFETCHERWATERMARKLEVEL_SHIFT 16
#define MCDE_OVL1CONF2_PIXELFETCHERWATERMARKLEVEL_MASK 0x1FFF0000
#define MCDE_OVL1CONF2_PIXELFETCHERWATERMARKLEVEL(__x) \
	MCDE_VAL2REG(MCDE_OVL1CONF2, PIXELFETCHERWATERMARKLEVEL, __x)
#define MCDE_OVL2CONF2 0x00000448
#define MCDE_OVL2CONF2_BP_SHIFT 0
#define MCDE_OVL2CONF2_BP_MASK 0x00000001
#define MCDE_OVL2CONF2_BP_PER_PIXEL_ALPHA 0
#define MCDE_OVL2CONF2_BP_CONSTANT_ALPHA 1
#define MCDE_OVL2CONF2_BP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL2CONF2, BP, MCDE_OVL2CONF2_BP_##__x)
#define MCDE_OVL2CONF2_BP(__x) \
	MCDE_VAL2REG(MCDE_OVL2CONF2, BP, __x)
#define MCDE_OVL2CONF2_ALPHAVALUE_SHIFT 1
#define MCDE_OVL2CONF2_ALPHAVALUE_MASK 0x000001FE
#define MCDE_OVL2CONF2_ALPHAVALUE(__x) \
	MCDE_VAL2REG(MCDE_OVL2CONF2, ALPHAVALUE, __x)
#define MCDE_OVL2CONF2_OPQ_SHIFT 9
#define MCDE_OVL2CONF2_OPQ_MASK 0x00000200
#define MCDE_OVL2CONF2_OPQ(__x) \
	MCDE_VAL2REG(MCDE_OVL2CONF2, OPQ, __x)
#define MCDE_OVL2CONF2_PIXOFF_SHIFT 10
#define MCDE_OVL2CONF2_PIXOFF_MASK 0x0000FC00
#define MCDE_OVL2CONF2_PIXOFF(__x) \
	MCDE_VAL2REG(MCDE_OVL2CONF2, PIXOFF, __x)
#define MCDE_OVL2CONF2_PIXELFETCHERWATERMARKLEVEL_SHIFT 16
#define MCDE_OVL2CONF2_PIXELFETCHERWATERMARKLEVEL_MASK 0x1FFF0000
#define MCDE_OVL2CONF2_PIXELFETCHERWATERMARKLEVEL(__x) \
	MCDE_VAL2REG(MCDE_OVL2CONF2, PIXELFETCHERWATERMARKLEVEL, __x)
#define MCDE_OVL3CONF2 0x00000468
#define MCDE_OVL3CONF2_BP_SHIFT 0
#define MCDE_OVL3CONF2_BP_MASK 0x00000001
#define MCDE_OVL3CONF2_BP_PER_PIXEL_ALPHA 0
#define MCDE_OVL3CONF2_BP_CONSTANT_ALPHA 1
#define MCDE_OVL3CONF2_BP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL3CONF2, BP, MCDE_OVL3CONF2_BP_##__x)
#define MCDE_OVL3CONF2_BP(__x) \
	MCDE_VAL2REG(MCDE_OVL3CONF2, BP, __x)
#define MCDE_OVL3CONF2_ALPHAVALUE_SHIFT 1
#define MCDE_OVL3CONF2_ALPHAVALUE_MASK 0x000001FE
#define MCDE_OVL3CONF2_ALPHAVALUE(__x) \
	MCDE_VAL2REG(MCDE_OVL3CONF2, ALPHAVALUE, __x)
#define MCDE_OVL3CONF2_OPQ_SHIFT 9
#define MCDE_OVL3CONF2_OPQ_MASK 0x00000200
#define MCDE_OVL3CONF2_OPQ(__x) \
	MCDE_VAL2REG(MCDE_OVL3CONF2, OPQ, __x)
#define MCDE_OVL3CONF2_PIXOFF_SHIFT 10
#define MCDE_OVL3CONF2_PIXOFF_MASK 0x0000FC00
#define MCDE_OVL3CONF2_PIXOFF(__x) \
	MCDE_VAL2REG(MCDE_OVL3CONF2, PIXOFF, __x)
#define MCDE_OVL3CONF2_PIXELFETCHERWATERMARKLEVEL_SHIFT 16
#define MCDE_OVL3CONF2_PIXELFETCHERWATERMARKLEVEL_MASK 0x1FFF0000
#define MCDE_OVL3CONF2_PIXELFETCHERWATERMARKLEVEL(__x) \
	MCDE_VAL2REG(MCDE_OVL3CONF2, PIXELFETCHERWATERMARKLEVEL, __x)
#define MCDE_OVL4CONF2 0x00000488
#define MCDE_OVL4CONF2_BP_SHIFT 0
#define MCDE_OVL4CONF2_BP_MASK 0x00000001
#define MCDE_OVL4CONF2_BP_PER_PIXEL_ALPHA 0
#define MCDE_OVL4CONF2_BP_CONSTANT_ALPHA 1
#define MCDE_OVL4CONF2_BP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL4CONF2, BP, MCDE_OVL4CONF2_BP_##__x)
#define MCDE_OVL4CONF2_BP(__x) \
	MCDE_VAL2REG(MCDE_OVL4CONF2, BP, __x)
#define MCDE_OVL4CONF2_ALPHAVALUE_SHIFT 1
#define MCDE_OVL4CONF2_ALPHAVALUE_MASK 0x000001FE
#define MCDE_OVL4CONF2_ALPHAVALUE(__x) \
	MCDE_VAL2REG(MCDE_OVL4CONF2, ALPHAVALUE, __x)
#define MCDE_OVL4CONF2_OPQ_SHIFT 9
#define MCDE_OVL4CONF2_OPQ_MASK 0x00000200
#define MCDE_OVL4CONF2_OPQ(__x) \
	MCDE_VAL2REG(MCDE_OVL4CONF2, OPQ, __x)
#define MCDE_OVL4CONF2_PIXOFF_SHIFT 10
#define MCDE_OVL4CONF2_PIXOFF_MASK 0x0000FC00
#define MCDE_OVL4CONF2_PIXOFF(__x) \
	MCDE_VAL2REG(MCDE_OVL4CONF2, PIXOFF, __x)
#define MCDE_OVL4CONF2_PIXELFETCHERWATERMARKLEVEL_SHIFT 16
#define MCDE_OVL4CONF2_PIXELFETCHERWATERMARKLEVEL_MASK 0x1FFF0000
#define MCDE_OVL4CONF2_PIXELFETCHERWATERMARKLEVEL(__x) \
	MCDE_VAL2REG(MCDE_OVL4CONF2, PIXELFETCHERWATERMARKLEVEL, __x)
#define MCDE_OVL5CONF2 0x000004A8
#define MCDE_OVL5CONF2_BP_SHIFT 0
#define MCDE_OVL5CONF2_BP_MASK 0x00000001
#define MCDE_OVL5CONF2_BP_PER_PIXEL_ALPHA 0
#define MCDE_OVL5CONF2_BP_CONSTANT_ALPHA 1
#define MCDE_OVL5CONF2_BP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_OVL5CONF2, BP, MCDE_OVL5CONF2_BP_##__x)
#define MCDE_OVL5CONF2_BP(__x) \
	MCDE_VAL2REG(MCDE_OVL5CONF2, BP, __x)
#define MCDE_OVL5CONF2_ALPHAVALUE_SHIFT 1
#define MCDE_OVL5CONF2_ALPHAVALUE_MASK 0x000001FE
#define MCDE_OVL5CONF2_ALPHAVALUE(__x) \
	MCDE_VAL2REG(MCDE_OVL5CONF2, ALPHAVALUE, __x)
#define MCDE_OVL5CONF2_OPQ_SHIFT 9
#define MCDE_OVL5CONF2_OPQ_MASK 0x00000200
#define MCDE_OVL5CONF2_OPQ(__x) \
	MCDE_VAL2REG(MCDE_OVL5CONF2, OPQ, __x)
#define MCDE_OVL5CONF2_PIXOFF_SHIFT 10
#define MCDE_OVL5CONF2_PIXOFF_MASK 0x0000FC00
#define MCDE_OVL5CONF2_PIXOFF(__x) \
	MCDE_VAL2REG(MCDE_OVL5CONF2, PIXOFF, __x)
#define MCDE_OVL5CONF2_PIXELFETCHERWATERMARKLEVEL_SHIFT 16
#define MCDE_OVL5CONF2_PIXELFETCHERWATERMARKLEVEL_MASK 0x1FFF0000
#define MCDE_OVL5CONF2_PIXELFETCHERWATERMARKLEVEL(__x) \
	MCDE_VAL2REG(MCDE_OVL5CONF2, PIXELFETCHERWATERMARKLEVEL, __x)
#define MCDE_OVL0LJINC 0x0000040C
#define MCDE_OVL0LJINC_GROUPOFFSET 0x20
#define MCDE_OVL0LJINC_LJINC_SHIFT 0
#define MCDE_OVL0LJINC_LJINC_MASK 0xFFFFFFFF
#define MCDE_OVL0LJINC_LJINC(__x) \
	MCDE_VAL2REG(MCDE_OVL0LJINC, LJINC, __x)
#define MCDE_OVL1LJINC 0x0000042C
#define MCDE_OVL1LJINC_LJINC_SHIFT 0
#define MCDE_OVL1LJINC_LJINC_MASK 0xFFFFFFFF
#define MCDE_OVL1LJINC_LJINC(__x) \
	MCDE_VAL2REG(MCDE_OVL1LJINC, LJINC, __x)
#define MCDE_OVL2LJINC 0x0000044C
#define MCDE_OVL2LJINC_LJINC_SHIFT 0
#define MCDE_OVL2LJINC_LJINC_MASK 0xFFFFFFFF
#define MCDE_OVL2LJINC_LJINC(__x) \
	MCDE_VAL2REG(MCDE_OVL2LJINC, LJINC, __x)
#define MCDE_OVL3LJINC 0x0000046C
#define MCDE_OVL3LJINC_LJINC_SHIFT 0
#define MCDE_OVL3LJINC_LJINC_MASK 0xFFFFFFFF
#define MCDE_OVL3LJINC_LJINC(__x) \
	MCDE_VAL2REG(MCDE_OVL3LJINC, LJINC, __x)
#define MCDE_OVL4LJINC 0x0000048C
#define MCDE_OVL4LJINC_LJINC_SHIFT 0
#define MCDE_OVL4LJINC_LJINC_MASK 0xFFFFFFFF
#define MCDE_OVL4LJINC_LJINC(__x) \
	MCDE_VAL2REG(MCDE_OVL4LJINC, LJINC, __x)
#define MCDE_OVL5LJINC 0x000004AC
#define MCDE_OVL5LJINC_LJINC_SHIFT 0
#define MCDE_OVL5LJINC_LJINC_MASK 0xFFFFFFFF
#define MCDE_OVL5LJINC_LJINC(__x) \
	MCDE_VAL2REG(MCDE_OVL5LJINC, LJINC, __x)
#define MCDE_OVL0CROP 0x00000410
#define MCDE_OVL0CROP_GROUPOFFSET 0x20
#define MCDE_OVL0CROP_TMRGN_SHIFT 0
#define MCDE_OVL0CROP_TMRGN_MASK 0x003FFFFF
#define MCDE_OVL0CROP_TMRGN(__x) \
	MCDE_VAL2REG(MCDE_OVL0CROP, TMRGN, __x)
#define MCDE_OVL0CROP_LMRGN_SHIFT 22
#define MCDE_OVL0CROP_LMRGN_MASK 0xFFC00000
#define MCDE_OVL0CROP_LMRGN(__x) \
	MCDE_VAL2REG(MCDE_OVL0CROP, LMRGN, __x)
#define MCDE_OVL1CROP 0x00000430
#define MCDE_OVL1CROP_TMRGN_SHIFT 0
#define MCDE_OVL1CROP_TMRGN_MASK 0x003FFFFF
#define MCDE_OVL1CROP_TMRGN(__x) \
	MCDE_VAL2REG(MCDE_OVL1CROP, TMRGN, __x)
#define MCDE_OVL1CROP_LMRGN_SHIFT 22
#define MCDE_OVL1CROP_LMRGN_MASK 0xFFC00000
#define MCDE_OVL1CROP_LMRGN(__x) \
	MCDE_VAL2REG(MCDE_OVL1CROP, LMRGN, __x)
#define MCDE_OVL2CROP 0x00000450
#define MCDE_OVL2CROP_TMRGN_SHIFT 0
#define MCDE_OVL2CROP_TMRGN_MASK 0x003FFFFF
#define MCDE_OVL2CROP_TMRGN(__x) \
	MCDE_VAL2REG(MCDE_OVL2CROP, TMRGN, __x)
#define MCDE_OVL2CROP_LMRGN_SHIFT 22
#define MCDE_OVL2CROP_LMRGN_MASK 0xFFC00000
#define MCDE_OVL2CROP_LMRGN(__x) \
	MCDE_VAL2REG(MCDE_OVL2CROP, LMRGN, __x)
#define MCDE_OVL3CROP 0x00000470
#define MCDE_OVL3CROP_TMRGN_SHIFT 0
#define MCDE_OVL3CROP_TMRGN_MASK 0x003FFFFF
#define MCDE_OVL3CROP_TMRGN(__x) \
	MCDE_VAL2REG(MCDE_OVL3CROP, TMRGN, __x)
#define MCDE_OVL3CROP_LMRGN_SHIFT 22
#define MCDE_OVL3CROP_LMRGN_MASK 0xFFC00000
#define MCDE_OVL3CROP_LMRGN(__x) \
	MCDE_VAL2REG(MCDE_OVL3CROP, LMRGN, __x)
#define MCDE_OVL4CROP 0x00000490
#define MCDE_OVL4CROP_TMRGN_SHIFT 0
#define MCDE_OVL4CROP_TMRGN_MASK 0x003FFFFF
#define MCDE_OVL4CROP_TMRGN(__x) \
	MCDE_VAL2REG(MCDE_OVL4CROP, TMRGN, __x)
#define MCDE_OVL4CROP_LMRGN_SHIFT 22
#define MCDE_OVL4CROP_LMRGN_MASK 0xFFC00000
#define MCDE_OVL4CROP_LMRGN(__x) \
	MCDE_VAL2REG(MCDE_OVL4CROP, LMRGN, __x)
#define MCDE_OVL5CROP 0x000004B0
#define MCDE_OVL5CROP_TMRGN_SHIFT 0
#define MCDE_OVL5CROP_TMRGN_MASK 0x003FFFFF
#define MCDE_OVL5CROP_TMRGN(__x) \
	MCDE_VAL2REG(MCDE_OVL5CROP, TMRGN, __x)
#define MCDE_OVL5CROP_LMRGN_SHIFT 22
#define MCDE_OVL5CROP_LMRGN_MASK 0xFFC00000
#define MCDE_OVL5CROP_LMRGN(__x) \
	MCDE_VAL2REG(MCDE_OVL5CROP, LMRGN, __x)
#define MCDE_OVL0COMP 0x00000414
#define MCDE_OVL0COMP_GROUPOFFSET 0x20
#define MCDE_OVL0COMP_XPOS_SHIFT 0
#define MCDE_OVL0COMP_XPOS_MASK 0x000007FF
#define MCDE_OVL0COMP_XPOS(__x) \
	MCDE_VAL2REG(MCDE_OVL0COMP, XPOS, __x)
#define MCDE_OVL0COMP_CH_ID_SHIFT 11
#define MCDE_OVL0COMP_CH_ID_MASK 0x00007800
#define MCDE_OVL0COMP_CH_ID(__x) \
	MCDE_VAL2REG(MCDE_OVL0COMP, CH_ID, __x)
#define MCDE_OVL0COMP_YPOS_SHIFT 16
#define MCDE_OVL0COMP_YPOS_MASK 0x07FF0000
#define MCDE_OVL0COMP_YPOS(__x) \
	MCDE_VAL2REG(MCDE_OVL0COMP, YPOS, __x)
#define MCDE_OVL0COMP_Z_SHIFT 27
#define MCDE_OVL0COMP_Z_MASK 0x78000000
#define MCDE_OVL0COMP_Z(__x) \
	MCDE_VAL2REG(MCDE_OVL0COMP, Z, __x)
#define MCDE_OVL1COMP 0x00000434
#define MCDE_OVL1COMP_XPOS_SHIFT 0
#define MCDE_OVL1COMP_XPOS_MASK 0x000007FF
#define MCDE_OVL1COMP_XPOS(__x) \
	MCDE_VAL2REG(MCDE_OVL1COMP, XPOS, __x)
#define MCDE_OVL1COMP_CH_ID_SHIFT 11
#define MCDE_OVL1COMP_CH_ID_MASK 0x00007800
#define MCDE_OVL1COMP_CH_ID(__x) \
	MCDE_VAL2REG(MCDE_OVL1COMP, CH_ID, __x)
#define MCDE_OVL1COMP_YPOS_SHIFT 16
#define MCDE_OVL1COMP_YPOS_MASK 0x07FF0000
#define MCDE_OVL1COMP_YPOS(__x) \
	MCDE_VAL2REG(MCDE_OVL1COMP, YPOS, __x)
#define MCDE_OVL1COMP_Z_SHIFT 27
#define MCDE_OVL1COMP_Z_MASK 0x78000000
#define MCDE_OVL1COMP_Z(__x) \
	MCDE_VAL2REG(MCDE_OVL1COMP, Z, __x)
#define MCDE_OVL2COMP 0x00000454
#define MCDE_OVL2COMP_XPOS_SHIFT 0
#define MCDE_OVL2COMP_XPOS_MASK 0x000007FF
#define MCDE_OVL2COMP_XPOS(__x) \
	MCDE_VAL2REG(MCDE_OVL2COMP, XPOS, __x)
#define MCDE_OVL2COMP_CH_ID_SHIFT 11
#define MCDE_OVL2COMP_CH_ID_MASK 0x00007800
#define MCDE_OVL2COMP_CH_ID(__x) \
	MCDE_VAL2REG(MCDE_OVL2COMP, CH_ID, __x)
#define MCDE_OVL2COMP_YPOS_SHIFT 16
#define MCDE_OVL2COMP_YPOS_MASK 0x07FF0000
#define MCDE_OVL2COMP_YPOS(__x) \
	MCDE_VAL2REG(MCDE_OVL2COMP, YPOS, __x)
#define MCDE_OVL2COMP_Z_SHIFT 27
#define MCDE_OVL2COMP_Z_MASK 0x78000000
#define MCDE_OVL2COMP_Z(__x) \
	MCDE_VAL2REG(MCDE_OVL2COMP, Z, __x)
#define MCDE_OVL3COMP 0x00000474
#define MCDE_OVL3COMP_XPOS_SHIFT 0
#define MCDE_OVL3COMP_XPOS_MASK 0x000007FF
#define MCDE_OVL3COMP_XPOS(__x) \
	MCDE_VAL2REG(MCDE_OVL3COMP, XPOS, __x)
#define MCDE_OVL3COMP_CH_ID_SHIFT 11
#define MCDE_OVL3COMP_CH_ID_MASK 0x00007800
#define MCDE_OVL3COMP_CH_ID(__x) \
	MCDE_VAL2REG(MCDE_OVL3COMP, CH_ID, __x)
#define MCDE_OVL3COMP_YPOS_SHIFT 16
#define MCDE_OVL3COMP_YPOS_MASK 0x07FF0000
#define MCDE_OVL3COMP_YPOS(__x) \
	MCDE_VAL2REG(MCDE_OVL3COMP, YPOS, __x)
#define MCDE_OVL3COMP_Z_SHIFT 27
#define MCDE_OVL3COMP_Z_MASK 0x78000000
#define MCDE_OVL3COMP_Z(__x) \
	MCDE_VAL2REG(MCDE_OVL3COMP, Z, __x)
#define MCDE_OVL4COMP 0x00000494
#define MCDE_OVL4COMP_XPOS_SHIFT 0
#define MCDE_OVL4COMP_XPOS_MASK 0x000007FF
#define MCDE_OVL4COMP_XPOS(__x) \
	MCDE_VAL2REG(MCDE_OVL4COMP, XPOS, __x)
#define MCDE_OVL4COMP_CH_ID_SHIFT 11
#define MCDE_OVL4COMP_CH_ID_MASK 0x00007800
#define MCDE_OVL4COMP_CH_ID(__x) \
	MCDE_VAL2REG(MCDE_OVL4COMP, CH_ID, __x)
#define MCDE_OVL4COMP_YPOS_SHIFT 16
#define MCDE_OVL4COMP_YPOS_MASK 0x07FF0000
#define MCDE_OVL4COMP_YPOS(__x) \
	MCDE_VAL2REG(MCDE_OVL4COMP, YPOS, __x)
#define MCDE_OVL4COMP_Z_SHIFT 27
#define MCDE_OVL4COMP_Z_MASK 0x78000000
#define MCDE_OVL4COMP_Z(__x) \
	MCDE_VAL2REG(MCDE_OVL4COMP, Z, __x)
#define MCDE_OVL5COMP 0x000004B4
#define MCDE_OVL5COMP_XPOS_SHIFT 0
#define MCDE_OVL5COMP_XPOS_MASK 0x000007FF
#define MCDE_OVL5COMP_XPOS(__x) \
	MCDE_VAL2REG(MCDE_OVL5COMP, XPOS, __x)
#define MCDE_OVL5COMP_CH_ID_SHIFT 11
#define MCDE_OVL5COMP_CH_ID_MASK 0x00007800
#define MCDE_OVL5COMP_CH_ID(__x) \
	MCDE_VAL2REG(MCDE_OVL5COMP, CH_ID, __x)
#define MCDE_OVL5COMP_YPOS_SHIFT 16
#define MCDE_OVL5COMP_YPOS_MASK 0x07FF0000
#define MCDE_OVL5COMP_YPOS(__x) \
	MCDE_VAL2REG(MCDE_OVL5COMP, YPOS, __x)
#define MCDE_OVL5COMP_Z_SHIFT 27
#define MCDE_OVL5COMP_Z_MASK 0x78000000
#define MCDE_OVL5COMP_Z(__x) \
	MCDE_VAL2REG(MCDE_OVL5COMP, Z, __x)
#define MCDE_CHNL0CONF 0x00000600
#define MCDE_CHNL0CONF_GROUPOFFSET 0x20
#define MCDE_CHNL0CONF_PPL_SHIFT 0
#define MCDE_CHNL0CONF_PPL_MASK 0x000007FF
#define MCDE_CHNL0CONF_PPL(__x) \
	MCDE_VAL2REG(MCDE_CHNL0CONF, PPL, __x)
#define MCDE_CHNL0CONF_LPF_SHIFT 16
#define MCDE_CHNL0CONF_LPF_MASK 0x07FF0000
#define MCDE_CHNL0CONF_LPF(__x) \
	MCDE_VAL2REG(MCDE_CHNL0CONF, LPF, __x)
#define MCDE_CHNL1CONF 0x00000620
#define MCDE_CHNL1CONF_PPL_SHIFT 0
#define MCDE_CHNL1CONF_PPL_MASK 0x000007FF
#define MCDE_CHNL1CONF_PPL(__x) \
	MCDE_VAL2REG(MCDE_CHNL1CONF, PPL, __x)
#define MCDE_CHNL1CONF_LPF_SHIFT 16
#define MCDE_CHNL1CONF_LPF_MASK 0x07FF0000
#define MCDE_CHNL1CONF_LPF(__x) \
	MCDE_VAL2REG(MCDE_CHNL1CONF, LPF, __x)
#define MCDE_CHNL2CONF 0x00000640
#define MCDE_CHNL2CONF_PPL_SHIFT 0
#define MCDE_CHNL2CONF_PPL_MASK 0x000007FF
#define MCDE_CHNL2CONF_PPL(__x) \
	MCDE_VAL2REG(MCDE_CHNL2CONF, PPL, __x)
#define MCDE_CHNL2CONF_LPF_SHIFT 16
#define MCDE_CHNL2CONF_LPF_MASK 0x07FF0000
#define MCDE_CHNL2CONF_LPF(__x) \
	MCDE_VAL2REG(MCDE_CHNL2CONF, LPF, __x)
#define MCDE_CHNL3CONF 0x00000660
#define MCDE_CHNL3CONF_PPL_SHIFT 0
#define MCDE_CHNL3CONF_PPL_MASK 0x000007FF
#define MCDE_CHNL3CONF_PPL(__x) \
	MCDE_VAL2REG(MCDE_CHNL3CONF, PPL, __x)
#define MCDE_CHNL3CONF_LPF_SHIFT 16
#define MCDE_CHNL3CONF_LPF_MASK 0x07FF0000
#define MCDE_CHNL3CONF_LPF(__x) \
	MCDE_VAL2REG(MCDE_CHNL3CONF, LPF, __x)
#define MCDE_CHNL0STAT 0x00000604
#define MCDE_CHNL0STAT_GROUPOFFSET 0x20
#define MCDE_CHNL0STAT_CHNLRD_SHIFT 0
#define MCDE_CHNL0STAT_CHNLRD_MASK 0x00000001
#define MCDE_CHNL0STAT_CHNLRD(__x) \
	MCDE_VAL2REG(MCDE_CHNL0STAT, CHNLRD, __x)
#define MCDE_CHNL0STAT_CHNLA_SHIFT 1
#define MCDE_CHNL0STAT_CHNLA_MASK 0x00000002
#define MCDE_CHNL0STAT_CHNLA(__x) \
	MCDE_VAL2REG(MCDE_CHNL0STAT, CHNLA, __x)
#define MCDE_CHNL0STAT_CHNLBLBCKGND_EN_SHIFT 16
#define MCDE_CHNL0STAT_CHNLBLBCKGND_EN_MASK 0x00010000
#define MCDE_CHNL0STAT_CHNLBLBCKGND_EN(__x) \
	MCDE_VAL2REG(MCDE_CHNL0STAT, CHNLBLBCKGND_EN, __x)
#define MCDE_CHNL1STAT 0x00000624
#define MCDE_CHNL1STAT_CHNLRD_SHIFT 0
#define MCDE_CHNL1STAT_CHNLRD_MASK 0x00000001
#define MCDE_CHNL1STAT_CHNLRD(__x) \
	MCDE_VAL2REG(MCDE_CHNL1STAT, CHNLRD, __x)
#define MCDE_CHNL1STAT_CHNLA_SHIFT 1
#define MCDE_CHNL1STAT_CHNLA_MASK 0x00000002
#define MCDE_CHNL1STAT_CHNLA(__x) \
	MCDE_VAL2REG(MCDE_CHNL1STAT, CHNLA, __x)
#define MCDE_CHNL1STAT_CHNLBLBCKGND_EN_SHIFT 16
#define MCDE_CHNL1STAT_CHNLBLBCKGND_EN_MASK 0x00010000
#define MCDE_CHNL1STAT_CHNLBLBCKGND_EN(__x) \
	MCDE_VAL2REG(MCDE_CHNL1STAT, CHNLBLBCKGND_EN, __x)
#define MCDE_CHNL2STAT 0x00000644
#define MCDE_CHNL2STAT_CHNLRD_SHIFT 0
#define MCDE_CHNL2STAT_CHNLRD_MASK 0x00000001
#define MCDE_CHNL2STAT_CHNLRD(__x) \
	MCDE_VAL2REG(MCDE_CHNL2STAT, CHNLRD, __x)
#define MCDE_CHNL2STAT_CHNLA_SHIFT 1
#define MCDE_CHNL2STAT_CHNLA_MASK 0x00000002
#define MCDE_CHNL2STAT_CHNLA(__x) \
	MCDE_VAL2REG(MCDE_CHNL2STAT, CHNLA, __x)
#define MCDE_CHNL2STAT_CHNLBLBCKGND_EN_SHIFT 16
#define MCDE_CHNL2STAT_CHNLBLBCKGND_EN_MASK 0x00010000
#define MCDE_CHNL2STAT_CHNLBLBCKGND_EN(__x) \
	MCDE_VAL2REG(MCDE_CHNL2STAT, CHNLBLBCKGND_EN, __x)
#define MCDE_CHNL3STAT 0x00000664
#define MCDE_CHNL3STAT_CHNLRD_SHIFT 0
#define MCDE_CHNL3STAT_CHNLRD_MASK 0x00000001
#define MCDE_CHNL3STAT_CHNLRD(__x) \
	MCDE_VAL2REG(MCDE_CHNL3STAT, CHNLRD, __x)
#define MCDE_CHNL3STAT_CHNLA_SHIFT 1
#define MCDE_CHNL3STAT_CHNLA_MASK 0x00000002
#define MCDE_CHNL3STAT_CHNLA(__x) \
	MCDE_VAL2REG(MCDE_CHNL3STAT, CHNLA, __x)
#define MCDE_CHNL3STAT_CHNLBLBCKGND_EN_SHIFT 16
#define MCDE_CHNL3STAT_CHNLBLBCKGND_EN_MASK 0x00010000
#define MCDE_CHNL3STAT_CHNLBLBCKGND_EN(__x) \
	MCDE_VAL2REG(MCDE_CHNL3STAT, CHNLBLBCKGND_EN, __x)
#define MCDE_CHNL0SYNCHMOD 0x00000608
#define MCDE_CHNL0SYNCHMOD_GROUPOFFSET 0x20
#define MCDE_CHNL0SYNCHMOD_SRC_SYNCH_SHIFT 0
#define MCDE_CHNL0SYNCHMOD_SRC_SYNCH_MASK 0x00000003
#define MCDE_CHNL0SYNCHMOD_SRC_SYNCH_OUTPUT 0
#define MCDE_CHNL0SYNCHMOD_SRC_SYNCH_AUTO 1
#define MCDE_CHNL0SYNCHMOD_SRC_SYNCH_SOFTWARE 2
#define MCDE_CHNL0SYNCHMOD_SRC_SYNCH_EXTERNAL 3
#define MCDE_CHNL0SYNCHMOD_SRC_SYNCH_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CHNL0SYNCHMOD, SRC_SYNCH, \
	MCDE_CHNL0SYNCHMOD_SRC_SYNCH_##__x)
#define MCDE_CHNL0SYNCHMOD_SRC_SYNCH(__x) \
	MCDE_VAL2REG(MCDE_CHNL0SYNCHMOD, SRC_SYNCH, __x)
#define MCDE_CHNL0SYNCHMOD_OUT_SYNCH_SRC_SHIFT 2
#define MCDE_CHNL0SYNCHMOD_OUT_SYNCH_SRC_MASK 0x0000001C
#define MCDE_CHNL0SYNCHMOD_OUT_SYNCH_SRC_FORMATTER 0
#define MCDE_CHNL0SYNCHMOD_OUT_SYNCH_SRC_VSYNC0 1
#define MCDE_CHNL0SYNCHMOD_OUT_SYNCH_SRC_VSYNC1 2
#define MCDE_CHNL0SYNCHMOD_OUT_SYNCH_SRC_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CHNL0SYNCHMOD, OUT_SYNCH_SRC, \
	MCDE_CHNL0SYNCHMOD_OUT_SYNCH_SRC_##__x)
#define MCDE_CHNL0SYNCHMOD_OUT_SYNCH_SRC(__x) \
	MCDE_VAL2REG(MCDE_CHNL0SYNCHMOD, OUT_SYNCH_SRC, __x)
#define MCDE_CHNL1SYNCHMOD 0x00000628
#define MCDE_CHNL1SYNCHMOD_SRC_SYNCH_SHIFT 0
#define MCDE_CHNL1SYNCHMOD_SRC_SYNCH_MASK 0x00000003
#define MCDE_CHNL1SYNCHMOD_SRC_SYNCH_OUTPUT 0
#define MCDE_CHNL1SYNCHMOD_SRC_SYNCH_AUTO 1
#define MCDE_CHNL1SYNCHMOD_SRC_SYNCH_SOFTWARE 2
#define MCDE_CHNL1SYNCHMOD_SRC_SYNCH_EXTERNAL 3
#define MCDE_CHNL1SYNCHMOD_SRC_SYNCH_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CHNL1SYNCHMOD, SRC_SYNCH, \
	MCDE_CHNL1SYNCHMOD_SRC_SYNCH_##__x)
#define MCDE_CHNL1SYNCHMOD_SRC_SYNCH(__x) \
	MCDE_VAL2REG(MCDE_CHNL1SYNCHMOD, SRC_SYNCH, __x)
#define MCDE_CHNL1SYNCHMOD_OUT_SYNCH_SRC_SHIFT 2
#define MCDE_CHNL1SYNCHMOD_OUT_SYNCH_SRC_MASK 0x0000001C
#define MCDE_CHNL1SYNCHMOD_OUT_SYNCH_SRC_FORMATTER 0
#define MCDE_CHNL1SYNCHMOD_OUT_SYNCH_SRC_VSYNC0 1
#define MCDE_CHNL1SYNCHMOD_OUT_SYNCH_SRC_VSYNC1 2
#define MCDE_CHNL1SYNCHMOD_OUT_SYNCH_SRC_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CHNL1SYNCHMOD, OUT_SYNCH_SRC, \
	MCDE_CHNL1SYNCHMOD_OUT_SYNCH_SRC_##__x)
#define MCDE_CHNL1SYNCHMOD_OUT_SYNCH_SRC(__x) \
	MCDE_VAL2REG(MCDE_CHNL1SYNCHMOD, OUT_SYNCH_SRC, __x)
#define MCDE_CHNL2SYNCHMOD 0x00000648
#define MCDE_CHNL2SYNCHMOD_SRC_SYNCH_SHIFT 0
#define MCDE_CHNL2SYNCHMOD_SRC_SYNCH_MASK 0x00000003
#define MCDE_CHNL2SYNCHMOD_SRC_SYNCH_OUTPUT 0
#define MCDE_CHNL2SYNCHMOD_SRC_SYNCH_AUTO 1
#define MCDE_CHNL2SYNCHMOD_SRC_SYNCH_SOFTWARE 2
#define MCDE_CHNL2SYNCHMOD_SRC_SYNCH_EXTERNAL 3
#define MCDE_CHNL2SYNCHMOD_SRC_SYNCH_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CHNL2SYNCHMOD, SRC_SYNCH, \
	MCDE_CHNL2SYNCHMOD_SRC_SYNCH_##__x)
#define MCDE_CHNL2SYNCHMOD_SRC_SYNCH(__x) \
	MCDE_VAL2REG(MCDE_CHNL2SYNCHMOD, SRC_SYNCH, __x)
#define MCDE_CHNL2SYNCHMOD_OUT_SYNCH_SRC_SHIFT 2
#define MCDE_CHNL2SYNCHMOD_OUT_SYNCH_SRC_MASK 0x0000001C
#define MCDE_CHNL2SYNCHMOD_OUT_SYNCH_SRC_FORMATTER 0
#define MCDE_CHNL2SYNCHMOD_OUT_SYNCH_SRC_VSYNC0 1
#define MCDE_CHNL2SYNCHMOD_OUT_SYNCH_SRC_VSYNC1 2
#define MCDE_CHNL2SYNCHMOD_OUT_SYNCH_SRC_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CHNL2SYNCHMOD, OUT_SYNCH_SRC, \
	MCDE_CHNL2SYNCHMOD_OUT_SYNCH_SRC_##__x)
#define MCDE_CHNL2SYNCHMOD_OUT_SYNCH_SRC(__x) \
	MCDE_VAL2REG(MCDE_CHNL2SYNCHMOD, OUT_SYNCH_SRC, __x)
#define MCDE_CHNL3SYNCHMOD 0x00000668
#define MCDE_CHNL3SYNCHMOD_SRC_SYNCH_SHIFT 0
#define MCDE_CHNL3SYNCHMOD_SRC_SYNCH_MASK 0x00000003
#define MCDE_CHNL3SYNCHMOD_SRC_SYNCH_OUTPUT 0
#define MCDE_CHNL3SYNCHMOD_SRC_SYNCH_AUTO 1
#define MCDE_CHNL3SYNCHMOD_SRC_SYNCH_SOFTWARE 2
#define MCDE_CHNL3SYNCHMOD_SRC_SYNCH_EXTERNAL 3
#define MCDE_CHNL3SYNCHMOD_SRC_SYNCH_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CHNL3SYNCHMOD, SRC_SYNCH, \
	MCDE_CHNL3SYNCHMOD_SRC_SYNCH_##__x)
#define MCDE_CHNL3SYNCHMOD_SRC_SYNCH(__x) \
	MCDE_VAL2REG(MCDE_CHNL3SYNCHMOD, SRC_SYNCH, __x)
#define MCDE_CHNL3SYNCHMOD_OUT_SYNCH_SRC_SHIFT 2
#define MCDE_CHNL3SYNCHMOD_OUT_SYNCH_SRC_MASK 0x0000001C
#define MCDE_CHNL3SYNCHMOD_OUT_SYNCH_SRC_FORMATTER 0
#define MCDE_CHNL3SYNCHMOD_OUT_SYNCH_SRC_VSYNC0 1
#define MCDE_CHNL3SYNCHMOD_OUT_SYNCH_SRC_VSYNC1 2
#define MCDE_CHNL3SYNCHMOD_OUT_SYNCH_SRC_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CHNL3SYNCHMOD, OUT_SYNCH_SRC, \
	MCDE_CHNL3SYNCHMOD_OUT_SYNCH_SRC_##__x)
#define MCDE_CHNL3SYNCHMOD_OUT_SYNCH_SRC(__x) \
	MCDE_VAL2REG(MCDE_CHNL3SYNCHMOD, OUT_SYNCH_SRC, __x)
#define MCDE_CHNL0SYNCHSW 0x0000060C
#define MCDE_CHNL0SYNCHSW_GROUPOFFSET 0x20
#define MCDE_CHNL0SYNCHSW_SW_TRIG_SHIFT 0
#define MCDE_CHNL0SYNCHSW_SW_TRIG_MASK 0x00000001
#define MCDE_CHNL0SYNCHSW_SW_TRIG(__x) \
	MCDE_VAL2REG(MCDE_CHNL0SYNCHSW, SW_TRIG, __x)
#define MCDE_CHNL1SYNCHSW 0x0000062C
#define MCDE_CHNL1SYNCHSW_SW_TRIG_SHIFT 0
#define MCDE_CHNL1SYNCHSW_SW_TRIG_MASK 0x00000001
#define MCDE_CHNL1SYNCHSW_SW_TRIG(__x) \
	MCDE_VAL2REG(MCDE_CHNL1SYNCHSW, SW_TRIG, __x)
#define MCDE_CHNL2SYNCHSW 0x0000064C
#define MCDE_CHNL2SYNCHSW_SW_TRIG_SHIFT 0
#define MCDE_CHNL2SYNCHSW_SW_TRIG_MASK 0x00000001
#define MCDE_CHNL2SYNCHSW_SW_TRIG(__x) \
	MCDE_VAL2REG(MCDE_CHNL2SYNCHSW, SW_TRIG, __x)
#define MCDE_CHNL3SYNCHSW 0x0000066C
#define MCDE_CHNL3SYNCHSW_SW_TRIG_SHIFT 0
#define MCDE_CHNL3SYNCHSW_SW_TRIG_MASK 0x00000001
#define MCDE_CHNL3SYNCHSW_SW_TRIG(__x) \
	MCDE_VAL2REG(MCDE_CHNL3SYNCHSW, SW_TRIG, __x)
#define MCDE_CHNL0BCKGNDCOL 0x00000610
#define MCDE_CHNL0BCKGNDCOL_GROUPOFFSET 0x20
#define MCDE_CHNL0BCKGNDCOL_B_SHIFT 0
#define MCDE_CHNL0BCKGNDCOL_B_MASK 0x000000FF
#define MCDE_CHNL0BCKGNDCOL_B(__x) \
	MCDE_VAL2REG(MCDE_CHNL0BCKGNDCOL, B, __x)
#define MCDE_CHNL0BCKGNDCOL_G_SHIFT 8
#define MCDE_CHNL0BCKGNDCOL_G_MASK 0x0000FF00
#define MCDE_CHNL0BCKGNDCOL_G(__x) \
	MCDE_VAL2REG(MCDE_CHNL0BCKGNDCOL, G, __x)
#define MCDE_CHNL0BCKGNDCOL_R_SHIFT 16
#define MCDE_CHNL0BCKGNDCOL_R_MASK 0x00FF0000
#define MCDE_CHNL0BCKGNDCOL_R(__x) \
	MCDE_VAL2REG(MCDE_CHNL0BCKGNDCOL, R, __x)
#define MCDE_CHNL1BCKGNDCOL 0x00000630
#define MCDE_CHNL1BCKGNDCOL_B_SHIFT 0
#define MCDE_CHNL1BCKGNDCOL_B_MASK 0x000000FF
#define MCDE_CHNL1BCKGNDCOL_B(__x) \
	MCDE_VAL2REG(MCDE_CHNL1BCKGNDCOL, B, __x)
#define MCDE_CHNL1BCKGNDCOL_G_SHIFT 8
#define MCDE_CHNL1BCKGNDCOL_G_MASK 0x0000FF00
#define MCDE_CHNL1BCKGNDCOL_G(__x) \
	MCDE_VAL2REG(MCDE_CHNL1BCKGNDCOL, G, __x)
#define MCDE_CHNL1BCKGNDCOL_R_SHIFT 16
#define MCDE_CHNL1BCKGNDCOL_R_MASK 0x00FF0000
#define MCDE_CHNL1BCKGNDCOL_R(__x) \
	MCDE_VAL2REG(MCDE_CHNL1BCKGNDCOL, R, __x)
#define MCDE_CHNL2BCKGNDCOL 0x00000650
#define MCDE_CHNL2BCKGNDCOL_B_SHIFT 0
#define MCDE_CHNL2BCKGNDCOL_B_MASK 0x000000FF
#define MCDE_CHNL2BCKGNDCOL_B(__x) \
	MCDE_VAL2REG(MCDE_CHNL2BCKGNDCOL, B, __x)
#define MCDE_CHNL2BCKGNDCOL_G_SHIFT 8
#define MCDE_CHNL2BCKGNDCOL_G_MASK 0x0000FF00
#define MCDE_CHNL2BCKGNDCOL_G(__x) \
	MCDE_VAL2REG(MCDE_CHNL2BCKGNDCOL, G, __x)
#define MCDE_CHNL2BCKGNDCOL_R_SHIFT 16
#define MCDE_CHNL2BCKGNDCOL_R_MASK 0x00FF0000
#define MCDE_CHNL2BCKGNDCOL_R(__x) \
	MCDE_VAL2REG(MCDE_CHNL2BCKGNDCOL, R, __x)
#define MCDE_CHNL3BCKGNDCOL 0x00000670
#define MCDE_CHNL3BCKGNDCOL_B_SHIFT 0
#define MCDE_CHNL3BCKGNDCOL_B_MASK 0x000000FF
#define MCDE_CHNL3BCKGNDCOL_B(__x) \
	MCDE_VAL2REG(MCDE_CHNL3BCKGNDCOL, B, __x)
#define MCDE_CHNL3BCKGNDCOL_G_SHIFT 8
#define MCDE_CHNL3BCKGNDCOL_G_MASK 0x0000FF00
#define MCDE_CHNL3BCKGNDCOL_G(__x) \
	MCDE_VAL2REG(MCDE_CHNL3BCKGNDCOL, G, __x)
#define MCDE_CHNL3BCKGNDCOL_R_SHIFT 16
#define MCDE_CHNL3BCKGNDCOL_R_MASK 0x00FF0000
#define MCDE_CHNL3BCKGNDCOL_R(__x) \
	MCDE_VAL2REG(MCDE_CHNL3BCKGNDCOL, R, __x)
#define MCDE_CHNL0PRIO_V1 0x00000614
#define MCDE_CHNL0PRIO_V1_GROUPOFFSET 0x20
#define MCDE_CHNL0PRIO_V1_CHNLPRIO_SHIFT 0
#define MCDE_CHNL0PRIO_V1_CHNLPRIO_MASK 0x0000000F
#define MCDE_CHNL0PRIO_V1_CHNLPRIO(__x) \
	MCDE_VAL2REG(MCDE_CHNL0PRIO_V1, CHNLPRIO, __x)
#define MCDE_CHNL1PRIO_V1 0x00000634
#define MCDE_CHNL1PRIO_V1_CHNLPRIO_SHIFT 0
#define MCDE_CHNL1PRIO_V1_CHNLPRIO_MASK 0x0000000F
#define MCDE_CHNL1PRIO_V1_CHNLPRIO(__x) \
	MCDE_VAL2REG(MCDE_CHNL1PRIO_V1, CHNLPRIO, __x)
#define MCDE_CHNL2PRIO_V1 0x00000654
#define MCDE_CHNL2PRIO_V1_CHNLPRIO_SHIFT 0
#define MCDE_CHNL2PRIO_V1_CHNLPRIO_MASK 0x0000000F
#define MCDE_CHNL2PRIO_V1_CHNLPRIO(__x) \
	MCDE_VAL2REG(MCDE_CHNL2PRIO_V1, CHNLPRIO, __x)
#define MCDE_CHNL3PRIO_V1 0x00000674
#define MCDE_CHNL3PRIO_V1_CHNLPRIO_SHIFT 0
#define MCDE_CHNL3PRIO_V1_CHNLPRIO_MASK 0x0000000F
#define MCDE_CHNL3PRIO_V1_CHNLPRIO(__x) \
	MCDE_VAL2REG(MCDE_CHNL3PRIO_V1, CHNLPRIO, __x)
#define MCDE_CHNL0MUXING_V2 0x00000614
#define MCDE_CHNL0MUXING_V2_GROUPOFFSET 0x20
#define MCDE_CHNL0MUXING_V2_FIFO_ID_SHIFT 0
#define MCDE_CHNL0MUXING_V2_FIFO_ID_MASK 0x00000007
#define MCDE_CHNL0MUXING_V2_FIFO_ID_FIFO_A 0
#define MCDE_CHNL0MUXING_V2_FIFO_ID_FIFO_B 1
#define MCDE_CHNL0MUXING_V2_FIFO_ID_FIFO_C0 2
#define MCDE_CHNL0MUXING_V2_FIFO_ID_FIFO_C1 3
#define MCDE_CHNL0MUXING_V2_FIFO_ID_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CHNL0MUXING_V2, FIFO_ID, \
	MCDE_CHNL0MUXING_V2_FIFO_ID_##__x)
#define MCDE_CHNL0MUXING_V2_FIFO_ID(__x) \
	MCDE_VAL2REG(MCDE_CHNL0MUXING_V2, FIFO_ID, __x)
#define MCDE_CHNL1MUXING_V2 0x00000634
#define MCDE_CHNL1MUXING_V2_FIFO_ID_SHIFT 0
#define MCDE_CHNL1MUXING_V2_FIFO_ID_MASK 0x00000007
#define MCDE_CHNL1MUXING_V2_FIFO_ID_FIFO_A 0
#define MCDE_CHNL1MUXING_V2_FIFO_ID_FIFO_B 1
#define MCDE_CHNL1MUXING_V2_FIFO_ID_FIFO_C0 2
#define MCDE_CHNL1MUXING_V2_FIFO_ID_FIFO_C1 3
#define MCDE_CHNL1MUXING_V2_FIFO_ID_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CHNL1MUXING_V2, FIFO_ID, \
	MCDE_CHNL1MUXING_V2_FIFO_ID_##__x)
#define MCDE_CHNL1MUXING_V2_FIFO_ID(__x) \
	MCDE_VAL2REG(MCDE_CHNL1MUXING_V2, FIFO_ID, __x)
#define MCDE_CHNL2MUXING_V2 0x00000654
#define MCDE_CHNL2MUXING_V2_FIFO_ID_SHIFT 0
#define MCDE_CHNL2MUXING_V2_FIFO_ID_MASK 0x00000007
#define MCDE_CHNL2MUXING_V2_FIFO_ID_FIFO_A 0
#define MCDE_CHNL2MUXING_V2_FIFO_ID_FIFO_B 1
#define MCDE_CHNL2MUXING_V2_FIFO_ID_FIFO_C0 2
#define MCDE_CHNL2MUXING_V2_FIFO_ID_FIFO_C1 3
#define MCDE_CHNL2MUXING_V2_FIFO_ID_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CHNL2MUXING_V2, FIFO_ID, \
	MCDE_CHNL2MUXING_V2_FIFO_ID_##__x)
#define MCDE_CHNL2MUXING_V2_FIFO_ID(__x) \
	MCDE_VAL2REG(MCDE_CHNL2MUXING_V2, FIFO_ID, __x)
#define MCDE_CHNL3MUXING_V2 0x00000674
#define MCDE_CHNL3MUXING_V2_FIFO_ID_SHIFT 0
#define MCDE_CHNL3MUXING_V2_FIFO_ID_MASK 0x00000007
#define MCDE_CHNL3MUXING_V2_FIFO_ID_FIFO_A 0
#define MCDE_CHNL3MUXING_V2_FIFO_ID_FIFO_B 1
#define MCDE_CHNL3MUXING_V2_FIFO_ID_FIFO_C0 2
#define MCDE_CHNL3MUXING_V2_FIFO_ID_FIFO_C1 3
#define MCDE_CHNL3MUXING_V2_FIFO_ID_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CHNL3MUXING_V2, FIFO_ID, \
	MCDE_CHNL3MUXING_V2_FIFO_ID_##__x)
#define MCDE_CHNL3MUXING_V2_FIFO_ID(__x) \
	MCDE_VAL2REG(MCDE_CHNL3MUXING_V2, FIFO_ID, __x)
#define MCDE_CRA0 0x00000800
#define MCDE_CRA0_GROUPOFFSET 0x200
#define MCDE_CRA0_FLOEN_SHIFT 0
#define MCDE_CRA0_FLOEN_MASK 0x00000001
#define MCDE_CRA0_FLOEN(__x) \
	MCDE_VAL2REG(MCDE_CRA0, FLOEN, __x)
#define MCDE_CRA0_POWEREN_SHIFT 1
#define MCDE_CRA0_POWEREN_MASK 0x00000002
#define MCDE_CRA0_POWEREN(__x) \
	MCDE_VAL2REG(MCDE_CRA0, POWEREN, __x)
#define MCDE_CRA0_BLENDEN_SHIFT 2
#define MCDE_CRA0_BLENDEN_MASK 0x00000004
#define MCDE_CRA0_BLENDEN(__x) \
	MCDE_VAL2REG(MCDE_CRA0, BLENDEN, __x)
#define MCDE_CRA0_AFLICKEN_SHIFT 3
#define MCDE_CRA0_AFLICKEN_MASK 0x00000008
#define MCDE_CRA0_AFLICKEN(__x) \
	MCDE_VAL2REG(MCDE_CRA0, AFLICKEN, __x)
#define MCDE_CRA0_PALEN_SHIFT 4
#define MCDE_CRA0_PALEN_MASK 0x00000010
#define MCDE_CRA0_PALEN(__x) \
	MCDE_VAL2REG(MCDE_CRA0, PALEN, __x)
#define MCDE_CRA0_DITHEN_SHIFT 5
#define MCDE_CRA0_DITHEN_MASK 0x00000020
#define MCDE_CRA0_DITHEN(__x) \
	MCDE_VAL2REG(MCDE_CRA0, DITHEN, __x)
#define MCDE_CRA0_GAMEN_SHIFT 6
#define MCDE_CRA0_GAMEN_MASK 0x00000040
#define MCDE_CRA0_GAMEN(__x) \
	MCDE_VAL2REG(MCDE_CRA0, GAMEN, __x)
#define MCDE_CRA0_KEYCTRL_SHIFT 7
#define MCDE_CRA0_KEYCTRL_MASK 0x00000380
#define MCDE_CRA0_KEYCTRL_OFF 0
#define MCDE_CRA0_KEYCTRL_ALPHA_RGB 1
#define MCDE_CRA0_KEYCTRL_RGB 2
#define MCDE_CRA0_KEYCTRL_FALPHA_FRGB 4
#define MCDE_CRA0_KEYCTRL_FRGB 5
#define MCDE_CRA0_KEYCTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRA0, KEYCTRL, MCDE_CRA0_KEYCTRL_##__x)
#define MCDE_CRA0_KEYCTRL(__x) \
	MCDE_VAL2REG(MCDE_CRA0, KEYCTRL, __x)
#define MCDE_CRA0_BLENDCTRL_SHIFT 10
#define MCDE_CRA0_BLENDCTRL_MASK 0x00000400
#define MCDE_CRA0_BLENDCTRL_SOURCE 0
#define MCDE_CRA0_BLENDCTRL_CONSTANT 1
#define MCDE_CRA0_BLENDCTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRA0, BLENDCTRL, MCDE_CRA0_BLENDCTRL_##__x)
#define MCDE_CRA0_BLENDCTRL(__x) \
	MCDE_VAL2REG(MCDE_CRA0, BLENDCTRL, __x)
#define MCDE_CRA0_FLICKMODE_SHIFT 11
#define MCDE_CRA0_FLICKMODE_MASK 0x00001800
#define MCDE_CRA0_FLICKMODE_FORCE_FILTER_0 0
#define MCDE_CRA0_FLICKMODE_ADAPTIVE 1
#define MCDE_CRA0_FLICKMODE_TEST_MODE 2
#define MCDE_CRA0_FLICKMODE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRA0, FLICKMODE, MCDE_CRA0_FLICKMODE_##__x)
#define MCDE_CRA0_FLICKMODE(__x) \
	MCDE_VAL2REG(MCDE_CRA0, FLICKMODE, __x)
#define MCDE_CRA0_FLOCKFORMAT_SHIFT 13
#define MCDE_CRA0_FLOCKFORMAT_MASK 0x00002000
#define MCDE_CRA0_FLOCKFORMAT_YCBCR 0
#define MCDE_CRA0_FLOCKFORMAT_RGB 1
#define MCDE_CRA0_FLOCKFORMAT_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRA0, FLOCKFORMAT, MCDE_CRA0_FLOCKFORMAT_##__x)
#define MCDE_CRA0_FLOCKFORMAT(__x) \
	MCDE_VAL2REG(MCDE_CRA0, FLOCKFORMAT, __x)
#define MCDE_CRA0_PALMODE_SHIFT 14
#define MCDE_CRA0_PALMODE_MASK 0x00004000
#define MCDE_CRA0_PALMODE_PALETTE 0
#define MCDE_CRA0_PALMODE_GAMMA 1
#define MCDE_CRA0_PALMODE(__x) \
	MCDE_VAL2REG(MCDE_CRA0, PALMODE, __x)
#define MCDE_CRA0_OLEDEN_SHIFT 15
#define MCDE_CRA0_OLEDEN_MASK 0x00008000
#define MCDE_CRA0_OLEDEN(__x) \
	MCDE_VAL2REG(MCDE_CRA0, OLEDEN, __x)
#define MCDE_CRA0_ALPHABLEND_SHIFT 16
#define MCDE_CRA0_ALPHABLEND_MASK 0x00FF0000
#define MCDE_CRA0_ALPHABLEND(__x) \
	MCDE_VAL2REG(MCDE_CRA0, ALPHABLEND, __x)
#define MCDE_CRA0_ROTEN_SHIFT 24
#define MCDE_CRA0_ROTEN_MASK 0x01000000
#define MCDE_CRA0_ROTEN(__x) \
	MCDE_VAL2REG(MCDE_CRA0, ROTEN, __x)
#define MCDE_CRA0_ROTBURSTSIZE_V1_SHIFT 25
#define MCDE_CRA0_ROTBURSTSIZE_V1_MASK 0x0E000000
#define MCDE_CRA0_ROTBURSTSIZE_V1_1W 0
#define MCDE_CRA0_ROTBURSTSIZE_V1_2W 1
#define MCDE_CRA0_ROTBURSTSIZE_V1_4W 2
#define MCDE_CRA0_ROTBURSTSIZE_V1_8W 3
#define MCDE_CRA0_ROTBURSTSIZE_V1_16W 4
#define MCDE_CRA0_ROTBURSTSIZE_V1_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRA0, ROTBURSTSIZE_V1, \
	MCDE_CRA0_ROTBURSTSIZE_V1_##__x)
#define MCDE_CRA0_ROTBURSTSIZE_V1(__x) \
	MCDE_VAL2REG(MCDE_CRA0, ROTBURSTSIZE_V1, __x)
#define MCDE_CRA0_ROTBURSTSIZE_HW_V1_SHIFT 28
#define MCDE_CRA0_ROTBURSTSIZE_HW_V1_MASK 0x10000000
#define MCDE_CRA0_ROTBURSTSIZE_HW_V1(__x) \
	MCDE_VAL2REG(MCDE_CRA0, ROTBURSTSIZE_HW_V1, __x)
#define MCDE_CRB0 0x00000A00
#define MCDE_CRB0_FLOEN_SHIFT 0
#define MCDE_CRB0_FLOEN_MASK 0x00000001
#define MCDE_CRB0_FLOEN(__x) \
	MCDE_VAL2REG(MCDE_CRB0, FLOEN, __x)
#define MCDE_CRB0_POWEREN_SHIFT 1
#define MCDE_CRB0_POWEREN_MASK 0x00000002
#define MCDE_CRB0_POWEREN(__x) \
	MCDE_VAL2REG(MCDE_CRB0, POWEREN, __x)
#define MCDE_CRB0_BLENDEN_SHIFT 2
#define MCDE_CRB0_BLENDEN_MASK 0x00000004
#define MCDE_CRB0_BLENDEN(__x) \
	MCDE_VAL2REG(MCDE_CRB0, BLENDEN, __x)
#define MCDE_CRB0_AFLICKEN_SHIFT 3
#define MCDE_CRB0_AFLICKEN_MASK 0x00000008
#define MCDE_CRB0_AFLICKEN(__x) \
	MCDE_VAL2REG(MCDE_CRB0, AFLICKEN, __x)
#define MCDE_CRB0_PALEN_SHIFT 4
#define MCDE_CRB0_PALEN_MASK 0x00000010
#define MCDE_CRB0_PALEN(__x) \
	MCDE_VAL2REG(MCDE_CRB0, PALEN, __x)
#define MCDE_CRB0_DITHEN_SHIFT 5
#define MCDE_CRB0_DITHEN_MASK 0x00000020
#define MCDE_CRB0_DITHEN(__x) \
	MCDE_VAL2REG(MCDE_CRB0, DITHEN, __x)
#define MCDE_CRB0_GAMEN_SHIFT 6
#define MCDE_CRB0_GAMEN_MASK 0x00000040
#define MCDE_CRB0_GAMEN(__x) \
	MCDE_VAL2REG(MCDE_CRB0, GAMEN, __x)
#define MCDE_CRB0_KEYCTRL_SHIFT 7
#define MCDE_CRB0_KEYCTRL_MASK 0x00000380
#define MCDE_CRB0_KEYCTRL_OFF 0
#define MCDE_CRB0_KEYCTRL_ALPHA_RGB 1
#define MCDE_CRB0_KEYCTRL_RGB 2
#define MCDE_CRB0_KEYCTRL_FALPHA_FRGB 4
#define MCDE_CRB0_KEYCTRL_FRGB 5
#define MCDE_CRB0_KEYCTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRB0, KEYCTRL, MCDE_CRB0_KEYCTRL_##__x)
#define MCDE_CRB0_KEYCTRL(__x) \
	MCDE_VAL2REG(MCDE_CRB0, KEYCTRL, __x)
#define MCDE_CRB0_BLENDCTRL_SHIFT 10
#define MCDE_CRB0_BLENDCTRL_MASK 0x00000400
#define MCDE_CRB0_BLENDCTRL_SOURCE 0
#define MCDE_CRB0_BLENDCTRL_CONSTANT 1
#define MCDE_CRB0_BLENDCTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRB0, BLENDCTRL, MCDE_CRB0_BLENDCTRL_##__x)
#define MCDE_CRB0_BLENDCTRL(__x) \
	MCDE_VAL2REG(MCDE_CRB0, BLENDCTRL, __x)
#define MCDE_CRB0_FLICKMODE_SHIFT 11
#define MCDE_CRB0_FLICKMODE_MASK 0x00001800
#define MCDE_CRB0_FLICKMODE_FORCE_FILTER_0 0
#define MCDE_CRB0_FLICKMODE_ADAPTIVE 1
#define MCDE_CRB0_FLICKMODE_TEST_MODE 2
#define MCDE_CRB0_FLICKMODE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRB0, FLICKMODE, MCDE_CRB0_FLICKMODE_##__x)
#define MCDE_CRB0_FLICKMODE(__x) \
	MCDE_VAL2REG(MCDE_CRB0, FLICKMODE, __x)
#define MCDE_CRB0_FLOCKFORMAT_SHIFT 13
#define MCDE_CRB0_FLOCKFORMAT_MASK 0x00002000
#define MCDE_CRB0_FLOCKFORMAT_YCBCR 0
#define MCDE_CRB0_FLOCKFORMAT_RGB 1
#define MCDE_CRB0_FLOCKFORMAT_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRB0, FLOCKFORMAT, MCDE_CRB0_FLOCKFORMAT_##__x)
#define MCDE_CRB0_FLOCKFORMAT(__x) \
	MCDE_VAL2REG(MCDE_CRB0, FLOCKFORMAT, __x)
#define MCDE_CRB0_PALMODE_SHIFT 14
#define MCDE_CRB0_PALMODE_MASK 0x00004000
#define MCDE_CRB0_PALMODE_PALETTE 0
#define MCDE_CRB0_PALMODE_GAMMA 1
#define MCDE_CRB0_PALMODE(__x) \
	MCDE_VAL2REG(MCDE_CRB0, PALMODE, __x)
#define MCDE_CRB0_OLEDEN_SHIFT 15
#define MCDE_CRB0_OLEDEN_MASK 0x00008000
#define MCDE_CRB0_OLEDEN(__x) \
	MCDE_VAL2REG(MCDE_CRB0, OLEDEN, __x)
#define MCDE_CRB0_ALPHABLEND_SHIFT 16
#define MCDE_CRB0_ALPHABLEND_MASK 0x00FF0000
#define MCDE_CRB0_ALPHABLEND(__x) \
	MCDE_VAL2REG(MCDE_CRB0, ALPHABLEND, __x)
#define MCDE_CRB0_ROTEN_SHIFT 24
#define MCDE_CRB0_ROTEN_MASK 0x01000000
#define MCDE_CRB0_ROTEN(__x) \
	MCDE_VAL2REG(MCDE_CRB0, ROTEN, __x)
#define MCDE_CRB0_ROTBURSTSIZE_V1_SHIFT 25
#define MCDE_CRB0_ROTBURSTSIZE_V1_MASK 0x0E000000
#define MCDE_CRB0_ROTBURSTSIZE_V1_1W 0
#define MCDE_CRB0_ROTBURSTSIZE_V1_2W 1
#define MCDE_CRB0_ROTBURSTSIZE_V1_4W 2
#define MCDE_CRB0_ROTBURSTSIZE_V1_8W 3
#define MCDE_CRB0_ROTBURSTSIZE_V1_16W 4
#define MCDE_CRB0_ROTBURSTSIZE_V1_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRB0, ROTBURSTSIZE_V1, \
	MCDE_CRB0_ROTBURSTSIZE_V1_##__x)
#define MCDE_CRB0_ROTBURSTSIZE_V1(__x) \
	MCDE_VAL2REG(MCDE_CRB0, ROTBURSTSIZE_V1, __x)
#define MCDE_CRB0_ROTBURSTSIZE_HW_V1_SHIFT 28
#define MCDE_CRB0_ROTBURSTSIZE_HW_V1_MASK 0x10000000
#define MCDE_CRB0_ROTBURSTSIZE_HW_V1(__x) \
	MCDE_VAL2REG(MCDE_CRB0, ROTBURSTSIZE_HW_V1, __x)
#define MCDE_CRA1 0x00000804
#define MCDE_CRA1_GROUPOFFSET 0x200
#define MCDE_CRA1_PCD_SHIFT 0
#define MCDE_CRA1_PCD_MASK 0x000003FF
#define MCDE_CRA1_PCD(__x) \
	MCDE_VAL2REG(MCDE_CRA1, PCD, __x)
#define MCDE_CRA1_CLKSEL_SHIFT 10
#define MCDE_CRA1_CLKSEL_MASK 0x00001C00
#define MCDE_CRA1_CLKSEL_LCD 0
#define MCDE_CRA1_CLKSEL_HDMI 1
#define MCDE_CRA1_CLKSEL_TV 2
#define MCDE_CRA1_CLKSEL_EXT_TV1 3
#define MCDE_CRA1_CLKSEL_EXT_TV2 4
#define MCDE_CRA1_CLKSEL_166MHZ 5
#define MCDE_CRA1_CLKSEL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRA1, CLKSEL, MCDE_CRA1_CLKSEL_##__x)
#define MCDE_CRA1_CLKSEL(__x) \
	MCDE_VAL2REG(MCDE_CRA1, CLKSEL, __x)
#define MCDE_CRA1_CDWIN_SHIFT 13
#define MCDE_CRA1_CDWIN_MASK 0x0001E000
#define MCDE_CRA1_CDWIN_8BPP_C1 0
#define MCDE_CRA1_CDWIN_12BPP_C1 1
#define MCDE_CRA1_CDWIN_12BPP_C2 2
#define MCDE_CRA1_CDWIN_16BPP_C1 3
#define MCDE_CRA1_CDWIN_16BPP_C2 4
#define MCDE_CRA1_CDWIN_16BPP_C3 5
#define MCDE_CRA1_CDWIN_18BPP_C1 6
#define MCDE_CRA1_CDWIN_18BPP_C2 7
#define MCDE_CRA1_CDWIN_24BPP 8
#define MCDE_CRA1_CDWIN_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRA1, CDWIN, MCDE_CRA1_CDWIN_##__x)
#define MCDE_CRA1_CDWIN(__x) \
	MCDE_VAL2REG(MCDE_CRA1, CDWIN, __x)
#define MCDE_CRA1_OUTBPP_SHIFT 25
#define MCDE_CRA1_OUTBPP_MASK 0x1E000000
#define MCDE_CRA1_OUTBPP_MONO1 0
#define MCDE_CRA1_OUTBPP_MONO2 1
#define MCDE_CRA1_OUTBPP_MONO4 2
#define MCDE_CRA1_OUTBPP_MONO8 3
#define MCDE_CRA1_OUTBPP_8BPP 4
#define MCDE_CRA1_OUTBPP_12BPP 5
#define MCDE_CRA1_OUTBPP_15BPP 6
#define MCDE_CRA1_OUTBPP_16BPP 7
#define MCDE_CRA1_OUTBPP_18BPP 8
#define MCDE_CRA1_OUTBPP_24BPP 9
#define MCDE_CRA1_OUTBPP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRA1, OUTBPP, MCDE_CRA1_OUTBPP_##__x)
#define MCDE_CRA1_OUTBPP(__x) \
	MCDE_VAL2REG(MCDE_CRA1, OUTBPP, __x)
#define MCDE_CRA1_BCD_SHIFT 29
#define MCDE_CRA1_BCD_MASK 0x20000000
#define MCDE_CRA1_BCD(__x) \
	MCDE_VAL2REG(MCDE_CRA1, BCD, __x)
#define MCDE_CRA1_CLKTYPE_SHIFT 30
#define MCDE_CRA1_CLKTYPE_MASK 0x40000000
#define MCDE_CRA1_CLKTYPE_EXTERNAL 0
#define MCDE_CRA1_CLKTYPE_INTERNAL 1
#define MCDE_CRA1_CLKTYPE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRA1, CLKTYPE, MCDE_CRA1_CLKTYPE_##__x)
#define MCDE_CRA1_CLKTYPE(__x) \
	MCDE_VAL2REG(MCDE_CRA1, CLKTYPE, __x)
#define MCDE_CRA1_TEFFECTEN_V1_SHIFT 31
#define MCDE_CRA1_TEFFECTEN_V1_MASK 0x80000000
#define MCDE_CRA1_TEFFECTEN_V1(__x) \
	MCDE_VAL2REG(MCDE_CRA1, TEFFECTEN_V1, __x)
#define MCDE_CRB1 0x00000A04
#define MCDE_CRB1_PCD_SHIFT 0
#define MCDE_CRB1_PCD_MASK 0x000003FF
#define MCDE_CRB1_PCD(__x) \
	MCDE_VAL2REG(MCDE_CRB1, PCD, __x)
#define MCDE_CRB1_CLKSEL_SHIFT 10
#define MCDE_CRB1_CLKSEL_MASK 0x00001C00
#define MCDE_CRB1_CLKSEL_LCD 0
#define MCDE_CRB1_CLKSEL_HDMI 1
#define MCDE_CRB1_CLKSEL_TV 2
#define MCDE_CRB1_CLKSEL_EXT_TV1 3
#define MCDE_CRB1_CLKSEL_EXT_TV2 4
#define MCDE_CRB1_CLKSEL_166MHZ 5
#define MCDE_CRB1_CLKSEL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRB1, CLKSEL, MCDE_CRB1_CLKSEL_##__x)
#define MCDE_CRB1_CLKSEL(__x) \
	MCDE_VAL2REG(MCDE_CRB1, CLKSEL, __x)
#define MCDE_CRB1_CDWIN_SHIFT 13
#define MCDE_CRB1_CDWIN_MASK 0x0001E000
#define MCDE_CRB1_CDWIN_8BPP_C1 0
#define MCDE_CRB1_CDWIN_12BPP_C1 1
#define MCDE_CRB1_CDWIN_12BPP_C2 2
#define MCDE_CRB1_CDWIN_16BPP_C1 3
#define MCDE_CRB1_CDWIN_16BPP_C2 4
#define MCDE_CRB1_CDWIN_16BPP_C3 5
#define MCDE_CRB1_CDWIN_18BPP_C1 6
#define MCDE_CRB1_CDWIN_18BPP_C2 7
#define MCDE_CRB1_CDWIN_24BPP 8
#define MCDE_CRB1_CDWIN_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRB1, CDWIN, MCDE_CRB1_CDWIN_##__x)
#define MCDE_CRB1_CDWIN(__x) \
	MCDE_VAL2REG(MCDE_CRB1, CDWIN, __x)
#define MCDE_CRB1_OUTBPP_SHIFT 25
#define MCDE_CRB1_OUTBPP_MASK 0x1E000000
#define MCDE_CRB1_OUTBPP_MONO1 0
#define MCDE_CRB1_OUTBPP_MONO2 1
#define MCDE_CRB1_OUTBPP_MONO4 2
#define MCDE_CRB1_OUTBPP_MONO8 3
#define MCDE_CRB1_OUTBPP_8BPP 4
#define MCDE_CRB1_OUTBPP_12BPP 5
#define MCDE_CRB1_OUTBPP_15BPP 6
#define MCDE_CRB1_OUTBPP_16BPP 7
#define MCDE_CRB1_OUTBPP_18BPP 8
#define MCDE_CRB1_OUTBPP_24BPP 9
#define MCDE_CRB1_OUTBPP_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRB1, OUTBPP, MCDE_CRB1_OUTBPP_##__x)
#define MCDE_CRB1_OUTBPP(__x) \
	MCDE_VAL2REG(MCDE_CRB1, OUTBPP, __x)
#define MCDE_CRB1_BCD_SHIFT 29
#define MCDE_CRB1_BCD_MASK 0x20000000
#define MCDE_CRB1_BCD(__x) \
	MCDE_VAL2REG(MCDE_CRB1, BCD, __x)
#define MCDE_CRB1_CLKTYPE_SHIFT 30
#define MCDE_CRB1_CLKTYPE_MASK 0x40000000
#define MCDE_CRB1_CLKTYPE_EXTERNAL 0
#define MCDE_CRB1_CLKTYPE_INTERNAL 1
#define MCDE_CRB1_CLKTYPE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRB1, CLKTYPE, MCDE_CRB1_CLKTYPE_##__x)
#define MCDE_CRB1_CLKTYPE(__x) \
	MCDE_VAL2REG(MCDE_CRB1, CLKTYPE, __x)
#define MCDE_CRB1_TEFFECTEN_V1_SHIFT 31
#define MCDE_CRB1_TEFFECTEN_V1_MASK 0x80000000
#define MCDE_CRB1_TEFFECTEN_V1(__x) \
	MCDE_VAL2REG(MCDE_CRB1, TEFFECTEN_V1, __x)
#define MCDE_COLKEYA 0x00000808
#define MCDE_COLKEYA_GROUPOFFSET 0x200
#define MCDE_COLKEYA_KEYB_SHIFT 0
#define MCDE_COLKEYA_KEYB_MASK 0x000000FF
#define MCDE_COLKEYA_KEYB(__x) \
	MCDE_VAL2REG(MCDE_COLKEYA, KEYB, __x)
#define MCDE_COLKEYA_KEYG_SHIFT 8
#define MCDE_COLKEYA_KEYG_MASK 0x0000FF00
#define MCDE_COLKEYA_KEYG(__x) \
	MCDE_VAL2REG(MCDE_COLKEYA, KEYG, __x)
#define MCDE_COLKEYA_KEYR_SHIFT 16
#define MCDE_COLKEYA_KEYR_MASK 0x00FF0000
#define MCDE_COLKEYA_KEYR(__x) \
	MCDE_VAL2REG(MCDE_COLKEYA, KEYR, __x)
#define MCDE_COLKEYA_KEYA_SHIFT 24
#define MCDE_COLKEYA_KEYA_MASK 0xFF000000
#define MCDE_COLKEYA_KEYA(__x) \
	MCDE_VAL2REG(MCDE_COLKEYA, KEYA, __x)
#define MCDE_COLKEYB 0x00000A08
#define MCDE_COLKEYB_KEYB_SHIFT 0
#define MCDE_COLKEYB_KEYB_MASK 0x000000FF
#define MCDE_COLKEYB_KEYB(__x) \
	MCDE_VAL2REG(MCDE_COLKEYB, KEYB, __x)
#define MCDE_COLKEYB_KEYG_SHIFT 8
#define MCDE_COLKEYB_KEYG_MASK 0x0000FF00
#define MCDE_COLKEYB_KEYG(__x) \
	MCDE_VAL2REG(MCDE_COLKEYB, KEYG, __x)
#define MCDE_COLKEYB_KEYR_SHIFT 16
#define MCDE_COLKEYB_KEYR_MASK 0x00FF0000
#define MCDE_COLKEYB_KEYR(__x) \
	MCDE_VAL2REG(MCDE_COLKEYB, KEYR, __x)
#define MCDE_COLKEYB_KEYA_SHIFT 24
#define MCDE_COLKEYB_KEYA_MASK 0xFF000000
#define MCDE_COLKEYB_KEYA(__x) \
	MCDE_VAL2REG(MCDE_COLKEYB, KEYA, __x)
#define MCDE_FCOLKEYA 0x0000080C
#define MCDE_FCOLKEYA_GROUPOFFSET 0x200
#define MCDE_FCOLKEYA_FKEYB_SHIFT 0
#define MCDE_FCOLKEYA_FKEYB_MASK 0x000000FF
#define MCDE_FCOLKEYA_FKEYB(__x) \
	MCDE_VAL2REG(MCDE_FCOLKEYA, FKEYB, __x)
#define MCDE_FCOLKEYA_FKEYG_SHIFT 8
#define MCDE_FCOLKEYA_FKEYG_MASK 0x0000FF00
#define MCDE_FCOLKEYA_FKEYG(__x) \
	MCDE_VAL2REG(MCDE_FCOLKEYA, FKEYG, __x)
#define MCDE_FCOLKEYA_FKEYR_SHIFT 16
#define MCDE_FCOLKEYA_FKEYR_MASK 0x00FF0000
#define MCDE_FCOLKEYA_FKEYR(__x) \
	MCDE_VAL2REG(MCDE_FCOLKEYA, FKEYR, __x)
#define MCDE_FCOLKEYA_FKEYA_SHIFT 24
#define MCDE_FCOLKEYA_FKEYA_MASK 0xFF000000
#define MCDE_FCOLKEYA_FKEYA(__x) \
	MCDE_VAL2REG(MCDE_FCOLKEYA, FKEYA, __x)
#define MCDE_FCOLKEYB 0x00000A0C
#define MCDE_FCOLKEYB_FKEYB_SHIFT 0
#define MCDE_FCOLKEYB_FKEYB_MASK 0x000000FF
#define MCDE_FCOLKEYB_FKEYB(__x) \
	MCDE_VAL2REG(MCDE_FCOLKEYB, FKEYB, __x)
#define MCDE_FCOLKEYB_FKEYG_SHIFT 8
#define MCDE_FCOLKEYB_FKEYG_MASK 0x0000FF00
#define MCDE_FCOLKEYB_FKEYG(__x) \
	MCDE_VAL2REG(MCDE_FCOLKEYB, FKEYG, __x)
#define MCDE_FCOLKEYB_FKEYR_SHIFT 16
#define MCDE_FCOLKEYB_FKEYR_MASK 0x00FF0000
#define MCDE_FCOLKEYB_FKEYR(__x) \
	MCDE_VAL2REG(MCDE_FCOLKEYB, FKEYR, __x)
#define MCDE_FCOLKEYB_FKEYA_SHIFT 24
#define MCDE_FCOLKEYB_FKEYA_MASK 0xFF000000
#define MCDE_FCOLKEYB_FKEYA(__x) \
	MCDE_VAL2REG(MCDE_FCOLKEYB, FKEYA, __x)
#define MCDE_RGBCONV1A 0x00000810
#define MCDE_RGBCONV1A_GROUPOFFSET 0x200
#define MCDE_RGBCONV1A_YR_GREEN_SHIFT 0
#define MCDE_RGBCONV1A_YR_GREEN_MASK 0x000007FF
#define MCDE_RGBCONV1A_YR_GREEN(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV1A, YR_GREEN, __x)
#define MCDE_RGBCONV1A_YR_RED_SHIFT 16
#define MCDE_RGBCONV1A_YR_RED_MASK 0x07FF0000
#define MCDE_RGBCONV1A_YR_RED(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV1A, YR_RED, __x)
#define MCDE_RGBCONV1B 0x00000A10
#define MCDE_RGBCONV1B_YR_GREEN_SHIFT 0
#define MCDE_RGBCONV1B_YR_GREEN_MASK 0x000007FF
#define MCDE_RGBCONV1B_YR_GREEN(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV1B, YR_GREEN, __x)
#define MCDE_RGBCONV1B_YR_RED_SHIFT 16
#define MCDE_RGBCONV1B_YR_RED_MASK 0x07FF0000
#define MCDE_RGBCONV1B_YR_RED(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV1B, YR_RED, __x)
#define MCDE_RGBCONV2A 0x00000814
#define MCDE_RGBCONV2A_GROUPOFFSET 0x200
#define MCDE_RGBCONV2A_CR_RED_SHIFT 0
#define MCDE_RGBCONV2A_CR_RED_MASK 0x000007FF
#define MCDE_RGBCONV2A_CR_RED(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV2A, CR_RED, __x)
#define MCDE_RGBCONV2A_YR_BLUE_SHIFT 16
#define MCDE_RGBCONV2A_YR_BLUE_MASK 0x07FF0000
#define MCDE_RGBCONV2A_YR_BLUE(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV2A, YR_BLUE, __x)
#define MCDE_RGBCONV2B 0x00000A14
#define MCDE_RGBCONV2B_CR_RED_SHIFT 0
#define MCDE_RGBCONV2B_CR_RED_MASK 0x000007FF
#define MCDE_RGBCONV2B_CR_RED(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV2B, CR_RED, __x)
#define MCDE_RGBCONV2B_YR_BLUE_SHIFT 16
#define MCDE_RGBCONV2B_YR_BLUE_MASK 0x07FF0000
#define MCDE_RGBCONV2B_YR_BLUE(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV2B, YR_BLUE, __x)
#define MCDE_RGBCONV3A 0x00000818
#define MCDE_RGBCONV3A_GROUPOFFSET 0x200
#define MCDE_RGBCONV3A_CR_BLUE_SHIFT 0
#define MCDE_RGBCONV3A_CR_BLUE_MASK 0x000007FF
#define MCDE_RGBCONV3A_CR_BLUE(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV3A, CR_BLUE, __x)
#define MCDE_RGBCONV3A_CR_GREEN_SHIFT 16
#define MCDE_RGBCONV3A_CR_GREEN_MASK 0x07FF0000
#define MCDE_RGBCONV3A_CR_GREEN(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV3A, CR_GREEN, __x)
#define MCDE_RGBCONV3B 0x00000A18
#define MCDE_RGBCONV3B_CR_BLUE_SHIFT 0
#define MCDE_RGBCONV3B_CR_BLUE_MASK 0x000007FF
#define MCDE_RGBCONV3B_CR_BLUE(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV3B, CR_BLUE, __x)
#define MCDE_RGBCONV3B_CR_GREEN_SHIFT 16
#define MCDE_RGBCONV3B_CR_GREEN_MASK 0x07FF0000
#define MCDE_RGBCONV3B_CR_GREEN(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV3B, CR_GREEN, __x)
#define MCDE_RGBCONV4A 0x0000081C
#define MCDE_RGBCONV4A_GROUPOFFSET 0x200
#define MCDE_RGBCONV4A_CB_GREEN_SHIFT 0
#define MCDE_RGBCONV4A_CB_GREEN_MASK 0x000007FF
#define MCDE_RGBCONV4A_CB_GREEN(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV4A, CB_GREEN, __x)
#define MCDE_RGBCONV4A_CB_RED_SHIFT 16
#define MCDE_RGBCONV4A_CB_RED_MASK 0x07FF0000
#define MCDE_RGBCONV4A_CB_RED(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV4A, CB_RED, __x)
#define MCDE_RGBCONV4B 0x00000A1C
#define MCDE_RGBCONV4B_CB_GREEN_SHIFT 0
#define MCDE_RGBCONV4B_CB_GREEN_MASK 0x000007FF
#define MCDE_RGBCONV4B_CB_GREEN(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV4B, CB_GREEN, __x)
#define MCDE_RGBCONV4B_CB_RED_SHIFT 16
#define MCDE_RGBCONV4B_CB_RED_MASK 0x07FF0000
#define MCDE_RGBCONV4B_CB_RED(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV4B, CB_RED, __x)
#define MCDE_RGBCONV5A 0x00000820
#define MCDE_RGBCONV5A_GROUPOFFSET 0x200
#define MCDE_RGBCONV5A_OFF_RED_SHIFT 0
#define MCDE_RGBCONV5A_OFF_RED_MASK 0x000007FF
#define MCDE_RGBCONV5A_OFF_RED(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV5A, OFF_RED, __x)
#define MCDE_RGBCONV5A_CB_BLUE_SHIFT 16
#define MCDE_RGBCONV5A_CB_BLUE_MASK 0x07FF0000
#define MCDE_RGBCONV5A_CB_BLUE(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV5A, CB_BLUE, __x)
#define MCDE_RGBCONV5B 0x00000A20
#define MCDE_RGBCONV5B_OFF_RED_SHIFT 0
#define MCDE_RGBCONV5B_OFF_RED_MASK 0x000007FF
#define MCDE_RGBCONV5B_OFF_RED(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV5B, OFF_RED, __x)
#define MCDE_RGBCONV5B_CB_BLUE_SHIFT 16
#define MCDE_RGBCONV5B_CB_BLUE_MASK 0x07FF0000
#define MCDE_RGBCONV5B_CB_BLUE(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV5B, CB_BLUE, __x)
#define MCDE_RGBCONV6A 0x00000824
#define MCDE_RGBCONV6A_GROUPOFFSET 0x200
#define MCDE_RGBCONV6A_OFF_BLUE_SHIFT 0
#define MCDE_RGBCONV6A_OFF_BLUE_MASK 0x000007FF
#define MCDE_RGBCONV6A_OFF_BLUE(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV6A, OFF_BLUE, __x)
#define MCDE_RGBCONV6A_OFF_GREEN_SHIFT 16
#define MCDE_RGBCONV6A_OFF_GREEN_MASK 0x07FF0000
#define MCDE_RGBCONV6A_OFF_GREEN(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV6A, OFF_GREEN, __x)
#define MCDE_RGBCONV6B 0x00000A24
#define MCDE_RGBCONV6B_OFF_BLUE_SHIFT 0
#define MCDE_RGBCONV6B_OFF_BLUE_MASK 0x000007FF
#define MCDE_RGBCONV6B_OFF_BLUE(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV6B, OFF_BLUE, __x)
#define MCDE_RGBCONV6B_OFF_GREEN_SHIFT 16
#define MCDE_RGBCONV6B_OFF_GREEN_MASK 0x07FF0000
#define MCDE_RGBCONV6B_OFF_GREEN(__x) \
	MCDE_VAL2REG(MCDE_RGBCONV6B, OFF_GREEN, __x)
#define MCDE_FFCOEF0 0x00000828
#define MCDE_FFCOEF0_COEFF0_N1_SHIFT 0
#define MCDE_FFCOEF0_COEFF0_N1_MASK 0x000000FF
#define MCDE_FFCOEF0_COEFF0_N1(__x) \
	MCDE_VAL2REG(MCDE_FFCOEF0, COEFF0_N1, __x)
#define MCDE_FFCOEF0_COEFF0_N2_SHIFT 8
#define MCDE_FFCOEF0_COEFF0_N2_MASK 0x0000FF00
#define MCDE_FFCOEF0_COEFF0_N2(__x) \
	MCDE_VAL2REG(MCDE_FFCOEF0, COEFF0_N2, __x)
#define MCDE_FFCOEF0_COEFF0_N3_SHIFT 16
#define MCDE_FFCOEF0_COEFF0_N3_MASK 0x00FF0000
#define MCDE_FFCOEF0_COEFF0_N3(__x) \
	MCDE_VAL2REG(MCDE_FFCOEF0, COEFF0_N3, __x)
#define MCDE_FFCOEF0_T0_SHIFT 24
#define MCDE_FFCOEF0_T0_MASK 0x0F000000
#define MCDE_FFCOEF0_T0(__x) \
	MCDE_VAL2REG(MCDE_FFCOEF0, T0, __x)
#define MCDE_FFCOEF1 0x0000082C
#define MCDE_FFCOEF1_COEFF1_N1_SHIFT 0
#define MCDE_FFCOEF1_COEFF1_N1_MASK 0x000000FF
#define MCDE_FFCOEF1_COEFF1_N1(__x) \
	MCDE_VAL2REG(MCDE_FFCOEF1, COEFF1_N1, __x)
#define MCDE_FFCOEF1_COEFF1_N2_SHIFT 8
#define MCDE_FFCOEF1_COEFF1_N2_MASK 0x0000FF00
#define MCDE_FFCOEF1_COEFF1_N2(__x) \
	MCDE_VAL2REG(MCDE_FFCOEF1, COEFF1_N2, __x)
#define MCDE_FFCOEF1_COEFF1_N3_SHIFT 16
#define MCDE_FFCOEF1_COEFF1_N3_MASK 0x00FF0000
#define MCDE_FFCOEF1_COEFF1_N3(__x) \
	MCDE_VAL2REG(MCDE_FFCOEF1, COEFF1_N3, __x)
#define MCDE_FFCOEF1_T1_SHIFT 24
#define MCDE_FFCOEF1_T1_MASK 0x0F000000
#define MCDE_FFCOEF1_T1(__x) \
	MCDE_VAL2REG(MCDE_FFCOEF1, T1, __x)
#define MCDE_FFCOEF2 0x00000830
#define MCDE_FFCOEF2_COEFF2_N1_SHIFT 0
#define MCDE_FFCOEF2_COEFF2_N1_MASK 0x000000FF
#define MCDE_FFCOEF2_COEFF2_N1(__x) \
	MCDE_VAL2REG(MCDE_FFCOEF2, COEFF2_N1, __x)
#define MCDE_FFCOEF2_COEFF2_N2_SHIFT 8
#define MCDE_FFCOEF2_COEFF2_N2_MASK 0x0000FF00
#define MCDE_FFCOEF2_COEFF2_N2(__x) \
	MCDE_VAL2REG(MCDE_FFCOEF2, COEFF2_N2, __x)
#define MCDE_FFCOEF2_COEFF2_N3_SHIFT 16
#define MCDE_FFCOEF2_COEFF2_N3_MASK 0x00FF0000
#define MCDE_FFCOEF2_COEFF2_N3(__x) \
	MCDE_VAL2REG(MCDE_FFCOEF2, COEFF2_N3, __x)
#define MCDE_FFCOEF2_T2_SHIFT 24
#define MCDE_FFCOEF2_T2_MASK 0x0F000000
#define MCDE_FFCOEF2_T2(__x) \
	MCDE_VAL2REG(MCDE_FFCOEF2, T2, __x)
#define MCDE_MCDE_WDATAA_V2 0x00000834
#define MCDE_MCDE_WDATAA_V2_GROUPOFFSET 0x200
#define MCDE_MCDE_WDATAA_V2_DC_SHIFT 24
#define MCDE_MCDE_WDATAA_V2_DC_MASK 0x01000000
#define MCDE_MCDE_WDATAA_V2_DC(__x) \
	MCDE_VAL2REG(MCDE_MCDE_WDATAA_V2, DC, __x)
#define MCDE_MCDE_WDATAA_V2_DATAVALUE_SHIFT 0
#define MCDE_MCDE_WDATAA_V2_DATAVALUE_MASK 0x00FFFFFF
#define MCDE_MCDE_WDATAA_V2_DATAVALUE(__x) \
	MCDE_VAL2REG(MCDE_MCDE_WDATAA_V2, DATAVALUE, __x)
#define MCDE_MCDE_WDATAB_V2 0x00000A34
#define MCDE_MCDE_WDATAB_V2_DC_SHIFT 24
#define MCDE_MCDE_WDATAB_V2_DC_MASK 0x01000000
#define MCDE_MCDE_WDATAB_V2_DC(__x) \
	MCDE_VAL2REG(MCDE_MCDE_WDATAB_V2, DC, __x)
#define MCDE_MCDE_WDATAB_V2_DATAVALUE_SHIFT 0
#define MCDE_MCDE_WDATAB_V2_DATAVALUE_MASK 0x00FFFFFF
#define MCDE_MCDE_WDATAB_V2_DATAVALUE(__x) \
	MCDE_VAL2REG(MCDE_MCDE_WDATAB_V2, DATAVALUE, __x)
#define MCDE_TVCRA 0x00000838
#define MCDE_TVCRA_GROUPOFFSET 0x200
#define MCDE_TVCRA_SEL_MOD_SHIFT 0
#define MCDE_TVCRA_SEL_MOD_MASK 0x00000001
#define MCDE_TVCRA_SEL_MOD_LCD 0
#define MCDE_TVCRA_SEL_MOD_TV 1
#define MCDE_TVCRA_SEL_MOD_ENUM(__x) \
	MCDE_VAL2REG(MCDE_TVCRA, SEL_MOD, MCDE_TVCRA_SEL_MOD_##__x)
#define MCDE_TVCRA_SEL_MOD(__x) \
	MCDE_VAL2REG(MCDE_TVCRA, SEL_MOD, __x)
#define MCDE_TVCRA_INTEREN_SHIFT 1
#define MCDE_TVCRA_INTEREN_MASK 0x00000002
#define MCDE_TVCRA_INTEREN(__x) \
	MCDE_VAL2REG(MCDE_TVCRA, INTEREN, __x)
#define MCDE_TVCRA_IFIELD_SHIFT 2
#define MCDE_TVCRA_IFIELD_MASK 0x00000004
#define MCDE_TVCRA_IFIELD(__x) \
	MCDE_VAL2REG(MCDE_TVCRA, IFIELD, __x)
#define MCDE_TVCRA_TVMODE_SHIFT 3
#define MCDE_TVCRA_TVMODE_MASK 0x00000038
#define MCDE_TVCRA_TVMODE_SDTV_656P 0
#define MCDE_TVCRA_TVMODE_HDTV_480P 1
#define MCDE_TVCRA_TVMODE_HDTV_720P 2
#define MCDE_TVCRA_TVMODE_SDTV_656P_LE 3
#define MCDE_TVCRA_TVMODE_SDTV_656P_BE 4
#define MCDE_TVCRA_TVMODE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_TVCRA, TVMODE, MCDE_TVCRA_TVMODE_##__x)
#define MCDE_TVCRA_TVMODE(__x) \
	MCDE_VAL2REG(MCDE_TVCRA, TVMODE, __x)
#define MCDE_TVCRA_SDTVMODE_SHIFT 6
#define MCDE_TVCRA_SDTVMODE_MASK 0x000000C0
#define MCDE_TVCRA_SDTVMODE_Y0CBY1CR 0
#define MCDE_TVCRA_SDTVMODE_CBY0CRY1 1
#define MCDE_TVCRA_SDTVMODE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_TVCRA, SDTVMODE, MCDE_TVCRA_SDTVMODE_##__x)
#define MCDE_TVCRA_SDTVMODE(__x) \
	MCDE_VAL2REG(MCDE_TVCRA, SDTVMODE, __x)
#define MCDE_TVCRA_AVRGEN_SHIFT 8
#define MCDE_TVCRA_AVRGEN_MASK 0x00000100
#define MCDE_TVCRA_AVRGEN(__x) \
	MCDE_VAL2REG(MCDE_TVCRA, AVRGEN, __x)
#define MCDE_TVCRA_CKINV_SHIFT 9
#define MCDE_TVCRA_CKINV_MASK 0x00000200
#define MCDE_TVCRA_CKINV(__x) \
	MCDE_VAL2REG(MCDE_TVCRA, CKINV, __x)
#define MCDE_TVCRB 0x00000A38
#define MCDE_TVCRB_SEL_MOD_SHIFT 0
#define MCDE_TVCRB_SEL_MOD_MASK 0x00000001
#define MCDE_TVCRB_SEL_MOD_LCD 0
#define MCDE_TVCRB_SEL_MOD_TV 1
#define MCDE_TVCRB_SEL_MOD_ENUM(__x) \
	MCDE_VAL2REG(MCDE_TVCRB, SEL_MOD, MCDE_TVCRB_SEL_MOD_##__x)
#define MCDE_TVCRB_SEL_MOD(__x) \
	MCDE_VAL2REG(MCDE_TVCRB, SEL_MOD, __x)
#define MCDE_TVCRB_INTEREN_SHIFT 1
#define MCDE_TVCRB_INTEREN_MASK 0x00000002
#define MCDE_TVCRB_INTEREN(__x) \
	MCDE_VAL2REG(MCDE_TVCRB, INTEREN, __x)
#define MCDE_TVCRB_IFIELD_SHIFT 2
#define MCDE_TVCRB_IFIELD_MASK 0x00000004
#define MCDE_TVCRB_IFIELD(__x) \
	MCDE_VAL2REG(MCDE_TVCRB, IFIELD, __x)
#define MCDE_TVCRB_TVMODE_SHIFT 3
#define MCDE_TVCRB_TVMODE_MASK 0x00000038
#define MCDE_TVCRB_TVMODE_SDTV_656P 0
#define MCDE_TVCRB_TVMODE_HDTV_480P 1
#define MCDE_TVCRB_TVMODE_HDTV_720P 2
#define MCDE_TVCRB_TVMODE_SDTV_656P_LE 3
#define MCDE_TVCRB_TVMODE_SDTV_656P_BE 4
#define MCDE_TVCRB_TVMODE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_TVCRB, TVMODE, MCDE_TVCRB_TVMODE_##__x)
#define MCDE_TVCRB_TVMODE(__x) \
	MCDE_VAL2REG(MCDE_TVCRB, TVMODE, __x)
#define MCDE_TVCRB_SDTVMODE_SHIFT 6
#define MCDE_TVCRB_SDTVMODE_MASK 0x000000C0
#define MCDE_TVCRB_SDTVMODE_Y0CBY1CR 0
#define MCDE_TVCRB_SDTVMODE_CBY0CRY1 1
#define MCDE_TVCRB_SDTVMODE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_TVCRB, SDTVMODE, MCDE_TVCRB_SDTVMODE_##__x)
#define MCDE_TVCRB_SDTVMODE(__x) \
	MCDE_VAL2REG(MCDE_TVCRB, SDTVMODE, __x)
#define MCDE_TVCRB_AVRGEN_SHIFT 8
#define MCDE_TVCRB_AVRGEN_MASK 0x00000100
#define MCDE_TVCRB_AVRGEN(__x) \
	MCDE_VAL2REG(MCDE_TVCRB, AVRGEN, __x)
#define MCDE_TVCRB_CKINV_SHIFT 9
#define MCDE_TVCRB_CKINV_MASK 0x00000200
#define MCDE_TVCRB_CKINV(__x) \
	MCDE_VAL2REG(MCDE_TVCRB, CKINV, __x)
#define MCDE_TVBL1A 0x0000083C
#define MCDE_TVBL1A_GROUPOFFSET 0x200
#define MCDE_TVBL1A_BEL1_SHIFT 0
#define MCDE_TVBL1A_BEL1_MASK 0x000007FF
#define MCDE_TVBL1A_BEL1(__x) \
	MCDE_VAL2REG(MCDE_TVBL1A, BEL1, __x)
#define MCDE_TVBL1A_BSL1_SHIFT 16
#define MCDE_TVBL1A_BSL1_MASK 0x07FF0000
#define MCDE_TVBL1A_BSL1(__x) \
	MCDE_VAL2REG(MCDE_TVBL1A, BSL1, __x)
#define MCDE_TVBL1B 0x00000A3C
#define MCDE_TVBL1B_BEL1_SHIFT 0
#define MCDE_TVBL1B_BEL1_MASK 0x000007FF
#define MCDE_TVBL1B_BEL1(__x) \
	MCDE_VAL2REG(MCDE_TVBL1B, BEL1, __x)
#define MCDE_TVBL1B_BSL1_SHIFT 16
#define MCDE_TVBL1B_BSL1_MASK 0x07FF0000
#define MCDE_TVBL1B_BSL1(__x) \
	MCDE_VAL2REG(MCDE_TVBL1B, BSL1, __x)
#define MCDE_TVISLA 0x00000840
#define MCDE_TVISLA_GROUPOFFSET 0x200
#define MCDE_TVISLA_FSL1_SHIFT 0
#define MCDE_TVISLA_FSL1_MASK 0x000007FF
#define MCDE_TVISLA_FSL1(__x) \
	MCDE_VAL2REG(MCDE_TVISLA, FSL1, __x)
#define MCDE_TVISLA_FSL2_SHIFT 16
#define MCDE_TVISLA_FSL2_MASK 0x07FF0000
#define MCDE_TVISLA_FSL2(__x) \
	MCDE_VAL2REG(MCDE_TVISLA, FSL2, __x)
#define MCDE_TVISLB 0x00000A40
#define MCDE_TVISLB_FSL1_SHIFT 0
#define MCDE_TVISLB_FSL1_MASK 0x000007FF
#define MCDE_TVISLB_FSL1(__x) \
	MCDE_VAL2REG(MCDE_TVISLB, FSL1, __x)
#define MCDE_TVISLB_FSL2_SHIFT 16
#define MCDE_TVISLB_FSL2_MASK 0x07FF0000
#define MCDE_TVISLB_FSL2(__x) \
	MCDE_VAL2REG(MCDE_TVISLB, FSL2, __x)
#define MCDE_TVDVOA 0x00000844
#define MCDE_TVDVOA_GROUPOFFSET 0x200
#define MCDE_TVDVOA_DVO1_SHIFT 0
#define MCDE_TVDVOA_DVO1_MASK 0x000007FF
#define MCDE_TVDVOA_DVO1(__x) \
	MCDE_VAL2REG(MCDE_TVDVOA, DVO1, __x)
#define MCDE_TVDVOA_DVO2_SHIFT 16
#define MCDE_TVDVOA_DVO2_MASK 0x07FF0000
#define MCDE_TVDVOA_DVO2(__x) \
	MCDE_VAL2REG(MCDE_TVDVOA, DVO2, __x)
#define MCDE_TVDVOB 0x00000A44
#define MCDE_TVDVOB_DVO1_SHIFT 0
#define MCDE_TVDVOB_DVO1_MASK 0x000007FF
#define MCDE_TVDVOB_DVO1(__x) \
	MCDE_VAL2REG(MCDE_TVDVOB, DVO1, __x)
#define MCDE_TVDVOB_DVO2_SHIFT 16
#define MCDE_TVDVOB_DVO2_MASK 0x07FF0000
#define MCDE_TVDVOB_DVO2(__x) \
	MCDE_VAL2REG(MCDE_TVDVOB, DVO2, __x)
#define MCDE_TVTIM1A 0x0000084C
#define MCDE_TVTIM1A_GROUPOFFSET 0x200
#define MCDE_TVTIM1A_DHO_SHIFT 0
#define MCDE_TVTIM1A_DHO_MASK 0x000007FF
#define MCDE_TVTIM1A_DHO(__x) \
	MCDE_VAL2REG(MCDE_TVTIM1A, DHO, __x)
#define MCDE_TVTIM1B 0x00000A4C
#define MCDE_TVTIM1B_DHO_SHIFT 0
#define MCDE_TVTIM1B_DHO_MASK 0x000007FF
#define MCDE_TVTIM1B_DHO(__x) \
	MCDE_VAL2REG(MCDE_TVTIM1B, DHO, __x)
#define MCDE_TVLBALWA 0x00000850
#define MCDE_TVLBALWA_GROUPOFFSET 0x200
#define MCDE_TVLBALWA_LBW_SHIFT 0
#define MCDE_TVLBALWA_LBW_MASK 0x000007FF
#define MCDE_TVLBALWA_LBW(__x) \
	MCDE_VAL2REG(MCDE_TVLBALWA, LBW, __x)
#define MCDE_TVLBALWA_ALW_SHIFT 16
#define MCDE_TVLBALWA_ALW_MASK 0x07FF0000
#define MCDE_TVLBALWA_ALW(__x) \
	MCDE_VAL2REG(MCDE_TVLBALWA, ALW, __x)
#define MCDE_TVLBALWB 0x00000A50
#define MCDE_TVLBALWB_LBW_SHIFT 0
#define MCDE_TVLBALWB_LBW_MASK 0x000007FF
#define MCDE_TVLBALWB_LBW(__x) \
	MCDE_VAL2REG(MCDE_TVLBALWB, LBW, __x)
#define MCDE_TVLBALWB_ALW_SHIFT 16
#define MCDE_TVLBALWB_ALW_MASK 0x07FF0000
#define MCDE_TVLBALWB_ALW(__x) \
	MCDE_VAL2REG(MCDE_TVLBALWB, ALW, __x)
#define MCDE_TVBL2A 0x00000854
#define MCDE_TVBL2A_GROUPOFFSET 0x200
#define MCDE_TVBL2A_BEL2_SHIFT 0
#define MCDE_TVBL2A_BEL2_MASK 0x000007FF
#define MCDE_TVBL2A_BEL2(__x) \
	MCDE_VAL2REG(MCDE_TVBL2A, BEL2, __x)
#define MCDE_TVBL2A_BSL2_SHIFT 16
#define MCDE_TVBL2A_BSL2_MASK 0x07FF0000
#define MCDE_TVBL2A_BSL2(__x) \
	MCDE_VAL2REG(MCDE_TVBL2A, BSL2, __x)
#define MCDE_TVBL2B 0x00000A54
#define MCDE_TVBL2B_BEL2_SHIFT 0
#define MCDE_TVBL2B_BEL2_MASK 0x000007FF
#define MCDE_TVBL2B_BEL2(__x) \
	MCDE_VAL2REG(MCDE_TVBL2B, BEL2, __x)
#define MCDE_TVBL2B_BSL2_SHIFT 16
#define MCDE_TVBL2B_BSL2_MASK 0x07FF0000
#define MCDE_TVBL2B_BSL2(__x) \
	MCDE_VAL2REG(MCDE_TVBL2B, BSL2, __x)
#define MCDE_TVBLUA 0x00000858
#define MCDE_TVBLUA_GROUPOFFSET 0x200
#define MCDE_TVBLUA_TVBLU_SHIFT 0
#define MCDE_TVBLUA_TVBLU_MASK 0x000000FF
#define MCDE_TVBLUA_TVBLU(__x) \
	MCDE_VAL2REG(MCDE_TVBLUA, TVBLU, __x)
#define MCDE_TVBLUA_TVBCB_SHIFT 8
#define MCDE_TVBLUA_TVBCB_MASK 0x0000FF00
#define MCDE_TVBLUA_TVBCB(__x) \
	MCDE_VAL2REG(MCDE_TVBLUA, TVBCB, __x)
#define MCDE_TVBLUA_TVBCR_SHIFT 16
#define MCDE_TVBLUA_TVBCR_MASK 0x00FF0000
#define MCDE_TVBLUA_TVBCR(__x) \
	MCDE_VAL2REG(MCDE_TVBLUA, TVBCR, __x)
#define MCDE_TVBLUB 0x00000A58
#define MCDE_TVBLUB_TVBLU_SHIFT 0
#define MCDE_TVBLUB_TVBLU_MASK 0x000000FF
#define MCDE_TVBLUB_TVBLU(__x) \
	MCDE_VAL2REG(MCDE_TVBLUB, TVBLU, __x)
#define MCDE_TVBLUB_TVBCB_SHIFT 8
#define MCDE_TVBLUB_TVBCB_MASK 0x0000FF00
#define MCDE_TVBLUB_TVBCB(__x) \
	MCDE_VAL2REG(MCDE_TVBLUB, TVBCB, __x)
#define MCDE_TVBLUB_TVBCR_SHIFT 16
#define MCDE_TVBLUB_TVBCR_MASK 0x00FF0000
#define MCDE_TVBLUB_TVBCR(__x) \
	MCDE_VAL2REG(MCDE_TVBLUB, TVBCR, __x)
#define MCDE_LCDTIM1A 0x00000860
#define MCDE_LCDTIM1A_GROUPOFFSET 0x200
#define MCDE_LCDTIM1A_IVP_SHIFT 19
#define MCDE_LCDTIM1A_IVP_MASK 0x00080000
#define MCDE_LCDTIM1A_IVP(__x) \
	MCDE_VAL2REG(MCDE_LCDTIM1A, IVP, __x)
#define MCDE_LCDTIM1A_IVS_SHIFT 20
#define MCDE_LCDTIM1A_IVS_MASK 0x00100000
#define MCDE_LCDTIM1A_IVS(__x) \
	MCDE_VAL2REG(MCDE_LCDTIM1A, IVS, __x)
#define MCDE_LCDTIM1A_IHS_SHIFT 21
#define MCDE_LCDTIM1A_IHS_MASK 0x00200000
#define MCDE_LCDTIM1A_IHS(__x) \
	MCDE_VAL2REG(MCDE_LCDTIM1A, IHS, __x)
#define MCDE_LCDTIM1A_IPC_SHIFT 22
#define MCDE_LCDTIM1A_IPC_MASK 0x00400000
#define MCDE_LCDTIM1A_IPC(__x) \
	MCDE_VAL2REG(MCDE_LCDTIM1A, IPC, __x)
#define MCDE_LCDTIM1A_IOE_SHIFT 23
#define MCDE_LCDTIM1A_IOE_MASK 0x00800000
#define MCDE_LCDTIM1A_IOE(__x) \
	MCDE_VAL2REG(MCDE_LCDTIM1A, IOE, __x)
#define MCDE_LCDTIM1B 0x00000A60
#define MCDE_LCDTIM1B_IVP_SHIFT 19
#define MCDE_LCDTIM1B_IVP_MASK 0x00080000
#define MCDE_LCDTIM1B_IVP(__x) \
	MCDE_VAL2REG(MCDE_LCDTIM1B, IVP, __x)
#define MCDE_LCDTIM1B_IVS_SHIFT 20
#define MCDE_LCDTIM1B_IVS_MASK 0x00100000
#define MCDE_LCDTIM1B_IVS(__x) \
	MCDE_VAL2REG(MCDE_LCDTIM1B, IVS, __x)
#define MCDE_LCDTIM1B_IHS_SHIFT 21
#define MCDE_LCDTIM1B_IHS_MASK 0x00200000
#define MCDE_LCDTIM1B_IHS(__x) \
	MCDE_VAL2REG(MCDE_LCDTIM1B, IHS, __x)
#define MCDE_LCDTIM1B_IPC_SHIFT 22
#define MCDE_LCDTIM1B_IPC_MASK 0x00400000
#define MCDE_LCDTIM1B_IPC(__x) \
	MCDE_VAL2REG(MCDE_LCDTIM1B, IPC, __x)
#define MCDE_LCDTIM1B_IOE_SHIFT 23
#define MCDE_LCDTIM1B_IOE_MASK 0x00800000
#define MCDE_LCDTIM1B_IOE(__x) \
	MCDE_VAL2REG(MCDE_LCDTIM1B, IOE, __x)
#define MCDE_DITCTRLA 0x00000864
#define MCDE_DITCTRLA_GROUPOFFSET 0x200
#define MCDE_DITCTRLA_TEMP_SHIFT 0
#define MCDE_DITCTRLA_TEMP_MASK 0x00000001
#define MCDE_DITCTRLA_TEMP(__x) \
	MCDE_VAL2REG(MCDE_DITCTRLA, TEMP, __x)
#define MCDE_DITCTRLA_COMP_SHIFT 1
#define MCDE_DITCTRLA_COMP_MASK 0x00000002
#define MCDE_DITCTRLA_COMP(__x) \
	MCDE_VAL2REG(MCDE_DITCTRLA, COMP, __x)
#define MCDE_DITCTRLA_MASK_SHIFT 4
#define MCDE_DITCTRLA_MASK_MASK 0x00000010
#define MCDE_DITCTRLA_MASK(__x) \
	MCDE_VAL2REG(MCDE_DITCTRLA, MASK, __x)
#define MCDE_DITCTRLA_FOFFX_SHIFT 5
#define MCDE_DITCTRLA_FOFFX_MASK 0x000003E0
#define MCDE_DITCTRLA_FOFFX(__x) \
	MCDE_VAL2REG(MCDE_DITCTRLA, FOFFX, __x)
#define MCDE_DITCTRLA_FOFFY_SHIFT 10
#define MCDE_DITCTRLA_FOFFY_MASK 0x00007C00
#define MCDE_DITCTRLA_FOFFY(__x) \
	MCDE_VAL2REG(MCDE_DITCTRLA, FOFFY, __x)
#define MCDE_DITCTRLB 0x00000A64
#define MCDE_DITCTRLB_TEMP_SHIFT 0
#define MCDE_DITCTRLB_TEMP_MASK 0x00000001
#define MCDE_DITCTRLB_TEMP(__x) \
	MCDE_VAL2REG(MCDE_DITCTRLB, TEMP, __x)
#define MCDE_DITCTRLB_COMP_SHIFT 1
#define MCDE_DITCTRLB_COMP_MASK 0x00000002
#define MCDE_DITCTRLB_COMP(__x) \
	MCDE_VAL2REG(MCDE_DITCTRLB, COMP, __x)
#define MCDE_DITCTRLB_MASK_SHIFT 4
#define MCDE_DITCTRLB_MASK_MASK 0x00000010
#define MCDE_DITCTRLB_MASK(__x) \
	MCDE_VAL2REG(MCDE_DITCTRLB, MASK, __x)
#define MCDE_DITCTRLB_FOFFX_SHIFT 5
#define MCDE_DITCTRLB_FOFFX_MASK 0x000003E0
#define MCDE_DITCTRLB_FOFFX(__x) \
	MCDE_VAL2REG(MCDE_DITCTRLB, FOFFX, __x)
#define MCDE_DITCTRLB_FOFFY_SHIFT 10
#define MCDE_DITCTRLB_FOFFY_MASK 0x00007C00
#define MCDE_DITCTRLB_FOFFY(__x) \
	MCDE_VAL2REG(MCDE_DITCTRLB, FOFFY, __x)
#define MCDE_DITOFFA 0x00000868
#define MCDE_DITOFFA_GROUPOFFSET 0x200
#define MCDE_DITOFFA_XG_SHIFT 0
#define MCDE_DITOFFA_XG_MASK 0x0000001F
#define MCDE_DITOFFA_XG(__x) \
	MCDE_VAL2REG(MCDE_DITOFFA, XG, __x)
#define MCDE_DITOFFA_YG_SHIFT 8
#define MCDE_DITOFFA_YG_MASK 0x00001F00
#define MCDE_DITOFFA_YG(__x) \
	MCDE_VAL2REG(MCDE_DITOFFA, YG, __x)
#define MCDE_DITOFFA_XB_SHIFT 16
#define MCDE_DITOFFA_XB_MASK 0x001F0000
#define MCDE_DITOFFA_XB(__x) \
	MCDE_VAL2REG(MCDE_DITOFFA, XB, __x)
#define MCDE_DITOFFA_YB_SHIFT 24
#define MCDE_DITOFFA_YB_MASK 0x1F000000
#define MCDE_DITOFFA_YB(__x) \
	MCDE_VAL2REG(MCDE_DITOFFA, YB, __x)
#define MCDE_DITOFFB 0x00000A68
#define MCDE_DITOFFB_XG_SHIFT 0
#define MCDE_DITOFFB_XG_MASK 0x0000001F
#define MCDE_DITOFFB_XG(__x) \
	MCDE_VAL2REG(MCDE_DITOFFB, XG, __x)
#define MCDE_DITOFFB_YG_SHIFT 8
#define MCDE_DITOFFB_YG_MASK 0x00001F00
#define MCDE_DITOFFB_YG(__x) \
	MCDE_VAL2REG(MCDE_DITOFFB, YG, __x)
#define MCDE_DITOFFB_XB_SHIFT 16
#define MCDE_DITOFFB_XB_MASK 0x001F0000
#define MCDE_DITOFFB_XB(__x) \
	MCDE_VAL2REG(MCDE_DITOFFB, XB, __x)
#define MCDE_DITOFFB_YB_SHIFT 24
#define MCDE_DITOFFB_YB_MASK 0x1F000000
#define MCDE_DITOFFB_YB(__x) \
	MCDE_VAL2REG(MCDE_DITOFFB, YB, __x)
#define MCDE_PAL0A 0x0000086C
#define MCDE_PAL0A_GROUPOFFSET 0x200
#define MCDE_PAL0A_BLUE_SHIFT 0
#define MCDE_PAL0A_BLUE_MASK 0x00000FFF
#define MCDE_PAL0A_BLUE(__x) \
	MCDE_VAL2REG(MCDE_PAL0A, BLUE, __x)
#define MCDE_PAL0A_GREEN_SHIFT 16
#define MCDE_PAL0A_GREEN_MASK 0x0FFF0000
#define MCDE_PAL0A_GREEN(__x) \
	MCDE_VAL2REG(MCDE_PAL0A, GREEN, __x)
#define MCDE_PAL0B 0x00000A6C
#define MCDE_PAL0B_BLUE_SHIFT 0
#define MCDE_PAL0B_BLUE_MASK 0x00000FFF
#define MCDE_PAL0B_BLUE(__x) \
	MCDE_VAL2REG(MCDE_PAL0B, BLUE, __x)
#define MCDE_PAL0B_GREEN_SHIFT 16
#define MCDE_PAL0B_GREEN_MASK 0x0FFF0000
#define MCDE_PAL0B_GREEN(__x) \
	MCDE_VAL2REG(MCDE_PAL0B, GREEN, __x)
#define MCDE_PAL1A 0x00000870
#define MCDE_PAL1A_GROUPOFFSET 0x200
#define MCDE_PAL1A_RED_SHIFT 0
#define MCDE_PAL1A_RED_MASK 0x00000FFF
#define MCDE_PAL1A_RED(__x) \
	MCDE_VAL2REG(MCDE_PAL1A, RED, __x)
#define MCDE_PAL1B 0x00000A70
#define MCDE_PAL1B_RED_SHIFT 0
#define MCDE_PAL1B_RED_MASK 0x00000FFF
#define MCDE_PAL1B_RED(__x) \
	MCDE_VAL2REG(MCDE_PAL1B, RED, __x)
#define MCDE_ROTADD0A 0x00000874
#define MCDE_ROTADD0A_GROUPOFFSET 0x200
#define MCDE_ROTADD0A_ROTADD0_SHIFT 3
#define MCDE_ROTADD0A_ROTADD0_MASK 0xFFFFFFF8
#define MCDE_ROTADD0A_ROTADD0(__x) \
	MCDE_VAL2REG(MCDE_ROTADD0A, ROTADD0, __x)
#define MCDE_ROTADD0B 0x00000A74
#define MCDE_ROTADD0B_ROTADD0_SHIFT 3
#define MCDE_ROTADD0B_ROTADD0_MASK 0xFFFFFFF8
#define MCDE_ROTADD0B_ROTADD0(__x) \
	MCDE_VAL2REG(MCDE_ROTADD0B, ROTADD0, __x)
#define MCDE_ROTADD1A 0x00000878
#define MCDE_ROTADD1A_GROUPOFFSET 0x200
#define MCDE_ROTADD1A_ROTADD1_SHIFT 3
#define MCDE_ROTADD1A_ROTADD1_MASK 0xFFFFFFF8
#define MCDE_ROTADD1A_ROTADD1(__x) \
	MCDE_VAL2REG(MCDE_ROTADD1A, ROTADD1, __x)
#define MCDE_ROTADD1B 0x00000A78
#define MCDE_ROTADD1B_ROTADD1_SHIFT 3
#define MCDE_ROTADD1B_ROTADD1_MASK 0xFFFFFFF8
#define MCDE_ROTADD1B_ROTADD1(__x) \
	MCDE_VAL2REG(MCDE_ROTADD1B, ROTADD1, __x)
#define MCDE_ROTACONF 0x0000087C
#define MCDE_ROTACONF_GROUPOFFSET 0x200
#define MCDE_ROTACONF_ROTBURSTSIZE_SHIFT 0
#define MCDE_ROTACONF_ROTBURSTSIZE_MASK 0x00000003
#define MCDE_ROTACONF_ROTBURSTSIZE_1W 0
#define MCDE_ROTACONF_ROTBURSTSIZE_2W 1
#define MCDE_ROTACONF_ROTBURSTSIZE_4W 2
#define MCDE_ROTACONF_ROTBURSTSIZE_8W 3
#define MCDE_ROTACONF_ROTBURSTSIZE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_ROTACONF, ROTBURSTSIZE, \
	MCDE_ROTACONF_ROTBURSTSIZE_##__x)
#define MCDE_ROTACONF_ROTBURSTSIZE(__x) \
	MCDE_VAL2REG(MCDE_ROTACONF, ROTBURSTSIZE, __x)
#define MCDE_ROTACONF_ROTBURSTSIZE_HW_SHIFT 2
#define MCDE_ROTACONF_ROTBURSTSIZE_HW_MASK 0x00000004
#define MCDE_ROTACONF_ROTBURSTSIZE_HW(__x) \
	MCDE_VAL2REG(MCDE_ROTACONF, ROTBURSTSIZE_HW, __x)
#define MCDE_ROTACONF_ROTDIR_SHIFT 3
#define MCDE_ROTACONF_ROTDIR_MASK 0x00000008
#define MCDE_ROTACONF_ROTDIR_CCW 0
#define MCDE_ROTACONF_ROTDIR_CW 1
#define MCDE_ROTACONF_ROTDIR_ENUM(__x) \
	MCDE_VAL2REG(MCDE_ROTACONF, ROTDIR, MCDE_ROTACONF_ROTDIR_##__x)
#define MCDE_ROTACONF_ROTDIR(__x) \
	MCDE_VAL2REG(MCDE_ROTACONF, ROTDIR, __x)
#define MCDE_ROTACONF_WR_MAXOUT_SHIFT 4
#define MCDE_ROTACONF_WR_MAXOUT_MASK 0x00000030
#define MCDE_ROTACONF_WR_MAXOUT_1_REQ 0
#define MCDE_ROTACONF_WR_MAXOUT_2_REQ 1
#define MCDE_ROTACONF_WR_MAXOUT_4_REQ 2
#define MCDE_ROTACONF_WR_MAXOUT_8_REQ 3
#define MCDE_ROTACONF_WR_MAXOUT_ENUM(__x) \
	MCDE_VAL2REG(MCDE_ROTACONF, WR_MAXOUT, MCDE_ROTACONF_WR_MAXOUT_##__x)
#define MCDE_ROTACONF_WR_MAXOUT(__x) \
	MCDE_VAL2REG(MCDE_ROTACONF, WR_MAXOUT, __x)
#define MCDE_ROTACONF_RD_MAXOUT_SHIFT 6
#define MCDE_ROTACONF_RD_MAXOUT_MASK 0x000000C0
#define MCDE_ROTACONF_RD_MAXOUT_1_REQ 0
#define MCDE_ROTACONF_RD_MAXOUT_2_REQ 1
#define MCDE_ROTACONF_RD_MAXOUT_4_REQ 2
#define MCDE_ROTACONF_RD_MAXOUT_8_REQ 3
#define MCDE_ROTACONF_RD_MAXOUT_ENUM(__x) \
	MCDE_VAL2REG(MCDE_ROTACONF, RD_MAXOUT, MCDE_ROTACONF_RD_MAXOUT_##__x)
#define MCDE_ROTACONF_RD_MAXOUT(__x) \
	MCDE_VAL2REG(MCDE_ROTACONF, RD_MAXOUT, __x)
#define MCDE_ROTACONF_STRIP_WIDTH_SHIFT 8
#define MCDE_ROTACONF_STRIP_WIDTH_MASK 0x00007F00
#define MCDE_ROTACONF_STRIP_WIDTH_2PIX 0
#define MCDE_ROTACONF_STRIP_WIDTH_4PIX 1
#define MCDE_ROTACONF_STRIP_WIDTH_8PIX 2
#define MCDE_ROTACONF_STRIP_WIDTH_16PIX 3
#define MCDE_ROTACONF_STRIP_WIDTH_32PIX 4
#define MCDE_ROTACONF_STRIP_WIDTH_ENUM(__x) \
	MCDE_VAL2REG(MCDE_ROTACONF, STRIP_WIDTH, \
	MCDE_ROTACONF_STRIP_WIDTH_##__x)
#define MCDE_ROTACONF_STRIP_WIDTH(__x) \
	MCDE_VAL2REG(MCDE_ROTACONF, STRIP_WIDTH, __x)
#define MCDE_ROTACONF_SINGLE_BUF_SHIFT 15
#define MCDE_ROTACONF_SINGLE_BUF_MASK 0x00008000
#define MCDE_ROTACONF_SINGLE_BUF(__x) \
	MCDE_VAL2REG(MCDE_ROTACONF, SINGLE_BUF, __x)
#define MCDE_ROTACONF_WR_ROPC_SHIFT 16
#define MCDE_ROTACONF_WR_ROPC_MASK 0x00FF0000
#define MCDE_ROTACONF_WR_ROPC(__x) \
	MCDE_VAL2REG(MCDE_ROTACONF, WR_ROPC, __x)
#define MCDE_ROTACONF_RD_ROPC_SHIFT 24
#define MCDE_ROTACONF_RD_ROPC_MASK 0xFF000000
#define MCDE_ROTACONF_RD_ROPC(__x) \
	MCDE_VAL2REG(MCDE_ROTACONF, RD_ROPC, __x)
#define MCDE_ROTBCONF 0x00000A7C
#define MCDE_ROTBCONF_ROTBURSTSIZE_SHIFT 0
#define MCDE_ROTBCONF_ROTBURSTSIZE_MASK 0x00000003
#define MCDE_ROTBCONF_ROTBURSTSIZE_1W 0
#define MCDE_ROTBCONF_ROTBURSTSIZE_2W 1
#define MCDE_ROTBCONF_ROTBURSTSIZE_4W 2
#define MCDE_ROTBCONF_ROTBURSTSIZE_8W 3
#define MCDE_ROTBCONF_ROTBURSTSIZE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_ROTBCONF, ROTBURSTSIZE, \
	MCDE_ROTBCONF_ROTBURSTSIZE_##__x)
#define MCDE_ROTBCONF_ROTBURSTSIZE(__x) \
	MCDE_VAL2REG(MCDE_ROTBCONF, ROTBURSTSIZE, __x)
#define MCDE_ROTBCONF_ROTBURSTSIZE_HW_SHIFT 2
#define MCDE_ROTBCONF_ROTBURSTSIZE_HW_MASK 0x00000004
#define MCDE_ROTBCONF_ROTBURSTSIZE_HW(__x) \
	MCDE_VAL2REG(MCDE_ROTBCONF, ROTBURSTSIZE_HW, __x)
#define MCDE_ROTBCONF_ROTDIR_SHIFT 3
#define MCDE_ROTBCONF_ROTDIR_MASK 0x00000008
#define MCDE_ROTBCONF_ROTDIR_CCW 0
#define MCDE_ROTBCONF_ROTDIR_CW 1
#define MCDE_ROTBCONF_ROTDIR_ENUM(__x) \
	MCDE_VAL2REG(MCDE_ROTBCONF, ROTDIR, MCDE_ROTBCONF_ROTDIR_##__x)
#define MCDE_ROTBCONF_ROTDIR(__x) \
	MCDE_VAL2REG(MCDE_ROTBCONF, ROTDIR, __x)
#define MCDE_ROTBCONF_WR_MAXOUT_SHIFT 4
#define MCDE_ROTBCONF_WR_MAXOUT_MASK 0x00000030
#define MCDE_ROTBCONF_WR_MAXOUT_1_REQ 0
#define MCDE_ROTBCONF_WR_MAXOUT_2_REQ 1
#define MCDE_ROTBCONF_WR_MAXOUT_4_REQ 2
#define MCDE_ROTBCONF_WR_MAXOUT_8_REQ 3
#define MCDE_ROTBCONF_WR_MAXOUT_ENUM(__x) \
	MCDE_VAL2REG(MCDE_ROTBCONF, WR_MAXOUT, MCDE_ROTBCONF_WR_MAXOUT_##__x)
#define MCDE_ROTBCONF_WR_MAXOUT(__x) \
	MCDE_VAL2REG(MCDE_ROTBCONF, WR_MAXOUT, __x)
#define MCDE_ROTBCONF_RD_MAXOUT_SHIFT 6
#define MCDE_ROTBCONF_RD_MAXOUT_MASK 0x000000C0
#define MCDE_ROTBCONF_RD_MAXOUT_1_REQ 0
#define MCDE_ROTBCONF_RD_MAXOUT_2_REQ 1
#define MCDE_ROTBCONF_RD_MAXOUT_4_REQ 2
#define MCDE_ROTBCONF_RD_MAXOUT_8_REQ 3
#define MCDE_ROTBCONF_RD_MAXOUT_ENUM(__x) \
	MCDE_VAL2REG(MCDE_ROTBCONF, RD_MAXOUT, MCDE_ROTBCONF_RD_MAXOUT_##__x)
#define MCDE_ROTBCONF_RD_MAXOUT(__x) \
	MCDE_VAL2REG(MCDE_ROTBCONF, RD_MAXOUT, __x)
#define MCDE_ROTBCONF_STRIP_WIDTH_SHIFT 8
#define MCDE_ROTBCONF_STRIP_WIDTH_MASK 0x00007F00
#define MCDE_ROTBCONF_STRIP_WIDTH_2PIX 0
#define MCDE_ROTBCONF_STRIP_WIDTH_4PIX 1
#define MCDE_ROTBCONF_STRIP_WIDTH_8PIX 2
#define MCDE_ROTBCONF_STRIP_WIDTH_16PIX 3
#define MCDE_ROTBCONF_STRIP_WIDTH_32PIX 4
#define MCDE_ROTBCONF_STRIP_WIDTH_ENUM(__x) \
	MCDE_VAL2REG(MCDE_ROTBCONF, STRIP_WIDTH, \
	MCDE_ROTBCONF_STRIP_WIDTH_##__x)
#define MCDE_ROTBCONF_STRIP_WIDTH(__x) \
	MCDE_VAL2REG(MCDE_ROTBCONF, STRIP_WIDTH, __x)
#define MCDE_ROTBCONF_SINGLE_BUF_SHIFT 15
#define MCDE_ROTBCONF_SINGLE_BUF_MASK 0x00008000
#define MCDE_ROTBCONF_SINGLE_BUF(__x) \
	MCDE_VAL2REG(MCDE_ROTBCONF, SINGLE_BUF, __x)
#define MCDE_ROTBCONF_WR_ROPC_SHIFT 16
#define MCDE_ROTBCONF_WR_ROPC_MASK 0x00FF0000
#define MCDE_ROTBCONF_WR_ROPC(__x) \
	MCDE_VAL2REG(MCDE_ROTBCONF, WR_ROPC, __x)
#define MCDE_ROTBCONF_RD_ROPC_SHIFT 24
#define MCDE_ROTBCONF_RD_ROPC_MASK 0xFF000000
#define MCDE_ROTBCONF_RD_ROPC(__x) \
	MCDE_VAL2REG(MCDE_ROTBCONF, RD_ROPC, __x)
#define MCDE_SYNCHCONFA 0x00000880
#define MCDE_SYNCHCONFA_GROUPOFFSET 0x200
#define MCDE_SYNCHCONFA_HWREQVEVENT_SHIFT 0
#define MCDE_SYNCHCONFA_HWREQVEVENT_MASK 0x00000003
#define MCDE_SYNCHCONFA_HWREQVEVENT_VSYNC 0
#define MCDE_SYNCHCONFA_HWREQVEVENT_BACK_PORCH 1
#define MCDE_SYNCHCONFA_HWREQVEVENT_ACTIVE_VIDEO 2
#define MCDE_SYNCHCONFA_HWREQVEVENT_FRONT_PORCH 3
#define MCDE_SYNCHCONFA_HWREQVEVENT_ENUM(__x) \
	MCDE_VAL2REG(MCDE_SYNCHCONFA, HWREQVEVENT, \
	MCDE_SYNCHCONFA_HWREQVEVENT_##__x)
#define MCDE_SYNCHCONFA_HWREQVEVENT(__x) \
	MCDE_VAL2REG(MCDE_SYNCHCONFA, HWREQVEVENT, __x)
#define MCDE_SYNCHCONFA_HWREQVCNT_SHIFT 2
#define MCDE_SYNCHCONFA_HWREQVCNT_MASK 0x0000FFFC
#define MCDE_SYNCHCONFA_HWREQVCNT(__x) \
	MCDE_VAL2REG(MCDE_SYNCHCONFA, HWREQVCNT, __x)
#define MCDE_SYNCHCONFA_SWINTVEVENT_SHIFT 16
#define MCDE_SYNCHCONFA_SWINTVEVENT_MASK 0x00030000
#define MCDE_SYNCHCONFA_SWINTVEVENT_VSYNC 0
#define MCDE_SYNCHCONFA_SWINTVEVENT_BACK_PORCH 1
#define MCDE_SYNCHCONFA_SWINTVEVENT_ACTIVE_VIDEO 2
#define MCDE_SYNCHCONFA_SWINTVEVENT_FRONT_PORCH 3
#define MCDE_SYNCHCONFA_SWINTVEVENT_ENUM(__x) \
	MCDE_VAL2REG(MCDE_SYNCHCONFA, SWINTVEVENT, \
	MCDE_SYNCHCONFA_SWINTVEVENT_##__x)
#define MCDE_SYNCHCONFA_SWINTVEVENT(__x) \
	MCDE_VAL2REG(MCDE_SYNCHCONFA, SWINTVEVENT, __x)
#define MCDE_SYNCHCONFA_SWINTVCNT_SHIFT 18
#define MCDE_SYNCHCONFA_SWINTVCNT_MASK 0xFFFC0000
#define MCDE_SYNCHCONFA_SWINTVCNT(__x) \
	MCDE_VAL2REG(MCDE_SYNCHCONFA, SWINTVCNT, __x)
#define MCDE_SYNCHCONFB 0x00000A80
#define MCDE_SYNCHCONFB_HWREQVEVENT_SHIFT 0
#define MCDE_SYNCHCONFB_HWREQVEVENT_MASK 0x00000003
#define MCDE_SYNCHCONFB_HWREQVEVENT_VSYNC 0
#define MCDE_SYNCHCONFB_HWREQVEVENT_BACK_PORCH 1
#define MCDE_SYNCHCONFB_HWREQVEVENT_ACTIVE_VIDEO 2
#define MCDE_SYNCHCONFB_HWREQVEVENT_FRONT_PORCH 3
#define MCDE_SYNCHCONFB_HWREQVEVENT_ENUM(__x) \
	MCDE_VAL2REG(MCDE_SYNCHCONFB, HWREQVEVENT, \
	MCDE_SYNCHCONFB_HWREQVEVENT_##__x)
#define MCDE_SYNCHCONFB_HWREQVEVENT(__x) \
	MCDE_VAL2REG(MCDE_SYNCHCONFB, HWREQVEVENT, __x)
#define MCDE_SYNCHCONFB_HWREQVCNT_SHIFT 2
#define MCDE_SYNCHCONFB_HWREQVCNT_MASK 0x0000FFFC
#define MCDE_SYNCHCONFB_HWREQVCNT(__x) \
	MCDE_VAL2REG(MCDE_SYNCHCONFB, HWREQVCNT, __x)
#define MCDE_SYNCHCONFB_SWINTVEVENT_SHIFT 16
#define MCDE_SYNCHCONFB_SWINTVEVENT_MASK 0x00030000
#define MCDE_SYNCHCONFB_SWINTVEVENT_VSYNC 0
#define MCDE_SYNCHCONFB_SWINTVEVENT_BACK_PORCH 1
#define MCDE_SYNCHCONFB_SWINTVEVENT_ACTIVE_VIDEO 2
#define MCDE_SYNCHCONFB_SWINTVEVENT_FRONT_PORCH 3
#define MCDE_SYNCHCONFB_SWINTVEVENT_ENUM(__x) \
	MCDE_VAL2REG(MCDE_SYNCHCONFB, SWINTVEVENT, \
	MCDE_SYNCHCONFB_SWINTVEVENT_##__x)
#define MCDE_SYNCHCONFB_SWINTVEVENT(__x) \
	MCDE_VAL2REG(MCDE_SYNCHCONFB, SWINTVEVENT, __x)
#define MCDE_SYNCHCONFB_SWINTVCNT_SHIFT 18
#define MCDE_SYNCHCONFB_SWINTVCNT_MASK 0xFFFC0000
#define MCDE_SYNCHCONFB_SWINTVCNT(__x) \
	MCDE_VAL2REG(MCDE_SYNCHCONFB, SWINTVCNT, __x)
#define MCDE_CTRLA 0x00000884
#define MCDE_CTRLA_GROUPOFFSET 0x200
#define MCDE_CTRLA_FIFOWTRMRK_SHIFT 0
#define MCDE_CTRLA_FIFOWTRMRK_MASK 0x000003FF
#define MCDE_CTRLA_FIFOWTRMRK(__x) \
	MCDE_VAL2REG(MCDE_CTRLA, FIFOWTRMRK, __x)
#define MCDE_CTRLA_FIFOEMPTY_SHIFT 12
#define MCDE_CTRLA_FIFOEMPTY_MASK 0x00001000
#define MCDE_CTRLA_FIFOEMPTY(__x) \
	MCDE_VAL2REG(MCDE_CTRLA, FIFOEMPTY, __x)
#define MCDE_CTRLA_FIFOFULL_SHIFT 13
#define MCDE_CTRLA_FIFOFULL_MASK 0x00002000
#define MCDE_CTRLA_FIFOFULL(__x) \
	MCDE_VAL2REG(MCDE_CTRLA, FIFOFULL, __x)
#define MCDE_CTRLA_FORMID_SHIFT 16
#define MCDE_CTRLA_FORMID_MASK 0x00070000
#define MCDE_CTRLA_FORMID_DSI0VID 0
#define MCDE_CTRLA_FORMID_DSI0CMD 1
#define MCDE_CTRLA_FORMID_DSI1VID 2
#define MCDE_CTRLA_FORMID_DSI1CMD 3
#define MCDE_CTRLA_FORMID_DSI2VID 4
#define MCDE_CTRLA_FORMID_DSI2CMD 5
#define MCDE_CTRLA_FORMID_DPIA 0
#define MCDE_CTRLA_FORMID_DPIB 1
#define MCDE_CTRLA_FORMID_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CTRLA, FORMID, MCDE_CTRLA_FORMID_##__x)
#define MCDE_CTRLA_FORMID(__x) \
	MCDE_VAL2REG(MCDE_CTRLA, FORMID, __x)
#define MCDE_CTRLA_FORMTYPE_SHIFT 20
#define MCDE_CTRLA_FORMTYPE_MASK 0x00700000
#define MCDE_CTRLA_FORMTYPE_DPITV 0
#define MCDE_CTRLA_FORMTYPE_DBI 1
#define MCDE_CTRLA_FORMTYPE_DSI 2
#define MCDE_CTRLA_FORMTYPE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CTRLA, FORMTYPE, MCDE_CTRLA_FORMTYPE_##__x)
#define MCDE_CTRLA_FORMTYPE(__x) \
	MCDE_VAL2REG(MCDE_CTRLA, FORMTYPE, __x)
#define MCDE_CTRLB 0x00000A84
#define MCDE_CTRLB_FIFOWTRMRK_SHIFT 0
#define MCDE_CTRLB_FIFOWTRMRK_MASK 0x000003FF
#define MCDE_CTRLB_FIFOWTRMRK(__x) \
	MCDE_VAL2REG(MCDE_CTRLB, FIFOWTRMRK, __x)
#define MCDE_CTRLB_FIFOEMPTY_SHIFT 12
#define MCDE_CTRLB_FIFOEMPTY_MASK 0x00001000
#define MCDE_CTRLB_FIFOEMPTY(__x) \
	MCDE_VAL2REG(MCDE_CTRLB, FIFOEMPTY, __x)
#define MCDE_CTRLB_FIFOFULL_SHIFT 13
#define MCDE_CTRLB_FIFOFULL_MASK 0x00002000
#define MCDE_CTRLB_FIFOFULL(__x) \
	MCDE_VAL2REG(MCDE_CTRLB, FIFOFULL, __x)
#define MCDE_CTRLB_FORMID_SHIFT 16
#define MCDE_CTRLB_FORMID_MASK 0x00070000
#define MCDE_CTRLB_FORMID_DSI0VID 0
#define MCDE_CTRLB_FORMID_DSI0CMD 1
#define MCDE_CTRLB_FORMID_DSI1VID 2
#define MCDE_CTRLB_FORMID_DSI1CMD 3
#define MCDE_CTRLB_FORMID_DSI2VID 4
#define MCDE_CTRLB_FORMID_DSI2CMD 5
#define MCDE_CTRLB_FORMID_DPIA 0
#define MCDE_CTRLB_FORMID_DPIB 1
#define MCDE_CTRLB_FORMID_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CTRLB, FORMID, MCDE_CTRLB_FORMID_##__x)
#define MCDE_CTRLB_FORMID(__x) \
	MCDE_VAL2REG(MCDE_CTRLB, FORMID, __x)
#define MCDE_CTRLB_FORMTYPE_SHIFT 20
#define MCDE_CTRLB_FORMTYPE_MASK 0x00700000
#define MCDE_CTRLB_FORMTYPE_DPITV 0
#define MCDE_CTRLB_FORMTYPE_DBI 1
#define MCDE_CTRLB_FORMTYPE_DSI 2
#define MCDE_CTRLB_FORMTYPE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CTRLB, FORMTYPE, MCDE_CTRLB_FORMTYPE_##__x)
#define MCDE_CTRLB_FORMTYPE(__x) \
	MCDE_VAL2REG(MCDE_CTRLB, FORMTYPE, __x)
#define MCDE_GAM0A 0x00000888
#define MCDE_GAM0A_GROUPOFFSET 0x200
#define MCDE_GAM0A_BLUE_SHIFT 0
#define MCDE_GAM0A_BLUE_MASK 0x00FFFFFF
#define MCDE_GAM0A_BLUE(__x) \
	MCDE_VAL2REG(MCDE_GAM0A, BLUE, __x)
#define MCDE_GAM0B 0x00000A88
#define MCDE_GAM0B_BLUE_SHIFT 0
#define MCDE_GAM0B_BLUE_MASK 0x00FFFFFF
#define MCDE_GAM0B_BLUE(__x) \
	MCDE_VAL2REG(MCDE_GAM0B, BLUE, __x)
#define MCDE_GAM1A 0x0000088C
#define MCDE_GAM1A_GROUPOFFSET 0x200
#define MCDE_GAM1A_GREEN_SHIFT 0
#define MCDE_GAM1A_GREEN_MASK 0x00FFFFFF
#define MCDE_GAM1A_GREEN(__x) \
	MCDE_VAL2REG(MCDE_GAM1A, GREEN, __x)
#define MCDE_GAM1B 0x00000A8C
#define MCDE_GAM1B_GREEN_SHIFT 0
#define MCDE_GAM1B_GREEN_MASK 0x00FFFFFF
#define MCDE_GAM1B_GREEN(__x) \
	MCDE_VAL2REG(MCDE_GAM1B, GREEN, __x)
#define MCDE_GAM2A 0x00000890
#define MCDE_GAM2A_GROUPOFFSET 0x200
#define MCDE_GAM2A_RED_SHIFT 0
#define MCDE_GAM2A_RED_MASK 0x00FFFFFF
#define MCDE_GAM2A_RED(__x) \
	MCDE_VAL2REG(MCDE_GAM2A, RED, __x)
#define MCDE_GAM2B 0x00000A90
#define MCDE_GAM2B_RED_SHIFT 0
#define MCDE_GAM2B_RED_MASK 0x00FFFFFF
#define MCDE_GAM2B_RED(__x) \
	MCDE_VAL2REG(MCDE_GAM2B, RED, __x)
#define MCDE_OLEDCONV1A 0x00000894
#define MCDE_OLEDCONV1A_GROUPOFFSET 0x200
#define MCDE_OLEDCONV1A_ALPHA_RED_SHIFT 0
#define MCDE_OLEDCONV1A_ALPHA_RED_MASK 0x00003FFF
#define MCDE_OLEDCONV1A_ALPHA_RED(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV1A, ALPHA_RED, __x)
#define MCDE_OLEDCONV1A_ALPHA_GREEN_SHIFT 16
#define MCDE_OLEDCONV1A_ALPHA_GREEN_MASK 0x3FFF0000
#define MCDE_OLEDCONV1A_ALPHA_GREEN(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV1A, ALPHA_GREEN, __x)
#define MCDE_OLEDCONV1B 0x00000A94
#define MCDE_OLEDCONV1B_ALPHA_RED_SHIFT 0
#define MCDE_OLEDCONV1B_ALPHA_RED_MASK 0x00003FFF
#define MCDE_OLEDCONV1B_ALPHA_RED(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV1B, ALPHA_RED, __x)
#define MCDE_OLEDCONV1B_ALPHA_GREEN_SHIFT 16
#define MCDE_OLEDCONV1B_ALPHA_GREEN_MASK 0x3FFF0000
#define MCDE_OLEDCONV1B_ALPHA_GREEN(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV1B, ALPHA_GREEN, __x)
#define MCDE_OLEDCONV2A 0x00000898
#define MCDE_OLEDCONV2A_GROUPOFFSET 0x200
#define MCDE_OLEDCONV2A_ALPHA_BLUE_SHIFT 0
#define MCDE_OLEDCONV2A_ALPHA_BLUE_MASK 0x00003FFF
#define MCDE_OLEDCONV2A_ALPHA_BLUE(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV2A, ALPHA_BLUE, __x)
#define MCDE_OLEDCONV2A_BETA_RED_SHIFT 16
#define MCDE_OLEDCONV2A_BETA_RED_MASK 0x3FFF0000
#define MCDE_OLEDCONV2A_BETA_RED(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV2A, BETA_RED, __x)
#define MCDE_OLEDCONV2B 0x00000A98
#define MCDE_OLEDCONV2B_ALPHA_BLUE_SHIFT 0
#define MCDE_OLEDCONV2B_ALPHA_BLUE_MASK 0x00003FFF
#define MCDE_OLEDCONV2B_ALPHA_BLUE(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV2B, ALPHA_BLUE, __x)
#define MCDE_OLEDCONV2B_BETA_RED_SHIFT 16
#define MCDE_OLEDCONV2B_BETA_RED_MASK 0x3FFF0000
#define MCDE_OLEDCONV2B_BETA_RED(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV2B, BETA_RED, __x)
#define MCDE_OLEDCONV3A 0x0000089C
#define MCDE_OLEDCONV3A_GROUPOFFSET 0x200
#define MCDE_OLEDCONV3A_BETA_GREEN_SHIFT 0
#define MCDE_OLEDCONV3A_BETA_GREEN_MASK 0x00003FFF
#define MCDE_OLEDCONV3A_BETA_GREEN(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV3A, BETA_GREEN, __x)
#define MCDE_OLEDCONV3A_BETA_BLUE_SHIFT 16
#define MCDE_OLEDCONV3A_BETA_BLUE_MASK 0x3FFF0000
#define MCDE_OLEDCONV3A_BETA_BLUE(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV3A, BETA_BLUE, __x)
#define MCDE_OLEDCONV3B 0x00000A9C
#define MCDE_OLEDCONV3B_BETA_GREEN_SHIFT 0
#define MCDE_OLEDCONV3B_BETA_GREEN_MASK 0x00003FFF
#define MCDE_OLEDCONV3B_BETA_GREEN(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV3B, BETA_GREEN, __x)
#define MCDE_OLEDCONV3B_BETA_BLUE_SHIFT 16
#define MCDE_OLEDCONV3B_BETA_BLUE_MASK 0x3FFF0000
#define MCDE_OLEDCONV3B_BETA_BLUE(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV3B, BETA_BLUE, __x)
#define MCDE_OLEDCONV4A 0x000008A0
#define MCDE_OLEDCONV4A_GROUPOFFSET 0x200
#define MCDE_OLEDCONV4A_GAMMA_RED_SHIFT 0
#define MCDE_OLEDCONV4A_GAMMA_RED_MASK 0x00003FFF
#define MCDE_OLEDCONV4A_GAMMA_RED(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV4A, GAMMA_RED, __x)
#define MCDE_OLEDCONV4A_GAMMA_GREEN_SHIFT 16
#define MCDE_OLEDCONV4A_GAMMA_GREEN_MASK 0x3FFF0000
#define MCDE_OLEDCONV4A_GAMMA_GREEN(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV4A, GAMMA_GREEN, __x)
#define MCDE_OLEDCONV4B 0x00000AA0
#define MCDE_OLEDCONV4B_GAMMA_RED_SHIFT 0
#define MCDE_OLEDCONV4B_GAMMA_RED_MASK 0x00003FFF
#define MCDE_OLEDCONV4B_GAMMA_RED(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV4B, GAMMA_RED, __x)
#define MCDE_OLEDCONV4B_GAMMA_GREEN_SHIFT 16
#define MCDE_OLEDCONV4B_GAMMA_GREEN_MASK 0x3FFF0000
#define MCDE_OLEDCONV4B_GAMMA_GREEN(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV4B, GAMMA_GREEN, __x)
#define MCDE_OLEDCONV5A 0x000008A4
#define MCDE_OLEDCONV5A_GROUPOFFSET 0x200
#define MCDE_OLEDCONV5A_GAMMA_BLUE_SHIFT 0
#define MCDE_OLEDCONV5A_GAMMA_BLUE_MASK 0x00003FFF
#define MCDE_OLEDCONV5A_GAMMA_BLUE(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV5A, GAMMA_BLUE, __x)
#define MCDE_OLEDCONV5A_OFF_RED_SHIFT 16
#define MCDE_OLEDCONV5A_OFF_RED_MASK 0x3FFF0000
#define MCDE_OLEDCONV5A_OFF_RED(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV5A, OFF_RED, __x)
#define MCDE_OLEDCONV5B 0x00000AA4
#define MCDE_OLEDCONV5B_GAMMA_BLUE_SHIFT 0
#define MCDE_OLEDCONV5B_GAMMA_BLUE_MASK 0x00003FFF
#define MCDE_OLEDCONV5B_GAMMA_BLUE(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV5B, GAMMA_BLUE, __x)
#define MCDE_OLEDCONV5B_OFF_RED_SHIFT 16
#define MCDE_OLEDCONV5B_OFF_RED_MASK 0x3FFF0000
#define MCDE_OLEDCONV5B_OFF_RED(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV5B, OFF_RED, __x)
#define MCDE_OLEDCONV6A 0x000008A8
#define MCDE_OLEDCONV6A_GROUPOFFSET 0x200
#define MCDE_OLEDCONV6A_OFF_GREEN_SHIFT 0
#define MCDE_OLEDCONV6A_OFF_GREEN_MASK 0x00003FFF
#define MCDE_OLEDCONV6A_OFF_GREEN(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV6A, OFF_GREEN, __x)
#define MCDE_OLEDCONV6A_OFF_BLUE_SHIFT 16
#define MCDE_OLEDCONV6A_OFF_BLUE_MASK 0x3FFF0000
#define MCDE_OLEDCONV6A_OFF_BLUE(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV6A, OFF_BLUE, __x)
#define MCDE_OLEDCONV6B 0x00000AA8
#define MCDE_OLEDCONV6B_OFF_GREEN_SHIFT 0
#define MCDE_OLEDCONV6B_OFF_GREEN_MASK 0x00003FFF
#define MCDE_OLEDCONV6B_OFF_GREEN(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV6B, OFF_GREEN, __x)
#define MCDE_OLEDCONV6B_OFF_BLUE_SHIFT 16
#define MCDE_OLEDCONV6B_OFF_BLUE_MASK 0x3FFF0000
#define MCDE_OLEDCONV6B_OFF_BLUE(__x) \
	MCDE_VAL2REG(MCDE_OLEDCONV6B, OFF_BLUE, __x)
#define MCDE_CRC 0x00000C00
#define MCDE_CRC_FLOEN_SHIFT 0
#define MCDE_CRC_FLOEN_MASK 0x00000001
#define MCDE_CRC_FLOEN(__x) \
	MCDE_VAL2REG(MCDE_CRC, FLOEN, __x)
#define MCDE_CRC_POWEREN_SHIFT 1
#define MCDE_CRC_POWEREN_MASK 0x00000002
#define MCDE_CRC_POWEREN(__x) \
	MCDE_VAL2REG(MCDE_CRC, POWEREN, __x)
#define MCDE_CRC_C1EN_SHIFT 2
#define MCDE_CRC_C1EN_MASK 0x00000004
#define MCDE_CRC_C1EN(__x) \
	MCDE_VAL2REG(MCDE_CRC, C1EN, __x)
#define MCDE_CRC_C2EN_SHIFT 3
#define MCDE_CRC_C2EN_MASK 0x00000008
#define MCDE_CRC_C2EN(__x) \
	MCDE_VAL2REG(MCDE_CRC, C2EN, __x)
#define MCDE_CRC_WMLVL1_SHIFT 4
#define MCDE_CRC_WMLVL1_MASK 0x00000010
#define MCDE_CRC_WMLVL1(__x) \
	MCDE_VAL2REG(MCDE_CRC, WMLVL1, __x)
#define MCDE_CRC_WMLVL2_SHIFT 5
#define MCDE_CRC_WMLVL2_MASK 0x00000020
#define MCDE_CRC_WMLVL2(__x) \
	MCDE_VAL2REG(MCDE_CRC, WMLVL2, __x)
#define MCDE_CRC_SYNCSEL_SHIFT 6
#define MCDE_CRC_SYNCSEL_MASK 0x00000040
#define MCDE_CRC_SYNCSEL(__x) \
	MCDE_VAL2REG(MCDE_CRC, SYNCSEL, __x)
#define MCDE_CRC_SYCEN0_SHIFT 7
#define MCDE_CRC_SYCEN0_MASK 0x00000080
#define MCDE_CRC_SYCEN0(__x) \
	MCDE_VAL2REG(MCDE_CRC, SYCEN0, __x)
#define MCDE_CRC_SYCEN1_SHIFT 8
#define MCDE_CRC_SYCEN1_MASK 0x00000100
#define MCDE_CRC_SYCEN1(__x) \
	MCDE_VAL2REG(MCDE_CRC, SYCEN1, __x)
#define MCDE_CRC_SIZE1_SHIFT 9
#define MCDE_CRC_SIZE1_MASK 0x00000200
#define MCDE_CRC_SIZE1(__x) \
	MCDE_VAL2REG(MCDE_CRC, SIZE1, __x)
#define MCDE_CRC_SIZE2_SHIFT 10
#define MCDE_CRC_SIZE2_MASK 0x00000400
#define MCDE_CRC_SIZE2(__x) \
	MCDE_VAL2REG(MCDE_CRC, SIZE2, __x)
#define MCDE_CRC_INBAND1_SHIFT 11
#define MCDE_CRC_INBAND1_MASK 0x00000800
#define MCDE_CRC_INBAND1(__x) \
	MCDE_VAL2REG(MCDE_CRC, INBAND1, __x)
#define MCDE_CRC_INBAND2_SHIFT 12
#define MCDE_CRC_INBAND2_MASK 0x00001000
#define MCDE_CRC_INBAND2(__x) \
	MCDE_VAL2REG(MCDE_CRC, INBAND2, __x)
#define MCDE_CRC_CLKSEL_SHIFT 13
#define MCDE_CRC_CLKSEL_MASK 0x00006000
#define MCDE_CRC_CLKSEL_166MHz 0
#define MCDE_CRC_CLKSEL_48MHz 1
#define MCDE_CRC_CLKSEL_LCD 2
#define MCDE_CRC_CLKSEL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRC, CLKSEL, MCDE_CRC_CLKSEL_##__x)
#define MCDE_CRC_CLKSEL(__x) \
	MCDE_VAL2REG(MCDE_CRC, CLKSEL, __x)
#define MCDE_CRC_YUVCONVC1EN_SHIFT 15
#define MCDE_CRC_YUVCONVC1EN_MASK 0x00008000
#define MCDE_CRC_YUVCONVC1EN(__x) \
	MCDE_VAL2REG(MCDE_CRC, YUVCONVC1EN, __x)
#define MCDE_CRC_CS1EN_SHIFT 16
#define MCDE_CRC_CS1EN_MASK 0x00010000
#define MCDE_CRC_CS1EN(__x) \
	MCDE_VAL2REG(MCDE_CRC, CS1EN, __x)
#define MCDE_CRC_CS2EN_SHIFT 17
#define MCDE_CRC_CS2EN_MASK 0x00020000
#define MCDE_CRC_CS2EN(__x) \
	MCDE_VAL2REG(MCDE_CRC, CS2EN, __x)
#define MCDE_CRC_RESEN_SHIFT 18
#define MCDE_CRC_RESEN_MASK 0x00040000
#define MCDE_CRC_RESEN(__x) \
	MCDE_VAL2REG(MCDE_CRC, RESEN, __x)
#define MCDE_CRC_CS1POL_SHIFT 19
#define MCDE_CRC_CS1POL_MASK 0x00080000
#define MCDE_CRC_CS1POL(__x) \
	MCDE_VAL2REG(MCDE_CRC, CS1POL, __x)
#define MCDE_CRC_CS2POL_SHIFT 20
#define MCDE_CRC_CS2POL_MASK 0x00100000
#define MCDE_CRC_CS2POL(__x) \
	MCDE_VAL2REG(MCDE_CRC, CS2POL, __x)
#define MCDE_CRC_CD1POL_SHIFT 21
#define MCDE_CRC_CD1POL_MASK 0x00200000
#define MCDE_CRC_CD1POL(__x) \
	MCDE_VAL2REG(MCDE_CRC, CD1POL, __x)
#define MCDE_CRC_CD2POL_SHIFT 22
#define MCDE_CRC_CD2POL_MASK 0x00400000
#define MCDE_CRC_CD2POL(__x) \
	MCDE_VAL2REG(MCDE_CRC, CD2POL, __x)
#define MCDE_CRC_WR1POL_SHIFT 23
#define MCDE_CRC_WR1POL_MASK 0x00800000
#define MCDE_CRC_WR1POL(__x) \
	MCDE_VAL2REG(MCDE_CRC, WR1POL, __x)
#define MCDE_CRC_WR2POL_SHIFT 24
#define MCDE_CRC_WR2POL_MASK 0x01000000
#define MCDE_CRC_WR2POL(__x) \
	MCDE_VAL2REG(MCDE_CRC, WR2POL, __x)
#define MCDE_CRC_RD1POL_SHIFT 25
#define MCDE_CRC_RD1POL_MASK 0x02000000
#define MCDE_CRC_RD1POL(__x) \
	MCDE_VAL2REG(MCDE_CRC, RD1POL, __x)
#define MCDE_CRC_RD2POL_SHIFT 26
#define MCDE_CRC_RD2POL_MASK 0x04000000
#define MCDE_CRC_RD2POL(__x) \
	MCDE_VAL2REG(MCDE_CRC, RD2POL, __x)
#define MCDE_CRC_RES1POL_SHIFT 27
#define MCDE_CRC_RES1POL_MASK 0x08000000
#define MCDE_CRC_RES1POL(__x) \
	MCDE_VAL2REG(MCDE_CRC, RES1POL, __x)
#define MCDE_CRC_RES2POL_SHIFT 28
#define MCDE_CRC_RES2POL_MASK 0x10000000
#define MCDE_CRC_RES2POL(__x) \
	MCDE_VAL2REG(MCDE_CRC, RES2POL, __x)
#define MCDE_CRC_SYNCCTRL_SHIFT 29
#define MCDE_CRC_SYNCCTRL_MASK 0x60000000
#define MCDE_CRC_SYNCCTRL_OFF 0
#define MCDE_CRC_SYNCCTRL_C0 1
#define MCDE_CRC_SYNCCTRL_C1 2
#define MCDE_CRC_SYNCCTRL_PING_PONG 3
#define MCDE_CRC_SYNCCTRL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CRC, SYNCCTRL, MCDE_CRC_SYNCCTRL_##__x)
#define MCDE_CRC_SYNCCTRL(__x) \
	MCDE_VAL2REG(MCDE_CRC, SYNCCTRL, __x)
#define MCDE_CRC_CLAMPC1EN_SHIFT 31
#define MCDE_CRC_CLAMPC1EN_MASK 0x80000000
#define MCDE_CRC_CLAMPC1EN(__x) \
	MCDE_VAL2REG(MCDE_CRC, CLAMPC1EN, __x)
#define MCDE_PBCCRC0 0x00000C04
#define MCDE_PBCCRC0_GROUPOFFSET 0x4
#define MCDE_PBCCRC0_BSCM_SHIFT 0
#define MCDE_PBCCRC0_BSCM_MASK 0x00000007
#define MCDE_PBCCRC0_BSCM_1_8BIT 0
#define MCDE_PBCCRC0_BSCM_2_8BIT 1
#define MCDE_PBCCRC0_BSCM_3_8BIT 2
#define MCDE_PBCCRC0_BSCM_1_16BIT 3
#define MCDE_PBCCRC0_BSCM_2_16BIT 4
#define MCDE_PBCCRC0_BSCM_ENUM(__x) \
	MCDE_VAL2REG(MCDE_PBCCRC0, BSCM, MCDE_PBCCRC0_BSCM_##__x)
#define MCDE_PBCCRC0_BSCM(__x) \
	MCDE_VAL2REG(MCDE_PBCCRC0, BSCM, __x)
#define MCDE_PBCCRC0_BSDM_SHIFT 3
#define MCDE_PBCCRC0_BSDM_MASK 0x00000038
#define MCDE_PBCCRC0_BSDM_1_8BIT 0
#define MCDE_PBCCRC0_BSDM_2_8BIT 1
#define MCDE_PBCCRC0_BSDM_3_8BIT 2
#define MCDE_PBCCRC0_BSDM_1_16BIT 3
#define MCDE_PBCCRC0_BSDM_2_16BIT 4
#define MCDE_PBCCRC0_BSDM_ENUM(__x) \
	MCDE_VAL2REG(MCDE_PBCCRC0, BSDM, MCDE_PBCCRC0_BSDM_##__x)
#define MCDE_PBCCRC0_BSDM(__x) \
	MCDE_VAL2REG(MCDE_PBCCRC0, BSDM, __x)
#define MCDE_PBCCRC0_PDM_SHIFT 6
#define MCDE_PBCCRC0_PDM_MASK 0x000000C0
#define MCDE_PBCCRC0_PDM_NORMAL 0
#define MCDE_PBCCRC0_PDM_16_TO_32 1
#define MCDE_PBCCRC0_PDM_24_TO_32_RIGHT 2
#define MCDE_PBCCRC0_PDM_24_TO_32_LEFT 3
#define MCDE_PBCCRC0_PDM_ENUM(__x) \
	MCDE_VAL2REG(MCDE_PBCCRC0, PDM, MCDE_PBCCRC0_PDM_##__x)
#define MCDE_PBCCRC0_PDM(__x) \
	MCDE_VAL2REG(MCDE_PBCCRC0, PDM, __x)
#define MCDE_PBCCRC0_PDCTRL_SHIFT 12
#define MCDE_PBCCRC0_PDCTRL_MASK 0x00001000
#define MCDE_PBCCRC0_PDCTRL(__x) \
	MCDE_VAL2REG(MCDE_PBCCRC0, PDCTRL, __x)
#define MCDE_PBCCRC0_BPP_SHIFT 13
#define MCDE_PBCCRC0_BPP_MASK 0x0000E000
#define MCDE_PBCCRC0_BPP_8BPP 0
#define MCDE_PBCCRC0_BPP_12BPP 1
#define MCDE_PBCCRC0_BPP_15BPP 2
#define MCDE_PBCCRC0_BPP_16BPP 3
#define MCDE_PBCCRC0_BPP_18BPP 4
#define MCDE_PBCCRC0_BPP_24BPP 5
#define MCDE_PBCCRC0_BPP(__x) \
	MCDE_VAL2REG(MCDE_PBCCRC0, BPP, __x)
#define MCDE_PBCCRC1 0x00000C08
#define MCDE_PBCCRC1_BSCM_SHIFT 0
#define MCDE_PBCCRC1_BSCM_MASK 0x00000007
#define MCDE_PBCCRC1_BSCM_1_8BIT 0
#define MCDE_PBCCRC1_BSCM_2_8BIT 1
#define MCDE_PBCCRC1_BSCM_3_8BIT 2
#define MCDE_PBCCRC1_BSCM_1_16BIT 3
#define MCDE_PBCCRC1_BSCM_2_16BIT 4
#define MCDE_PBCCRC1_BSCM_ENUM(__x) \
	MCDE_VAL2REG(MCDE_PBCCRC1, BSCM, MCDE_PBCCRC1_BSCM_##__x)
#define MCDE_PBCCRC1_BSCM(__x) \
	MCDE_VAL2REG(MCDE_PBCCRC1, BSCM, __x)
#define MCDE_PBCCRC1_BSDM_SHIFT 3
#define MCDE_PBCCRC1_BSDM_MASK 0x00000038
#define MCDE_PBCCRC1_BSDM_1_8BIT 0
#define MCDE_PBCCRC1_BSDM_2_8BIT 1
#define MCDE_PBCCRC1_BSDM_3_8BIT 2
#define MCDE_PBCCRC1_BSDM_1_16BIT 3
#define MCDE_PBCCRC1_BSDM_2_16BIT 4
#define MCDE_PBCCRC1_BSDM_ENUM(__x) \
	MCDE_VAL2REG(MCDE_PBCCRC1, BSDM, MCDE_PBCCRC1_BSDM_##__x)
#define MCDE_PBCCRC1_BSDM(__x) \
	MCDE_VAL2REG(MCDE_PBCCRC1, BSDM, __x)
#define MCDE_PBCCRC1_PDM_SHIFT 6
#define MCDE_PBCCRC1_PDM_MASK 0x000000C0
#define MCDE_PBCCRC1_PDM_NORMAL 0
#define MCDE_PBCCRC1_PDM_16_TO_32 1
#define MCDE_PBCCRC1_PDM_24_TO_32_RIGHT 2
#define MCDE_PBCCRC1_PDM_24_TO_32_LEFT 3
#define MCDE_PBCCRC1_PDM_ENUM(__x) \
	MCDE_VAL2REG(MCDE_PBCCRC1, PDM, MCDE_PBCCRC1_PDM_##__x)
#define MCDE_PBCCRC1_PDM(__x) \
	MCDE_VAL2REG(MCDE_PBCCRC1, PDM, __x)
#define MCDE_PBCCRC1_PDCTRL_SHIFT 12
#define MCDE_PBCCRC1_PDCTRL_MASK 0x00001000
#define MCDE_PBCCRC1_PDCTRL(__x) \
	MCDE_VAL2REG(MCDE_PBCCRC1, PDCTRL, __x)
#define MCDE_PBCCRC1_BPP_SHIFT 13
#define MCDE_PBCCRC1_BPP_MASK 0x0000E000
#define MCDE_PBCCRC1_BPP_8BPP 0
#define MCDE_PBCCRC1_BPP_12BPP 1
#define MCDE_PBCCRC1_BPP_15BPP 2
#define MCDE_PBCCRC1_BPP_16BPP 3
#define MCDE_PBCCRC1_BPP_18BPP 4
#define MCDE_PBCCRC1_BPP_24BPP 5
#define MCDE_PBCCRC1_BPP(__x) \
	MCDE_VAL2REG(MCDE_PBCCRC1, BPP, __x)
#define MCDE_PBCBMRC00 0x00000C0C
#define MCDE_PBCBMRC00_GROUPOFFSET 0x4
#define MCDE_PBCBMRC00_MUXI_SHIFT 0
#define MCDE_PBCBMRC00_MUXI_MASK 0xFFFFFFFF
#define MCDE_PBCBMRC00_MUXI(__x) \
	MCDE_VAL2REG(MCDE_PBCBMRC00, MUXI, __x)
#define MCDE_PBCBMRC01 0x00000C10
#define MCDE_PBCBMRC01_MUXI_SHIFT 0
#define MCDE_PBCBMRC01_MUXI_MASK 0xFFFFFFFF
#define MCDE_PBCBMRC01_MUXI(__x) \
	MCDE_VAL2REG(MCDE_PBCBMRC01, MUXI, __x)
#define MCDE_PBCBMRC02 0x00000C14
#define MCDE_PBCBMRC02_MUXI_SHIFT 0
#define MCDE_PBCBMRC02_MUXI_MASK 0xFFFFFFFF
#define MCDE_PBCBMRC02_MUXI(__x) \
	MCDE_VAL2REG(MCDE_PBCBMRC02, MUXI, __x)
#define MCDE_PBCBMRC03 0x00000C18
#define MCDE_PBCBMRC03_MUXI_SHIFT 0
#define MCDE_PBCBMRC03_MUXI_MASK 0xFFFFFFFF
#define MCDE_PBCBMRC03_MUXI(__x) \
	MCDE_VAL2REG(MCDE_PBCBMRC03, MUXI, __x)
#define MCDE_PBCBMRC04 0x00000C1C
#define MCDE_PBCBMRC04_MUXI_SHIFT 0
#define MCDE_PBCBMRC04_MUXI_MASK 0xFFFFFFFF
#define MCDE_PBCBMRC04_MUXI(__x) \
	MCDE_VAL2REG(MCDE_PBCBMRC04, MUXI, __x)
#define MCDE_PBCBMRC10 0x00000C20
#define MCDE_PBCBMRC10_MUXI_SHIFT 0
#define MCDE_PBCBMRC10_MUXI_MASK 0xFFFFFFFF
#define MCDE_PBCBMRC10_MUXI(__x) \
	MCDE_VAL2REG(MCDE_PBCBMRC10, MUXI, __x)
#define MCDE_PBCBMRC11 0x00000C24
#define MCDE_PBCBMRC11_MUXI_SHIFT 0
#define MCDE_PBCBMRC11_MUXI_MASK 0xFFFFFFFF
#define MCDE_PBCBMRC11_MUXI(__x) \
	MCDE_VAL2REG(MCDE_PBCBMRC11, MUXI, __x)
#define MCDE_PBCBMRC12 0x00000C28
#define MCDE_PBCBMRC12_MUXI_SHIFT 0
#define MCDE_PBCBMRC12_MUXI_MASK 0xFFFFFFFF
#define MCDE_PBCBMRC12_MUXI(__x) \
	MCDE_VAL2REG(MCDE_PBCBMRC12, MUXI, __x)
#define MCDE_PBCBMRC13 0x00000C2C
#define MCDE_PBCBMRC13_MUXI_SHIFT 0
#define MCDE_PBCBMRC13_MUXI_MASK 0xFFFFFFFF
#define MCDE_PBCBMRC13_MUXI(__x) \
	MCDE_VAL2REG(MCDE_PBCBMRC13, MUXI, __x)
#define MCDE_PBCBMRC14 0x00000C30
#define MCDE_PBCBMRC14_MUXI_SHIFT 0
#define MCDE_PBCBMRC14_MUXI_MASK 0xFFFFFFFF
#define MCDE_PBCBMRC14_MUXI(__x) \
	MCDE_VAL2REG(MCDE_PBCBMRC14, MUXI, __x)
#define MCDE_PBCBCRC00 0x00000C34
#define MCDE_PBCBCRC00_GROUPOFFSET 0x4
#define MCDE_PBCBCRC00_CTLI_SHIFT 0
#define MCDE_PBCBCRC00_CTLI_MASK 0xFFFFFFFF
#define MCDE_PBCBCRC00_CTLI(__x) \
	MCDE_VAL2REG(MCDE_PBCBCRC00, CTLI, __x)
#define MCDE_PBCBCRC10 0x00000C38
#define MCDE_PBCBCRC10_CTLI_SHIFT 0
#define MCDE_PBCBCRC10_CTLI_MASK 0xFFFFFFFF
#define MCDE_PBCBCRC10_CTLI(__x) \
	MCDE_VAL2REG(MCDE_PBCBCRC10, CTLI, __x)
#define MCDE_PBCBCRC01 0x00000C48
#define MCDE_PBCBCRC01_GROUPOFFSET 0x4
#define MCDE_PBCBCRC01_CTLI_SHIFT 0
#define MCDE_PBCBCRC01_CTLI_MASK 0xFFFFFFFF
#define MCDE_PBCBCRC01_CTLI(__x) \
	MCDE_VAL2REG(MCDE_PBCBCRC01, CTLI, __x)
#define MCDE_PBCBCRC11 0x00000C4C
#define MCDE_PBCBCRC11_CTLI_SHIFT 0
#define MCDE_PBCBCRC11_CTLI_MASK 0xFFFFFFFF
#define MCDE_PBCBCRC11_CTLI(__x) \
	MCDE_VAL2REG(MCDE_PBCBCRC11, CTLI, __x)
#define MCDE_VSCRC0 0x00000C5C
#define MCDE_VSCRC0_GROUPOFFSET 0x4
#define MCDE_VSCRC0_VSPMIN_SHIFT 0
#define MCDE_VSCRC0_VSPMIN_MASK 0x00000FFF
#define MCDE_VSCRC0_VSPMIN(__x) \
	MCDE_VAL2REG(MCDE_VSCRC0, VSPMIN, __x)
#define MCDE_VSCRC0_VSPMAX_SHIFT 12
#define MCDE_VSCRC0_VSPMAX_MASK 0x00FFF000
#define MCDE_VSCRC0_VSPMAX(__x) \
	MCDE_VAL2REG(MCDE_VSCRC0, VSPMAX, __x)
#define MCDE_VSCRC0_VSPDIV_SHIFT 24
#define MCDE_VSCRC0_VSPDIV_MASK 0x07000000
#define MCDE_VSCRC0_VSPDIV(__x) \
	MCDE_VAL2REG(MCDE_VSCRC0, VSPDIV, __x)
#define MCDE_VSCRC0_VSPOL_SHIFT 27
#define MCDE_VSCRC0_VSPOL_MASK 0x08000000
#define MCDE_VSCRC0_VSPOL_ACTIVE_HIGH 0
#define MCDE_VSCRC0_VSPOL_ACTIVE_LOW 1
#define MCDE_VSCRC0_VSPOL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_VSCRC0, VSPOL, MCDE_VSCRC0_VSPOL_##__x)
#define MCDE_VSCRC0_VSPOL(__x) \
	MCDE_VAL2REG(MCDE_VSCRC0, VSPOL, __x)
#define MCDE_VSCRC0_VSSEL_SHIFT 28
#define MCDE_VSCRC0_VSSEL_MASK 0x10000000
#define MCDE_VSCRC0_VSSEL_VSYNC 0
#define MCDE_VSCRC0_VSSEL_HSYNC 1
#define MCDE_VSCRC0_VSSEL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_VSCRC0, VSSEL, MCDE_VSCRC0_VSSEL_##__x)
#define MCDE_VSCRC0_VSSEL(__x) \
	MCDE_VAL2REG(MCDE_VSCRC0, VSSEL, __x)
#define MCDE_VSCRC0_VSDBL_SHIFT 29
#define MCDE_VSCRC0_VSDBL_MASK 0xE0000000
#define MCDE_VSCRC0_VSDBL(__x) \
	MCDE_VAL2REG(MCDE_VSCRC0, VSDBL, __x)
#define MCDE_VSCRC1 0x00000C60
#define MCDE_VSCRC1_VSPMIN_SHIFT 0
#define MCDE_VSCRC1_VSPMIN_MASK 0x00000FFF
#define MCDE_VSCRC1_VSPMIN(__x) \
	MCDE_VAL2REG(MCDE_VSCRC1, VSPMIN, __x)
#define MCDE_VSCRC1_VSPMAX_SHIFT 12
#define MCDE_VSCRC1_VSPMAX_MASK 0x00FFF000
#define MCDE_VSCRC1_VSPMAX(__x) \
	MCDE_VAL2REG(MCDE_VSCRC1, VSPMAX, __x)
#define MCDE_VSCRC1_VSPDIV_SHIFT 24
#define MCDE_VSCRC1_VSPDIV_MASK 0x07000000
#define MCDE_VSCRC1_VSPDIV(__x) \
	MCDE_VAL2REG(MCDE_VSCRC1, VSPDIV, __x)
#define MCDE_VSCRC1_VSPOL_SHIFT 27
#define MCDE_VSCRC1_VSPOL_MASK 0x08000000
#define MCDE_VSCRC1_VSPOL_ACTIVE_HIGH 0
#define MCDE_VSCRC1_VSPOL_ACTIVE_LOW 1
#define MCDE_VSCRC1_VSPOL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_VSCRC1, VSPOL, MCDE_VSCRC1_VSPOL_##__x)
#define MCDE_VSCRC1_VSPOL(__x) \
	MCDE_VAL2REG(MCDE_VSCRC1, VSPOL, __x)
#define MCDE_VSCRC1_VSSEL_SHIFT 28
#define MCDE_VSCRC1_VSSEL_MASK 0x10000000
#define MCDE_VSCRC1_VSSEL_VSYNC 0
#define MCDE_VSCRC1_VSSEL_HSYNC 1
#define MCDE_VSCRC1_VSSEL_ENUM(__x) \
	MCDE_VAL2REG(MCDE_VSCRC1, VSSEL, MCDE_VSCRC1_VSSEL_##__x)
#define MCDE_VSCRC1_VSSEL(__x) \
	MCDE_VAL2REG(MCDE_VSCRC1, VSSEL, __x)
#define MCDE_VSCRC1_VSDBL_SHIFT 29
#define MCDE_VSCRC1_VSDBL_MASK 0xE0000000
#define MCDE_VSCRC1_VSDBL(__x) \
	MCDE_VAL2REG(MCDE_VSCRC1, VSDBL, __x)
#define MCDE_SCTRC 0x00000C64
#define MCDE_SCTRC_SYNCDELC0_SHIFT 0
#define MCDE_SCTRC_SYNCDELC0_MASK 0x000000FF
#define MCDE_SCTRC_SYNCDELC0(__x) \
	MCDE_VAL2REG(MCDE_SCTRC, SYNCDELC0, __x)
#define MCDE_SCTRC_SYNCDELC1_SHIFT 8
#define MCDE_SCTRC_SYNCDELC1_MASK 0x0000FF00
#define MCDE_SCTRC_SYNCDELC1(__x) \
	MCDE_VAL2REG(MCDE_SCTRC, SYNCDELC1, __x)
#define MCDE_SCTRC_TRDELC_SHIFT 16
#define MCDE_SCTRC_TRDELC_MASK 0x0FFF0000
#define MCDE_SCTRC_TRDELC(__x) \
	MCDE_VAL2REG(MCDE_SCTRC, TRDELC, __x)
#define MCDE_SCSRC 0x00000C68
#define MCDE_SCSRC_VSTAC0_SHIFT 0
#define MCDE_SCSRC_VSTAC0_MASK 0x00000001
#define MCDE_SCSRC_VSTAC0(__x) \
	MCDE_VAL2REG(MCDE_SCSRC, VSTAC0, __x)
#define MCDE_SCSRC_VSTAC1_SHIFT 1
#define MCDE_SCSRC_VSTAC1_MASK 0x00000002
#define MCDE_SCSRC_VSTAC1(__x) \
	MCDE_VAL2REG(MCDE_SCSRC, VSTAC1, __x)
#define MCDE_BCNR0 0x00000C6C
#define MCDE_BCNR0_GROUPOFFSET 0x4
#define MCDE_BCNR0_BCN_SHIFT 0
#define MCDE_BCNR0_BCN_MASK 0x000000FF
#define MCDE_BCNR0_BCN(__x) \
	MCDE_VAL2REG(MCDE_BCNR0, BCN, __x)
#define MCDE_BCNR1 0x00000C70
#define MCDE_BCNR1_BCN_SHIFT 0
#define MCDE_BCNR1_BCN_MASK 0x000000FF
#define MCDE_BCNR1_BCN(__x) \
	MCDE_VAL2REG(MCDE_BCNR1, BCN, __x)
#define MCDE_CSCDTR0 0x00000C74
#define MCDE_CSCDTR0_GROUPOFFSET 0x4
#define MCDE_CSCDTR0_CSACT_SHIFT 0
#define MCDE_CSCDTR0_CSACT_MASK 0x000000FF
#define MCDE_CSCDTR0_CSACT(__x) \
	MCDE_VAL2REG(MCDE_CSCDTR0, CSACT, __x)
#define MCDE_CSCDTR0_CSDEACT_SHIFT 8
#define MCDE_CSCDTR0_CSDEACT_MASK 0x0000FF00
#define MCDE_CSCDTR0_CSDEACT(__x) \
	MCDE_VAL2REG(MCDE_CSCDTR0, CSDEACT, __x)
#define MCDE_CSCDTR0_CDACT_SHIFT 16
#define MCDE_CSCDTR0_CDACT_MASK 0x00FF0000
#define MCDE_CSCDTR0_CDACT(__x) \
	MCDE_VAL2REG(MCDE_CSCDTR0, CDACT, __x)
#define MCDE_CSCDTR0_CDDEACT_SHIFT 24
#define MCDE_CSCDTR0_CDDEACT_MASK 0xFF000000
#define MCDE_CSCDTR0_CDDEACT(__x) \
	MCDE_VAL2REG(MCDE_CSCDTR0, CDDEACT, __x)
#define MCDE_CSCDTR1 0x00000C78
#define MCDE_CSCDTR1_CSACT_SHIFT 0
#define MCDE_CSCDTR1_CSACT_MASK 0x000000FF
#define MCDE_CSCDTR1_CSACT(__x) \
	MCDE_VAL2REG(MCDE_CSCDTR1, CSACT, __x)
#define MCDE_CSCDTR1_CSDEACT_SHIFT 8
#define MCDE_CSCDTR1_CSDEACT_MASK 0x0000FF00
#define MCDE_CSCDTR1_CSDEACT(__x) \
	MCDE_VAL2REG(MCDE_CSCDTR1, CSDEACT, __x)
#define MCDE_CSCDTR1_CDACT_SHIFT 16
#define MCDE_CSCDTR1_CDACT_MASK 0x00FF0000
#define MCDE_CSCDTR1_CDACT(__x) \
	MCDE_VAL2REG(MCDE_CSCDTR1, CDACT, __x)
#define MCDE_CSCDTR1_CDDEACT_SHIFT 24
#define MCDE_CSCDTR1_CDDEACT_MASK 0xFF000000
#define MCDE_CSCDTR1_CDDEACT(__x) \
	MCDE_VAL2REG(MCDE_CSCDTR1, CDDEACT, __x)
#define MCDE_RDWRTR0 0x00000C7C
#define MCDE_RDWRTR0_GROUPOFFSET 0x4
#define MCDE_RDWRTR0_RWACT_SHIFT 0
#define MCDE_RDWRTR0_RWACT_MASK 0x000000FF
#define MCDE_RDWRTR0_RWACT(__x) \
	MCDE_VAL2REG(MCDE_RDWRTR0, RWACT, __x)
#define MCDE_RDWRTR0_RWDEACT_SHIFT 8
#define MCDE_RDWRTR0_RWDEACT_MASK 0x0000FF00
#define MCDE_RDWRTR0_RWDEACT(__x) \
	MCDE_VAL2REG(MCDE_RDWRTR0, RWDEACT, __x)
#define MCDE_RDWRTR0_MOTINT_SHIFT 16
#define MCDE_RDWRTR0_MOTINT_MASK 0x00010000
#define MCDE_RDWRTR0_MOTINT(__x) \
	MCDE_VAL2REG(MCDE_RDWRTR0, MOTINT, __x)
#define MCDE_RDWRTR1 0x00000C80
#define MCDE_RDWRTR1_RWACT_SHIFT 0
#define MCDE_RDWRTR1_RWACT_MASK 0x000000FF
#define MCDE_RDWRTR1_RWACT(__x) \
	MCDE_VAL2REG(MCDE_RDWRTR1, RWACT, __x)
#define MCDE_RDWRTR1_RWDEACT_SHIFT 8
#define MCDE_RDWRTR1_RWDEACT_MASK 0x0000FF00
#define MCDE_RDWRTR1_RWDEACT(__x) \
	MCDE_VAL2REG(MCDE_RDWRTR1, RWDEACT, __x)
#define MCDE_RDWRTR1_MOTINT_SHIFT 16
#define MCDE_RDWRTR1_MOTINT_MASK 0x00010000
#define MCDE_RDWRTR1_MOTINT(__x) \
	MCDE_VAL2REG(MCDE_RDWRTR1, MOTINT, __x)
#define MCDE_DOTR0 0x00000C84
#define MCDE_DOTR0_GROUPOFFSET 0x4
#define MCDE_DOTR0_DOACT_SHIFT 0
#define MCDE_DOTR0_DOACT_MASK 0x000000FF
#define MCDE_DOTR0_DOACT(__x) \
	MCDE_VAL2REG(MCDE_DOTR0, DOACT, __x)
#define MCDE_DOTR0_DODEACT_SHIFT 8
#define MCDE_DOTR0_DODEACT_MASK 0x0000FF00
#define MCDE_DOTR0_DODEACT(__x) \
	MCDE_VAL2REG(MCDE_DOTR0, DODEACT, __x)
#define MCDE_DOTR1 0x00000C88
#define MCDE_DOTR1_DOACT_SHIFT 0
#define MCDE_DOTR1_DOACT_MASK 0x000000FF
#define MCDE_DOTR1_DOACT(__x) \
	MCDE_VAL2REG(MCDE_DOTR1, DOACT, __x)
#define MCDE_DOTR1_DODEACT_SHIFT 8
#define MCDE_DOTR1_DODEACT_MASK 0x0000FF00
#define MCDE_DOTR1_DODEACT(__x) \
	MCDE_VAL2REG(MCDE_DOTR1, DODEACT, __x)
#define MCDE_WCMDC0_V1 0x00000C8C
#define MCDE_WCMDC0_V1_GROUPOFFSET 0x4
#define MCDE_WCMDC0_V1_COMMANDVALUE_SHIFT 0
#define MCDE_WCMDC0_V1_COMMANDVALUE_MASK 0x00FFFFFF
#define MCDE_WCMDC0_V1_COMMANDVALUE(__x) \
	MCDE_VAL2REG(MCDE_WCMDC0_V1, COMMANDVALUE, __x)
#define MCDE_WCMDC1_V1 0x00000C90
#define MCDE_WCMDC1_V1_COMMANDVALUE_SHIFT 0
#define MCDE_WCMDC1_V1_COMMANDVALUE_MASK 0x00FFFFFF
#define MCDE_WCMDC1_V1_COMMANDVALUE(__x) \
	MCDE_VAL2REG(MCDE_WCMDC1_V1, COMMANDVALUE, __x)
#define MCDE_WDATADC0 0x00000C94
#define MCDE_WDATADC0_GROUPOFFSET 0x4
#define MCDE_WDATADC0_DATAVALUE_SHIFT 0
#define MCDE_WDATADC0_DATAVALUE_MASK 0x00FFFFFF
#define MCDE_WDATADC0_DATAVALUE(__x) \
	MCDE_VAL2REG(MCDE_WDATADC0, DATAVALUE, __x)
#define MCDE_WDATADC1 0x00000C98
#define MCDE_WDATADC1_DATAVALUE_SHIFT 0
#define MCDE_WDATADC1_DATAVALUE_MASK 0x00FFFFFF
#define MCDE_WDATADC1_DATAVALUE(__x) \
	MCDE_VAL2REG(MCDE_WDATADC1, DATAVALUE, __x)
#define MCDE_RDATADC0 0x00000C9C
#define MCDE_RDATADC0_GROUPOFFSET 0x4
#define MCDE_RDATADC0_DATAREADFROMDISPLAYMODULE_SHIFT 0
#define MCDE_RDATADC0_DATAREADFROMDISPLAYMODULE_MASK 0x0000FFFF
#define MCDE_RDATADC0_DATAREADFROMDISPLAYMODULE(__x) \
	MCDE_VAL2REG(MCDE_RDATADC0, DATAREADFROMDISPLAYMODULE, __x)
#define MCDE_RDATADC0_STARTREAD_SHIFT 16
#define MCDE_RDATADC0_STARTREAD_MASK 0x00010000
#define MCDE_RDATADC0_STARTREAD(__x) \
	MCDE_VAL2REG(MCDE_RDATADC0, STARTREAD, __x)
#define MCDE_RDATADC1 0x00000CA0
#define MCDE_RDATADC1_DATAREADFROMDISPLAYMODULE_SHIFT 0
#define MCDE_RDATADC1_DATAREADFROMDISPLAYMODULE_MASK 0x0000FFFF
#define MCDE_RDATADC1_DATAREADFROMDISPLAYMODULE(__x) \
	MCDE_VAL2REG(MCDE_RDATADC1, DATAREADFROMDISPLAYMODULE, __x)
#define MCDE_RDATADC1_STARTREAD_SHIFT 16
#define MCDE_RDATADC1_STARTREAD_MASK 0x00010000
#define MCDE_RDATADC1_STARTREAD(__x) \
	MCDE_VAL2REG(MCDE_RDATADC1, STARTREAD, __x)
#define MCDE_STATC_V1 0x00000CA4
#define MCDE_STATC_V1_STATBUSY0_SHIFT 0
#define MCDE_STATC_V1_STATBUSY0_MASK 0x00000001
#define MCDE_STATC_V1_STATBUSY0(__x) \
	MCDE_VAL2REG(MCDE_STATC_V1, STATBUSY0, __x)
#define MCDE_STATC_V1_FIFOEMPTY0_SHIFT 1
#define MCDE_STATC_V1_FIFOEMPTY0_MASK 0x00000002
#define MCDE_STATC_V1_FIFOEMPTY0(__x) \
	MCDE_VAL2REG(MCDE_STATC_V1, FIFOEMPTY0, __x)
#define MCDE_STATC_V1_FIFOFULL0_SHIFT 2
#define MCDE_STATC_V1_FIFOFULL0_MASK 0x00000004
#define MCDE_STATC_V1_FIFOFULL0(__x) \
	MCDE_VAL2REG(MCDE_STATC_V1, FIFOFULL0, __x)
#define MCDE_STATC_V1_FIFOCMDEMPTY0_SHIFT 3
#define MCDE_STATC_V1_FIFOCMDEMPTY0_MASK 0x00000008
#define MCDE_STATC_V1_FIFOCMDEMPTY0(__x) \
	MCDE_VAL2REG(MCDE_STATC_V1, FIFOCMDEMPTY0, __x)
#define MCDE_STATC_V1_FIFOCMDFULL0_SHIFT 4
#define MCDE_STATC_V1_FIFOCMDFULL0_MASK 0x00000010
#define MCDE_STATC_V1_FIFOCMDFULL0(__x) \
	MCDE_VAL2REG(MCDE_STATC_V1, FIFOCMDFULL0, __x)
#define MCDE_STATC_V1_STATBUSY1_SHIFT 5
#define MCDE_STATC_V1_STATBUSY1_MASK 0x00000020
#define MCDE_STATC_V1_STATBUSY1(__x) \
	MCDE_VAL2REG(MCDE_STATC_V1, STATBUSY1, __x)
#define MCDE_STATC_V1_FIFOEMPTY1_SHIFT 6
#define MCDE_STATC_V1_FIFOEMPTY1_MASK 0x00000040
#define MCDE_STATC_V1_FIFOEMPTY1(__x) \
	MCDE_VAL2REG(MCDE_STATC_V1, FIFOEMPTY1, __x)
#define MCDE_STATC_V1_FIFOFULL1_SHIFT 7
#define MCDE_STATC_V1_FIFOFULL1_MASK 0x00000080
#define MCDE_STATC_V1_FIFOFULL1(__x) \
	MCDE_VAL2REG(MCDE_STATC_V1, FIFOFULL1, __x)
#define MCDE_STATC_V1_FIFOCMDEMPTY1_SHIFT 8
#define MCDE_STATC_V1_FIFOCMDEMPTY1_MASK 0x00000100
#define MCDE_STATC_V1_FIFOCMDEMPTY1(__x) \
	MCDE_VAL2REG(MCDE_STATC_V1, FIFOCMDEMPTY1, __x)
#define MCDE_STATC_V1_FIFOCMDFULL1_SHIFT 9
#define MCDE_STATC_V1_FIFOCMDFULL1_MASK 0x00000200
#define MCDE_STATC_V1_FIFOCMDFULL1(__x) \
	MCDE_VAL2REG(MCDE_STATC_V1, FIFOCMDFULL1, __x)
#define MCDE_CTRLC0 0x00000CA8
#define MCDE_CTRLC0_GROUPOFFSET 0x4
#define MCDE_CTRLC0_FIFOWTRMRK_SHIFT 0
#define MCDE_CTRLC0_FIFOWTRMRK_MASK 0x000000FF
#define MCDE_CTRLC0_FIFOWTRMRK(__x) \
	MCDE_VAL2REG(MCDE_CTRLC0, FIFOWTRMRK, __x)
#define MCDE_CTRLC0_FIFOEMPTY_SHIFT 12
#define MCDE_CTRLC0_FIFOEMPTY_MASK 0x00001000
#define MCDE_CTRLC0_FIFOEMPTY(__x) \
	MCDE_VAL2REG(MCDE_CTRLC0, FIFOEMPTY, __x)
#define MCDE_CTRLC0_FIFOFULL_SHIFT 13
#define MCDE_CTRLC0_FIFOFULL_MASK 0x00002000
#define MCDE_CTRLC0_FIFOFULL(__x) \
	MCDE_VAL2REG(MCDE_CTRLC0, FIFOFULL, __x)
#define MCDE_CTRLC0_FORMID_SHIFT 16
#define MCDE_CTRLC0_FORMID_MASK 0x00070000
#define MCDE_CTRLC0_FORMID_DSI0VID 0
#define MCDE_CTRLC0_FORMID_DSI0CMD 1
#define MCDE_CTRLC0_FORMID_DSI1VID 2
#define MCDE_CTRLC0_FORMID_DSI1CMD 3
#define MCDE_CTRLC0_FORMID_DSI2VID 4
#define MCDE_CTRLC0_FORMID_DSI2CMD 5
#define MCDE_CTRLC0_FORMID_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CTRLC0, FORMID, MCDE_CTRLC0_FORMID_##__x)
#define MCDE_CTRLC0_FORMID(__x) \
	MCDE_VAL2REG(MCDE_CTRLC0, FORMID, __x)
#define MCDE_CTRLC0_FORMTYPE_SHIFT 20
#define MCDE_CTRLC0_FORMTYPE_MASK 0x00700000
#define MCDE_CTRLC0_FORMTYPE_DPITV 0
#define MCDE_CTRLC0_FORMTYPE_DBI 1
#define MCDE_CTRLC0_FORMTYPE_DSI 2
#define MCDE_CTRLC0_FORMTYPE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CTRLC0, FORMTYPE, MCDE_CTRLC0_FORMTYPE_##__x)
#define MCDE_CTRLC0_FORMTYPE(__x) \
	MCDE_VAL2REG(MCDE_CTRLC0, FORMTYPE, __x)
#define MCDE_CTRLC1 0x00000CAC
#define MCDE_CTRLC1_FIFOWTRMRK_SHIFT 0
#define MCDE_CTRLC1_FIFOWTRMRK_MASK 0x000000FF
#define MCDE_CTRLC1_FIFOWTRMRK(__x) \
	MCDE_VAL2REG(MCDE_CTRLC1, FIFOWTRMRK, __x)
#define MCDE_CTRLC1_FIFOEMPTY_SHIFT 12
#define MCDE_CTRLC1_FIFOEMPTY_MASK 0x00001000
#define MCDE_CTRLC1_FIFOEMPTY(__x) \
	MCDE_VAL2REG(MCDE_CTRLC1, FIFOEMPTY, __x)
#define MCDE_CTRLC1_FIFOFULL_SHIFT 13
#define MCDE_CTRLC1_FIFOFULL_MASK 0x00002000
#define MCDE_CTRLC1_FIFOFULL(__x) \
	MCDE_VAL2REG(MCDE_CTRLC1, FIFOFULL, __x)
#define MCDE_CTRLC1_FORMID_SHIFT 16
#define MCDE_CTRLC1_FORMID_MASK 0x00070000
#define MCDE_CTRLC1_FORMID_DSI0VID 0
#define MCDE_CTRLC1_FORMID_DSI0CMD 1
#define MCDE_CTRLC1_FORMID_DSI1VID 2
#define MCDE_CTRLC1_FORMID_DSI1CMD 3
#define MCDE_CTRLC1_FORMID_DSI2VID 4
#define MCDE_CTRLC1_FORMID_DSI2CMD 5
#define MCDE_CTRLC1_FORMID_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CTRLC1, FORMID, MCDE_CTRLC1_FORMID_##__x)
#define MCDE_CTRLC1_FORMID(__x) \
	MCDE_VAL2REG(MCDE_CTRLC1, FORMID, __x)
#define MCDE_CTRLC1_FORMTYPE_SHIFT 20
#define MCDE_CTRLC1_FORMTYPE_MASK 0x00700000
#define MCDE_CTRLC1_FORMTYPE_DPITV 0
#define MCDE_CTRLC1_FORMTYPE_DBI 1
#define MCDE_CTRLC1_FORMTYPE_DSI 2
#define MCDE_CTRLC1_FORMTYPE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_CTRLC1, FORMTYPE, MCDE_CTRLC1_FORMTYPE_##__x)
#define MCDE_CTRLC1_FORMTYPE(__x) \
	MCDE_VAL2REG(MCDE_CTRLC1, FORMTYPE, __x)
#define MCDE_DSIVID0CONF0 0x00000E00
#define MCDE_DSIVID0CONF0_GROUPOFFSET 0x20
#define MCDE_DSIVID0CONF0_BLANKING_SHIFT 0
#define MCDE_DSIVID0CONF0_BLANKING_MASK 0x000000FF
#define MCDE_DSIVID0CONF0_BLANKING(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0CONF0, BLANKING, __x)
#define MCDE_DSIVID0CONF0_VID_MODE_SHIFT 12
#define MCDE_DSIVID0CONF0_VID_MODE_MASK 0x00001000
#define MCDE_DSIVID0CONF0_VID_MODE_CMD 0
#define MCDE_DSIVID0CONF0_VID_MODE_VID 1
#define MCDE_DSIVID0CONF0_VID_MODE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0CONF0, VID_MODE, \
	MCDE_DSIVID0CONF0_VID_MODE_##__x)
#define MCDE_DSIVID0CONF0_VID_MODE(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0CONF0, VID_MODE, __x)
#define MCDE_DSIVID0CONF0_CMD8_SHIFT 13
#define MCDE_DSIVID0CONF0_CMD8_MASK 0x00002000
#define MCDE_DSIVID0CONF0_CMD8(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0CONF0, CMD8, __x)
#define MCDE_DSIVID0CONF0_BIT_SWAP_SHIFT 16
#define MCDE_DSIVID0CONF0_BIT_SWAP_MASK 0x00010000
#define MCDE_DSIVID0CONF0_BIT_SWAP(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0CONF0, BIT_SWAP, __x)
#define MCDE_DSIVID0CONF0_BYTE_SWAP_SHIFT 17
#define MCDE_DSIVID0CONF0_BYTE_SWAP_MASK 0x00020000
#define MCDE_DSIVID0CONF0_BYTE_SWAP(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0CONF0, BYTE_SWAP, __x)
#define MCDE_DSIVID0CONF0_DCSVID_NOTGEN_SHIFT 18
#define MCDE_DSIVID0CONF0_DCSVID_NOTGEN_MASK 0x00040000
#define MCDE_DSIVID0CONF0_DCSVID_NOTGEN(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0CONF0, DCSVID_NOTGEN, __x)
#define MCDE_DSIVID0CONF0_PACKING_SHIFT 20
#define MCDE_DSIVID0CONF0_PACKING_MASK 0x00700000
#define MCDE_DSIVID0CONF0_PACKING_RGB565 0
#define MCDE_DSIVID0CONF0_PACKING_RGB666 1
#define MCDE_DSIVID0CONF0_PACKING_RGB888 2
#define MCDE_DSIVID0CONF0_PACKING_BGR888 3
#define MCDE_DSIVID0CONF0_PACKING_HDTV 4
#define MCDE_DSIVID0CONF0_PACKING_ENUM(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0CONF0, PACKING, \
	MCDE_DSIVID0CONF0_PACKING_##__x)
#define MCDE_DSIVID0CONF0_PACKING(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0CONF0, PACKING, __x)
#define MCDE_DSICMD0CONF0 0x00000E20
#define MCDE_DSICMD0CONF0_BLANKING_SHIFT 0
#define MCDE_DSICMD0CONF0_BLANKING_MASK 0x000000FF
#define MCDE_DSICMD0CONF0_BLANKING(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0CONF0, BLANKING, __x)
#define MCDE_DSICMD0CONF0_VID_MODE_SHIFT 12
#define MCDE_DSICMD0CONF0_VID_MODE_MASK 0x00001000
#define MCDE_DSICMD0CONF0_VID_MODE_CMD 0
#define MCDE_DSICMD0CONF0_VID_MODE_VID 1
#define MCDE_DSICMD0CONF0_VID_MODE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0CONF0, VID_MODE, \
	MCDE_DSICMD0CONF0_VID_MODE_##__x)
#define MCDE_DSICMD0CONF0_VID_MODE(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0CONF0, VID_MODE, __x)
#define MCDE_DSICMD0CONF0_CMD8_SHIFT 13
#define MCDE_DSICMD0CONF0_CMD8_MASK 0x00002000
#define MCDE_DSICMD0CONF0_CMD8(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0CONF0, CMD8, __x)
#define MCDE_DSICMD0CONF0_BIT_SWAP_SHIFT 16
#define MCDE_DSICMD0CONF0_BIT_SWAP_MASK 0x00010000
#define MCDE_DSICMD0CONF0_BIT_SWAP(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0CONF0, BIT_SWAP, __x)
#define MCDE_DSICMD0CONF0_BYTE_SWAP_SHIFT 17
#define MCDE_DSICMD0CONF0_BYTE_SWAP_MASK 0x00020000
#define MCDE_DSICMD0CONF0_BYTE_SWAP(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0CONF0, BYTE_SWAP, __x)
#define MCDE_DSICMD0CONF0_DCSVID_NOTGEN_SHIFT 18
#define MCDE_DSICMD0CONF0_DCSVID_NOTGEN_MASK 0x00040000
#define MCDE_DSICMD0CONF0_DCSVID_NOTGEN(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0CONF0, DCSVID_NOTGEN, __x)
#define MCDE_DSICMD0CONF0_PACKING_SHIFT 20
#define MCDE_DSICMD0CONF0_PACKING_MASK 0x00700000
#define MCDE_DSICMD0CONF0_PACKING_RGB565 0
#define MCDE_DSICMD0CONF0_PACKING_RGB666 1
#define MCDE_DSICMD0CONF0_PACKING_RGB888 2
#define MCDE_DSICMD0CONF0_PACKING_BGR888 3
#define MCDE_DSICMD0CONF0_PACKING_HDTV 4
#define MCDE_DSICMD0CONF0_PACKING_ENUM(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0CONF0, PACKING, \
	MCDE_DSICMD0CONF0_PACKING_##__x)
#define MCDE_DSICMD0CONF0_PACKING(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0CONF0, PACKING, __x)
#define MCDE_DSIVID1CONF0 0x00000E40
#define MCDE_DSIVID1CONF0_BLANKING_SHIFT 0
#define MCDE_DSIVID1CONF0_BLANKING_MASK 0x000000FF
#define MCDE_DSIVID1CONF0_BLANKING(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1CONF0, BLANKING, __x)
#define MCDE_DSIVID1CONF0_VID_MODE_SHIFT 12
#define MCDE_DSIVID1CONF0_VID_MODE_MASK 0x00001000
#define MCDE_DSIVID1CONF0_VID_MODE_CMD 0
#define MCDE_DSIVID1CONF0_VID_MODE_VID 1
#define MCDE_DSIVID1CONF0_VID_MODE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1CONF0, VID_MODE, \
	MCDE_DSIVID1CONF0_VID_MODE_##__x)
#define MCDE_DSIVID1CONF0_VID_MODE(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1CONF0, VID_MODE, __x)
#define MCDE_DSIVID1CONF0_CMD8_SHIFT 13
#define MCDE_DSIVID1CONF0_CMD8_MASK 0x00002000
#define MCDE_DSIVID1CONF0_CMD8(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1CONF0, CMD8, __x)
#define MCDE_DSIVID1CONF0_BIT_SWAP_SHIFT 16
#define MCDE_DSIVID1CONF0_BIT_SWAP_MASK 0x00010000
#define MCDE_DSIVID1CONF0_BIT_SWAP(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1CONF0, BIT_SWAP, __x)
#define MCDE_DSIVID1CONF0_BYTE_SWAP_SHIFT 17
#define MCDE_DSIVID1CONF0_BYTE_SWAP_MASK 0x00020000
#define MCDE_DSIVID1CONF0_BYTE_SWAP(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1CONF0, BYTE_SWAP, __x)
#define MCDE_DSIVID1CONF0_DCSVID_NOTGEN_SHIFT 18
#define MCDE_DSIVID1CONF0_DCSVID_NOTGEN_MASK 0x00040000
#define MCDE_DSIVID1CONF0_DCSVID_NOTGEN(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1CONF0, DCSVID_NOTGEN, __x)
#define MCDE_DSIVID1CONF0_PACKING_SHIFT 20
#define MCDE_DSIVID1CONF0_PACKING_MASK 0x00700000
#define MCDE_DSIVID1CONF0_PACKING_RGB565 0
#define MCDE_DSIVID1CONF0_PACKING_RGB666 1
#define MCDE_DSIVID1CONF0_PACKING_RGB888 2
#define MCDE_DSIVID1CONF0_PACKING_BGR888 3
#define MCDE_DSIVID1CONF0_PACKING_HDTV 4
#define MCDE_DSIVID1CONF0_PACKING_ENUM(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1CONF0, PACKING, \
	MCDE_DSIVID1CONF0_PACKING_##__x)
#define MCDE_DSIVID1CONF0_PACKING(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1CONF0, PACKING, __x)
#define MCDE_DSICMD1CONF0 0x00000E60
#define MCDE_DSICMD1CONF0_BLANKING_SHIFT 0
#define MCDE_DSICMD1CONF0_BLANKING_MASK 0x000000FF
#define MCDE_DSICMD1CONF0_BLANKING(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1CONF0, BLANKING, __x)
#define MCDE_DSICMD1CONF0_VID_MODE_SHIFT 12
#define MCDE_DSICMD1CONF0_VID_MODE_MASK 0x00001000
#define MCDE_DSICMD1CONF0_VID_MODE_CMD 0
#define MCDE_DSICMD1CONF0_VID_MODE_VID 1
#define MCDE_DSICMD1CONF0_VID_MODE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1CONF0, VID_MODE, \
	MCDE_DSICMD1CONF0_VID_MODE_##__x)
#define MCDE_DSICMD1CONF0_VID_MODE(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1CONF0, VID_MODE, __x)
#define MCDE_DSICMD1CONF0_CMD8_SHIFT 13
#define MCDE_DSICMD1CONF0_CMD8_MASK 0x00002000
#define MCDE_DSICMD1CONF0_CMD8(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1CONF0, CMD8, __x)
#define MCDE_DSICMD1CONF0_BIT_SWAP_SHIFT 16
#define MCDE_DSICMD1CONF0_BIT_SWAP_MASK 0x00010000
#define MCDE_DSICMD1CONF0_BIT_SWAP(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1CONF0, BIT_SWAP, __x)
#define MCDE_DSICMD1CONF0_BYTE_SWAP_SHIFT 17
#define MCDE_DSICMD1CONF0_BYTE_SWAP_MASK 0x00020000
#define MCDE_DSICMD1CONF0_BYTE_SWAP(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1CONF0, BYTE_SWAP, __x)
#define MCDE_DSICMD1CONF0_DCSVID_NOTGEN_SHIFT 18
#define MCDE_DSICMD1CONF0_DCSVID_NOTGEN_MASK 0x00040000
#define MCDE_DSICMD1CONF0_DCSVID_NOTGEN(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1CONF0, DCSVID_NOTGEN, __x)
#define MCDE_DSICMD1CONF0_PACKING_SHIFT 20
#define MCDE_DSICMD1CONF0_PACKING_MASK 0x00700000
#define MCDE_DSICMD1CONF0_PACKING_RGB565 0
#define MCDE_DSICMD1CONF0_PACKING_RGB666 1
#define MCDE_DSICMD1CONF0_PACKING_RGB888 2
#define MCDE_DSICMD1CONF0_PACKING_BGR888 3
#define MCDE_DSICMD1CONF0_PACKING_HDTV 4
#define MCDE_DSICMD1CONF0_PACKING_ENUM(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1CONF0, PACKING, \
	MCDE_DSICMD1CONF0_PACKING_##__x)
#define MCDE_DSICMD1CONF0_PACKING(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1CONF0, PACKING, __x)
#define MCDE_DSIVID2CONF0 0x00000E80
#define MCDE_DSIVID2CONF0_BLANKING_SHIFT 0
#define MCDE_DSIVID2CONF0_BLANKING_MASK 0x000000FF
#define MCDE_DSIVID2CONF0_BLANKING(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2CONF0, BLANKING, __x)
#define MCDE_DSIVID2CONF0_VID_MODE_SHIFT 12
#define MCDE_DSIVID2CONF0_VID_MODE_MASK 0x00001000
#define MCDE_DSIVID2CONF0_VID_MODE_CMD 0
#define MCDE_DSIVID2CONF0_VID_MODE_VID 1
#define MCDE_DSIVID2CONF0_VID_MODE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2CONF0, VID_MODE, \
	MCDE_DSIVID2CONF0_VID_MODE_##__x)
#define MCDE_DSIVID2CONF0_VID_MODE(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2CONF0, VID_MODE, __x)
#define MCDE_DSIVID2CONF0_CMD8_SHIFT 13
#define MCDE_DSIVID2CONF0_CMD8_MASK 0x00002000
#define MCDE_DSIVID2CONF0_CMD8(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2CONF0, CMD8, __x)
#define MCDE_DSIVID2CONF0_BIT_SWAP_SHIFT 16
#define MCDE_DSIVID2CONF0_BIT_SWAP_MASK 0x00010000
#define MCDE_DSIVID2CONF0_BIT_SWAP(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2CONF0, BIT_SWAP, __x)
#define MCDE_DSIVID2CONF0_BYTE_SWAP_SHIFT 17
#define MCDE_DSIVID2CONF0_BYTE_SWAP_MASK 0x00020000
#define MCDE_DSIVID2CONF0_BYTE_SWAP(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2CONF0, BYTE_SWAP, __x)
#define MCDE_DSIVID2CONF0_DCSVID_NOTGEN_SHIFT 18
#define MCDE_DSIVID2CONF0_DCSVID_NOTGEN_MASK 0x00040000
#define MCDE_DSIVID2CONF0_DCSVID_NOTGEN(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2CONF0, DCSVID_NOTGEN, __x)
#define MCDE_DSIVID2CONF0_PACKING_SHIFT 20
#define MCDE_DSIVID2CONF0_PACKING_MASK 0x00700000
#define MCDE_DSIVID2CONF0_PACKING_RGB565 0
#define MCDE_DSIVID2CONF0_PACKING_RGB666 1
#define MCDE_DSIVID2CONF0_PACKING_RGB888 2
#define MCDE_DSIVID2CONF0_PACKING_BGR888 3
#define MCDE_DSIVID2CONF0_PACKING_HDTV 4
#define MCDE_DSIVID2CONF0_PACKING_ENUM(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2CONF0, PACKING, \
	MCDE_DSIVID2CONF0_PACKING_##__x)
#define MCDE_DSIVID2CONF0_PACKING(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2CONF0, PACKING, __x)
#define MCDE_DSICMD2CONF0 0x00000EA0
#define MCDE_DSICMD2CONF0_BLANKING_SHIFT 0
#define MCDE_DSICMD2CONF0_BLANKING_MASK 0x000000FF
#define MCDE_DSICMD2CONF0_BLANKING(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2CONF0, BLANKING, __x)
#define MCDE_DSICMD2CONF0_VID_MODE_SHIFT 12
#define MCDE_DSICMD2CONF0_VID_MODE_MASK 0x00001000
#define MCDE_DSICMD2CONF0_VID_MODE_CMD 0
#define MCDE_DSICMD2CONF0_VID_MODE_VID 1
#define MCDE_DSICMD2CONF0_VID_MODE_ENUM(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2CONF0, VID_MODE, \
	MCDE_DSICMD2CONF0_VID_MODE_##__x)
#define MCDE_DSICMD2CONF0_VID_MODE(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2CONF0, VID_MODE, __x)
#define MCDE_DSICMD2CONF0_CMD8_SHIFT 13
#define MCDE_DSICMD2CONF0_CMD8_MASK 0x00002000
#define MCDE_DSICMD2CONF0_CMD8(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2CONF0, CMD8, __x)
#define MCDE_DSICMD2CONF0_BIT_SWAP_SHIFT 16
#define MCDE_DSICMD2CONF0_BIT_SWAP_MASK 0x00010000
#define MCDE_DSICMD2CONF0_BIT_SWAP(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2CONF0, BIT_SWAP, __x)
#define MCDE_DSICMD2CONF0_BYTE_SWAP_SHIFT 17
#define MCDE_DSICMD2CONF0_BYTE_SWAP_MASK 0x00020000
#define MCDE_DSICMD2CONF0_BYTE_SWAP(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2CONF0, BYTE_SWAP, __x)
#define MCDE_DSICMD2CONF0_DCSVID_NOTGEN_SHIFT 18
#define MCDE_DSICMD2CONF0_DCSVID_NOTGEN_MASK 0x00040000
#define MCDE_DSICMD2CONF0_DCSVID_NOTGEN(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2CONF0, DCSVID_NOTGEN, __x)
#define MCDE_DSICMD2CONF0_PACKING_SHIFT 20
#define MCDE_DSICMD2CONF0_PACKING_MASK 0x00700000
#define MCDE_DSICMD2CONF0_PACKING_RGB565 0
#define MCDE_DSICMD2CONF0_PACKING_RGB666 1
#define MCDE_DSICMD2CONF0_PACKING_RGB888 2
#define MCDE_DSICMD2CONF0_PACKING_BGR888 3
#define MCDE_DSICMD2CONF0_PACKING_HDTV 4
#define MCDE_DSICMD2CONF0_PACKING_ENUM(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2CONF0, PACKING, \
	MCDE_DSICMD2CONF0_PACKING_##__x)
#define MCDE_DSICMD2CONF0_PACKING(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2CONF0, PACKING, __x)
#define MCDE_DSIVID0FRAME 0x00000E04
#define MCDE_DSIVID0FRAME_GROUPOFFSET 0x20
#define MCDE_DSIVID0FRAME_FRAME_SHIFT 0
#define MCDE_DSIVID0FRAME_FRAME_MASK 0x00FFFFFF
#define MCDE_DSIVID0FRAME_FRAME(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0FRAME, FRAME, __x)
#define MCDE_DSICMD0FRAME 0x00000E24
#define MCDE_DSICMD0FRAME_FRAME_SHIFT 0
#define MCDE_DSICMD0FRAME_FRAME_MASK 0x00FFFFFF
#define MCDE_DSICMD0FRAME_FRAME(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0FRAME, FRAME, __x)
#define MCDE_DSIVID1FRAME 0x00000E44
#define MCDE_DSIVID1FRAME_FRAME_SHIFT 0
#define MCDE_DSIVID1FRAME_FRAME_MASK 0x00FFFFFF
#define MCDE_DSIVID1FRAME_FRAME(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1FRAME, FRAME, __x)
#define MCDE_DSICMD1FRAME 0x00000E64
#define MCDE_DSICMD1FRAME_FRAME_SHIFT 0
#define MCDE_DSICMD1FRAME_FRAME_MASK 0x00FFFFFF
#define MCDE_DSICMD1FRAME_FRAME(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1FRAME, FRAME, __x)
#define MCDE_DSIVID2FRAME 0x00000E84
#define MCDE_DSIVID2FRAME_FRAME_SHIFT 0
#define MCDE_DSIVID2FRAME_FRAME_MASK 0x00FFFFFF
#define MCDE_DSIVID2FRAME_FRAME(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2FRAME, FRAME, __x)
#define MCDE_DSICMD2FRAME 0x00000EA4
#define MCDE_DSICMD2FRAME_FRAME_SHIFT 0
#define MCDE_DSICMD2FRAME_FRAME_MASK 0x00FFFFFF
#define MCDE_DSICMD2FRAME_FRAME(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2FRAME, FRAME, __x)
#define MCDE_DSIVID0PKT 0x00000E08
#define MCDE_DSIVID0PKT_GROUPOFFSET 0x20
#define MCDE_DSIVID0PKT_PACKET_SHIFT 0
#define MCDE_DSIVID0PKT_PACKET_MASK 0x0000FFFF
#define MCDE_DSIVID0PKT_PACKET(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0PKT, PACKET, __x)
#define MCDE_DSICMD0PKT 0x00000E28
#define MCDE_DSICMD0PKT_PACKET_SHIFT 0
#define MCDE_DSICMD0PKT_PACKET_MASK 0x0000FFFF
#define MCDE_DSICMD0PKT_PACKET(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0PKT, PACKET, __x)
#define MCDE_DSIVID1PKT 0x00000E48
#define MCDE_DSIVID1PKT_PACKET_SHIFT 0
#define MCDE_DSIVID1PKT_PACKET_MASK 0x0000FFFF
#define MCDE_DSIVID1PKT_PACKET(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1PKT, PACKET, __x)
#define MCDE_DSICMD1PKT 0x00000E68
#define MCDE_DSICMD1PKT_PACKET_SHIFT 0
#define MCDE_DSICMD1PKT_PACKET_MASK 0x0000FFFF
#define MCDE_DSICMD1PKT_PACKET(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1PKT, PACKET, __x)
#define MCDE_DSIVID2PKT 0x00000E88
#define MCDE_DSIVID2PKT_PACKET_SHIFT 0
#define MCDE_DSIVID2PKT_PACKET_MASK 0x0000FFFF
#define MCDE_DSIVID2PKT_PACKET(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2PKT, PACKET, __x)
#define MCDE_DSICMD2PKT 0x00000EA8
#define MCDE_DSICMD2PKT_PACKET_SHIFT 0
#define MCDE_DSICMD2PKT_PACKET_MASK 0x0000FFFF
#define MCDE_DSICMD2PKT_PACKET(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2PKT, PACKET, __x)
#define MCDE_DSIVID0SYNC 0x00000E0C
#define MCDE_DSIVID0SYNC_GROUPOFFSET 0x20
#define MCDE_DSIVID0SYNC_DMA_SHIFT 0
#define MCDE_DSIVID0SYNC_DMA_MASK 0x00000FFF
#define MCDE_DSIVID0SYNC_DMA(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0SYNC, DMA, __x)
#define MCDE_DSIVID0SYNC_SW_SHIFT 16
#define MCDE_DSIVID0SYNC_SW_MASK 0x0FFF0000
#define MCDE_DSIVID0SYNC_SW(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0SYNC, SW, __x)
#define MCDE_DSICMD0SYNC 0x00000E2C
#define MCDE_DSICMD0SYNC_DMA_SHIFT 0
#define MCDE_DSICMD0SYNC_DMA_MASK 0x00000FFF
#define MCDE_DSICMD0SYNC_DMA(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0SYNC, DMA, __x)
#define MCDE_DSICMD0SYNC_SW_SHIFT 16
#define MCDE_DSICMD0SYNC_SW_MASK 0x0FFF0000
#define MCDE_DSICMD0SYNC_SW(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0SYNC, SW, __x)
#define MCDE_DSIVID1SYNC 0x00000E4C
#define MCDE_DSIVID1SYNC_DMA_SHIFT 0
#define MCDE_DSIVID1SYNC_DMA_MASK 0x00000FFF
#define MCDE_DSIVID1SYNC_DMA(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1SYNC, DMA, __x)
#define MCDE_DSIVID1SYNC_SW_SHIFT 16
#define MCDE_DSIVID1SYNC_SW_MASK 0x0FFF0000
#define MCDE_DSIVID1SYNC_SW(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1SYNC, SW, __x)
#define MCDE_DSICMD1SYNC 0x00000E6C
#define MCDE_DSICMD1SYNC_DMA_SHIFT 0
#define MCDE_DSICMD1SYNC_DMA_MASK 0x00000FFF
#define MCDE_DSICMD1SYNC_DMA(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1SYNC, DMA, __x)
#define MCDE_DSICMD1SYNC_SW_SHIFT 16
#define MCDE_DSICMD1SYNC_SW_MASK 0x0FFF0000
#define MCDE_DSICMD1SYNC_SW(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1SYNC, SW, __x)
#define MCDE_DSIVID2SYNC 0x00000E8C
#define MCDE_DSIVID2SYNC_DMA_SHIFT 0
#define MCDE_DSIVID2SYNC_DMA_MASK 0x00000FFF
#define MCDE_DSIVID2SYNC_DMA(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2SYNC, DMA, __x)
#define MCDE_DSIVID2SYNC_SW_SHIFT 16
#define MCDE_DSIVID2SYNC_SW_MASK 0x0FFF0000
#define MCDE_DSIVID2SYNC_SW(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2SYNC, SW, __x)
#define MCDE_DSICMD2SYNC 0x00000EAC
#define MCDE_DSICMD2SYNC_DMA_SHIFT 0
#define MCDE_DSICMD2SYNC_DMA_MASK 0x00000FFF
#define MCDE_DSICMD2SYNC_DMA(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2SYNC, DMA, __x)
#define MCDE_DSICMD2SYNC_SW_SHIFT 16
#define MCDE_DSICMD2SYNC_SW_MASK 0x0FFF0000
#define MCDE_DSICMD2SYNC_SW(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2SYNC, SW, __x)
#define MCDE_DSIVID0CMDW 0x00000E10
#define MCDE_DSIVID0CMDW_GROUPOFFSET 0x20
#define MCDE_DSIVID0CMDW_CMDW_CONTINUE_SHIFT 0
#define MCDE_DSIVID0CMDW_CMDW_CONTINUE_MASK 0x0000FFFF
#define MCDE_DSIVID0CMDW_CMDW_CONTINUE(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0CMDW, CMDW_CONTINUE, __x)
#define MCDE_DSIVID0CMDW_CMDW_START_SHIFT 16
#define MCDE_DSIVID0CMDW_CMDW_START_MASK 0xFFFF0000
#define MCDE_DSIVID0CMDW_CMDW_START(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0CMDW, CMDW_START, __x)
#define MCDE_DSICMD0CMDW 0x00000E30
#define MCDE_DSICMD0CMDW_CMDW_CONTINUE_SHIFT 0
#define MCDE_DSICMD0CMDW_CMDW_CONTINUE_MASK 0x0000FFFF
#define MCDE_DSICMD0CMDW_CMDW_CONTINUE(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0CMDW, CMDW_CONTINUE, __x)
#define MCDE_DSICMD0CMDW_CMDW_START_SHIFT 16
#define MCDE_DSICMD0CMDW_CMDW_START_MASK 0xFFFF0000
#define MCDE_DSICMD0CMDW_CMDW_START(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0CMDW, CMDW_START, __x)
#define MCDE_DSIVID1CMDW 0x00000E50
#define MCDE_DSIVID1CMDW_CMDW_CONTINUE_SHIFT 0
#define MCDE_DSIVID1CMDW_CMDW_CONTINUE_MASK 0x0000FFFF
#define MCDE_DSIVID1CMDW_CMDW_CONTINUE(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1CMDW, CMDW_CONTINUE, __x)
#define MCDE_DSIVID1CMDW_CMDW_START_SHIFT 16
#define MCDE_DSIVID1CMDW_CMDW_START_MASK 0xFFFF0000
#define MCDE_DSIVID1CMDW_CMDW_START(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1CMDW, CMDW_START, __x)
#define MCDE_DSICMD1CMDW 0x00000E70
#define MCDE_DSICMD1CMDW_CMDW_CONTINUE_SHIFT 0
#define MCDE_DSICMD1CMDW_CMDW_CONTINUE_MASK 0x0000FFFF
#define MCDE_DSICMD1CMDW_CMDW_CONTINUE(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1CMDW, CMDW_CONTINUE, __x)
#define MCDE_DSICMD1CMDW_CMDW_START_SHIFT 16
#define MCDE_DSICMD1CMDW_CMDW_START_MASK 0xFFFF0000
#define MCDE_DSICMD1CMDW_CMDW_START(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1CMDW, CMDW_START, __x)
#define MCDE_DSIVID2CMDW 0x00000E90
#define MCDE_DSIVID2CMDW_CMDW_CONTINUE_SHIFT 0
#define MCDE_DSIVID2CMDW_CMDW_CONTINUE_MASK 0x0000FFFF
#define MCDE_DSIVID2CMDW_CMDW_CONTINUE(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2CMDW, CMDW_CONTINUE, __x)
#define MCDE_DSIVID2CMDW_CMDW_START_SHIFT 16
#define MCDE_DSIVID2CMDW_CMDW_START_MASK 0xFFFF0000
#define MCDE_DSIVID2CMDW_CMDW_START(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2CMDW, CMDW_START, __x)
#define MCDE_DSICMD2CMDW 0x00000EB0
#define MCDE_DSICMD2CMDW_CMDW_CONTINUE_SHIFT 0
#define MCDE_DSICMD2CMDW_CMDW_CONTINUE_MASK 0x0000FFFF
#define MCDE_DSICMD2CMDW_CMDW_CONTINUE(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2CMDW, CMDW_CONTINUE, __x)
#define MCDE_DSICMD2CMDW_CMDW_START_SHIFT 16
#define MCDE_DSICMD2CMDW_CMDW_START_MASK 0xFFFF0000
#define MCDE_DSICMD2CMDW_CMDW_START(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2CMDW, CMDW_START, __x)
#define MCDE_DSIVID0DELAY0 0x00000E14
#define MCDE_DSIVID0DELAY0_GROUPOFFSET 0x20
#define MCDE_DSIVID0DELAY0_INTPKTDEL_SHIFT 0
#define MCDE_DSIVID0DELAY0_INTPKTDEL_MASK 0x0000FFFF
#define MCDE_DSIVID0DELAY0_INTPKTDEL(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0DELAY0, INTPKTDEL, __x)
#define MCDE_DSICMD0DELAY0 0x00000E34
#define MCDE_DSICMD0DELAY0_INTPKTDEL_SHIFT 0
#define MCDE_DSICMD0DELAY0_INTPKTDEL_MASK 0x0000FFFF
#define MCDE_DSICMD0DELAY0_INTPKTDEL(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0DELAY0, INTPKTDEL, __x)
#define MCDE_DSIVID1DELAY0 0x00000E54
#define MCDE_DSIVID1DELAY0_INTPKTDEL_SHIFT 0
#define MCDE_DSIVID1DELAY0_INTPKTDEL_MASK 0x0000FFFF
#define MCDE_DSIVID1DELAY0_INTPKTDEL(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1DELAY0, INTPKTDEL, __x)
#define MCDE_DSICMD1DELAY0 0x00000E74
#define MCDE_DSICMD1DELAY0_INTPKTDEL_SHIFT 0
#define MCDE_DSICMD1DELAY0_INTPKTDEL_MASK 0x0000FFFF
#define MCDE_DSICMD1DELAY0_INTPKTDEL(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1DELAY0, INTPKTDEL, __x)
#define MCDE_DSIVID2DELAY0 0x00000E94
#define MCDE_DSIVID2DELAY0_INTPKTDEL_SHIFT 0
#define MCDE_DSIVID2DELAY0_INTPKTDEL_MASK 0x0000FFFF
#define MCDE_DSIVID2DELAY0_INTPKTDEL(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2DELAY0, INTPKTDEL, __x)
#define MCDE_DSICMD2DELAY0 0x00000EB4
#define MCDE_DSICMD2DELAY0_INTPKTDEL_SHIFT 0
#define MCDE_DSICMD2DELAY0_INTPKTDEL_MASK 0x0000FFFF
#define MCDE_DSICMD2DELAY0_INTPKTDEL(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2DELAY0, INTPKTDEL, __x)
#define MCDE_DSIVID0DELAY1 0x00000E18
#define MCDE_DSIVID0DELAY1_GROUPOFFSET 0x20
#define MCDE_DSIVID0DELAY1_TEREQDEL_SHIFT 0
#define MCDE_DSIVID0DELAY1_TEREQDEL_MASK 0x00000FFF
#define MCDE_DSIVID0DELAY1_TEREQDEL(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0DELAY1, TEREQDEL, __x)
#define MCDE_DSIVID0DELAY1_FRAMESTARTDEL_SHIFT 16
#define MCDE_DSIVID0DELAY1_FRAMESTARTDEL_MASK 0x00FF0000
#define MCDE_DSIVID0DELAY1_FRAMESTARTDEL(__x) \
	MCDE_VAL2REG(MCDE_DSIVID0DELAY1, FRAMESTARTDEL, __x)
#define MCDE_DSICMD0DELAY1 0x00000E38
#define MCDE_DSICMD0DELAY1_TEREQDEL_SHIFT 0
#define MCDE_DSICMD0DELAY1_TEREQDEL_MASK 0x00000FFF
#define MCDE_DSICMD0DELAY1_TEREQDEL(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0DELAY1, TEREQDEL, __x)
#define MCDE_DSICMD0DELAY1_FRAMESTARTDEL_SHIFT 16
#define MCDE_DSICMD0DELAY1_FRAMESTARTDEL_MASK 0x00FF0000
#define MCDE_DSICMD0DELAY1_FRAMESTARTDEL(__x) \
	MCDE_VAL2REG(MCDE_DSICMD0DELAY1, FRAMESTARTDEL, __x)
#define MCDE_DSIVID1DELAY1 0x00000E58
#define MCDE_DSIVID1DELAY1_TEREQDEL_SHIFT 0
#define MCDE_DSIVID1DELAY1_TEREQDEL_MASK 0x00000FFF
#define MCDE_DSIVID1DELAY1_TEREQDEL(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1DELAY1, TEREQDEL, __x)
#define MCDE_DSIVID1DELAY1_FRAMESTARTDEL_SHIFT 16
#define MCDE_DSIVID1DELAY1_FRAMESTARTDEL_MASK 0x00FF0000
#define MCDE_DSIVID1DELAY1_FRAMESTARTDEL(__x) \
	MCDE_VAL2REG(MCDE_DSIVID1DELAY1, FRAMESTARTDEL, __x)
#define MCDE_DSICMD1DELAY1 0x00000E78
#define MCDE_DSICMD1DELAY1_TEREQDEL_SHIFT 0
#define MCDE_DSICMD1DELAY1_TEREQDEL_MASK 0x00000FFF
#define MCDE_DSICMD1DELAY1_TEREQDEL(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1DELAY1, TEREQDEL, __x)
#define MCDE_DSICMD1DELAY1_FRAMESTARTDEL_SHIFT 16
#define MCDE_DSICMD1DELAY1_FRAMESTARTDEL_MASK 0x00FF0000
#define MCDE_DSICMD1DELAY1_FRAMESTARTDEL(__x) \
	MCDE_VAL2REG(MCDE_DSICMD1DELAY1, FRAMESTARTDEL, __x)
#define MCDE_DSIVID2DELAY1 0x00000E98
#define MCDE_DSIVID2DELAY1_TEREQDEL_SHIFT 0
#define MCDE_DSIVID2DELAY1_TEREQDEL_MASK 0x00000FFF
#define MCDE_DSIVID2DELAY1_TEREQDEL(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2DELAY1, TEREQDEL, __x)
#define MCDE_DSIVID2DELAY1_FRAMESTARTDEL_SHIFT 16
#define MCDE_DSIVID2DELAY1_FRAMESTARTDEL_MASK 0x00FF0000
#define MCDE_DSIVID2DELAY1_FRAMESTARTDEL(__x) \
	MCDE_VAL2REG(MCDE_DSIVID2DELAY1, FRAMESTARTDEL, __x)
#define MCDE_DSICMD2DELAY1 0x00000EB8
#define MCDE_DSICMD2DELAY1_TEREQDEL_SHIFT 0
#define MCDE_DSICMD2DELAY1_TEREQDEL_MASK 0x00000FFF
#define MCDE_DSICMD2DELAY1_TEREQDEL(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2DELAY1, TEREQDEL, __x)
#define MCDE_DSICMD2DELAY1_FRAMESTARTDEL_SHIFT 16
#define MCDE_DSICMD2DELAY1_FRAMESTARTDEL_MASK 0x00FF0000
#define MCDE_DSICMD2DELAY1_FRAMESTARTDEL(__x) \
	MCDE_VAL2REG(MCDE_DSICMD2DELAY1, FRAMESTARTDEL, __x)
